#include <hush/source.h>
#include <vip.h>
#include <hush/session.h>
#include <hush/dv/scene/kit.h>
#include <hush/scene.h>
#include <dx/main/menu-media.h>
#include <dx/main/menu-present.h>
#include <dx/main/menu-dots.h>
#include <dx/main/menu-create.h>
#include <dx/main/menu-vip.h>
#include <dx/main/menu-tutorial.h>
#include <scene/lecture.h>
//#include <dx/lectures/lecture-imm.h>
//#include <dx/lectures/lecture-tutorial.h>


#include <objects/scene-text-3d.h>

#include "extra/object-dolphin.h"
#include "extra/object-spectrum.h"
#include "extra/object-water.h"

#include <scene/background.h>
#include <scene/shader.h>
//#include <scene/dossier.h>

#include <extra/object-flag.h>
#include <extra/object-dolphin.h>

#include <odyssee/scene-0.h>
#include <odyssee/scene-1.h>
#include <odyssee/scene-2.h>
#include <odyssee/scene-3.h>
#include <odyssee/scene-3x.h>

#include <extra/object-grab.h>




#include <hush/io.h>

//int IO::silent = 0;
//int _errno;
int errno = 0;

extern "C" {

int HUSH_API load_menu() {
	scene* sc = 0;
	//kit* x = new scene_kit();
	//scene::_main()->debug("menu load",1);
	sc = new object_flag();
	scene::declare("vip/flag",sc);
	//scene::_main()->debug("menu load 1",1);
	sc = new object_dolphin();
	sc->state = 1;
    scene::declare("object/dolphin",sc);
	sc = new object_dolphin();
	scene::declare("object/dolphin/0",sc);
	sc = new object_dolphin();
	scene::declare("object/dolphin/1",sc);
	//sc = new object_water();
	scene::declare("vip/water",new object_water());
	scene::declare("object/water",new object_water());
	scene::declare("object/spectrum",new object_spectrum());
	//sc = new background();
	scene::declare("grab/try",new object_grab());
	scene::declare("object/flag",new object_flag());
    scene::declare("background",new background());
	
	
	//sc = new vip_text(100);
	//scene::declare("text",sc);

	//scene::declare("logo/3d",new scene_text_3d());
	//scene::_main()->debug("menu load scenes",1);

	scene::declare("scene/0",new scene_0());
	scene::declare("scene/1",new scene_1());
	scene::declare("scene/2",new scene_2());
	scene::declare("scene/3",new scene_3());
	scene::declare("scene/4",new scene_3x());

	//scene::_main()->debug("menu load lectures",1);


	scene::declare("lecture/vip",new lecture("name=vip"));
	scene::declare("lecture/web3d",new lecture("name=web3d"));
	scene::declare("lecture/eca",new lecture("name=eca"));
	scene::declare("lecture/awc",new lecture("name=awc"));
	scene::declare("lecture/imm",new lecture("name=imm"));
	scene::declare("lecture/casus",new lecture("name=casus"));
	scene::declare("lecture/convergence",new lecture("name=convergence"));
	scene::declare("lecture/standards",new lecture("name=standards"));
	scene::declare("lecture/retrieval",new lecture("name=retrieval"));
	//scene::declare("lecture/environments",new lecture("text=environments"));
	scene::declare("lecture/tam",new lecture("name=tam"));
	scene::declare("lecture/design",new lecture("name=design"));
	scene::declare("lecture/party",new lecture("name=party"));
	scene::declare("lecture",new lecture());
	scene::declare("lecture/create/announce",new lecture("name=create slides=slides/create/announce"));
	scene::declare("lecture/create/inspire",new lecture("name=create slides=slides/create/aesthetics"));
	scene::declare("lecture/create/aesthetics",new lecture("name=create slides=slides/create/inspire"));
	scene::declare("lecture/create/game",new lecture("name=create slides=slides/create/game"));
	
	//sc = new lecture_tutorial();
	//scene::declare("lecture/tutorial",sc);

	//scene::_main()->debug("menu load menus",1);

    //scene::declare("vip/dossier",new dossier());

	// ae/sebas
    sc = new menu_tutorial();
	scene::declare("menu/tutorial",sc);
	//scene::_main()->debug("menu load menus tut",1);
	sc = new menu_media();
	scene::declare("menu/media",sc);
	//scene::_main()->debug("menu load menus media",1);
	sc = new menu_present();
	scene::declare("menu/present",sc);
	//scene::_main()->debug("menu load menus present",1);
	
	sc = new menu_dots();
	scene::declare("menu/dots",sc);
	//scene::_main()->debug("menu load menus dots",1);

	sc = new menu_create();
	scene::declare("menu/create",sc);

	sc = new menu_vip();
	scene::declare("menu/vip",sc);
	//scene::_main()->debug("menu load menus vip",1);

	
	
	
	//sc = new background_scene();
    //scene::declare("background",sc);
	//if (session::get_default())
	//	session::get_default()->_register(x);
	//kit::declare("scene",x);
	//scene::_main()->debug("menu loaded",1);
	//if (session::_trace)
		cerr << "Loading (vip) menu " << endl;
	return 1;
	}

};
