#include <hush/source.h>
#include <hush/session.h>
#include <hush/dv/scene/kit.h>
#include <hush/scene.h>
#include <dx/shader/shader.h>
#include <dx/shader/sm.h>
#include <dx/shader/face.h>
#include <dx/shader/mesh.h>
#include <dx/shader/actor.h>
#include <dx/shader/morph.h>

#include <hush/io.h>


static int initialized = 0;


extern "C" {

int HUSH_API load_shader() {

	
	if (initialized) return 1;
	initialized = 1;
	scene* sc;

	sc = new vip_mesh();
	scene::declare("vip/mesh",sc);
	

	sc = new vip_face();
	scene::declare("vip/face",sc);
	

	sc = new vip_actor();
	scene::declare("vip/actor",sc);
	

	
	sc = new vip_sm();
	scene::declare("vip/sm",sc);
	

	sc = new vip_morph();
	scene::declare("vip/morph",sc);
	//scene::declare("vip/morph",sc);
	
	
	//if (session::_trace)
		cerr << "Loading (vip) shader " << endl;
	return 1;
	}

};
