#include <hush/source.h>
#include <hush/session.h>
#include <hush/dv/scene/kit.h>
#include <hush/scene.h>
#include <scene/slides.h>
#include <dx/text/text.h>
#include <dx/text/vip.h>
#include <dx/text/imm.h>
#include <dx/text/eca.h>
#include <dx/text/awc.h>
#include <dx/text/roundup.h>
#include <dx/text/web3d.h>
#include <dx/text/casus.h>
#include <dx/text/convergence.h>
#include <dx/text/standards.h>
#include <dx/text/retrieval.h>
#include <dx/text/tam.h>
#include <dx/text/help.h>
#include <dx/text/design.h>
#include <dx/text/create.h>
#include <dx/text/sebas.h>
#include <dx/text/xtext.h>



#include <hush/io.h>


static int initialized = 0;


extern "C" {

int HUSH_API load_text() {

	
	if (initialized) return 1;
	initialized = 1;

	
	scene* sc = new vip_text(100);
	scene::declare("text",sc);
	scene::declare("text/vip",new text_vip());
	scene::declare("text/eca",new text_eca());
	scene::declare("text/awc",new text_awc());
	scene::declare("text/imm",new text_imm());
	scene::declare("text/roundup",new text_roundup());
	scene::declare("alt/text/roundup",new text_roundup());
	scene::declare("text/web3d",new text_web3d());
	scene::declare("text/casus",new text_casus());
	scene::declare("text/convergence",new text_convergence());
	scene::declare("text/standards",new text_standards());
	scene::declare("text/retrieval",new text_retrieval());
	scene::declare("text/tam",new text_tam());
	scene::declare("text/help",new text_help());
	scene::declare("text/design",new text_design());
	scene::declare("text/create",new text_create());
	scene::declare("alt/text/design",new text_design());
	scene::declare("alt/text/create",new text_create());
	scene::declare("text/party",new text_sebas());

	//scene::declare("generic/text",new generic_text());
	scene::declare("text",new generic_text());
	scene::declare("xtext",new generic_text());

	

	
	//if (session::_trace)
		cerr << "Loading (vip) text " << endl;
	return 1;
	}

};
