// HelloServer.cpp : Simple XMLRPC server example. Usage: HelloServer serverPort
//

#include <vip.h>

#include "xmlrpc/XmlRpc.h"



#include <iostream>
#include <stdlib.h>

using namespace XmlRpc;

// The server
XmlRpcServer s;

// No arguments, result is "Hello".
class Hello : public XmlRpcServerMethod
{
public:
  Hello(XmlRpcServer* s) : XmlRpcServerMethod("Hello", s) {}

  void execute(XmlRpcValue& params, XmlRpcValue& result)
  {
    result = "Hello";
	scene::_main()->eq("xmlrpc","hello");
  }

  std::string help() { return std::string("Say hello"); }

} hello(&s);    // This constructor registers the method with the server


// One argument is passed, result is "Hello, " + arg.
class HelloName : public XmlRpcServerMethod
{
public:
  HelloName(XmlRpcServer* s) : XmlRpcServerMethod("HelloName", s) {}

  void execute(XmlRpcValue& params, XmlRpcValue& result)
  {
    std::string resultString = "Hello, ";
    resultString += std::string(params[0]);
    result = resultString;
	scene::_main()->eq("xmlrpc","hello name");
  }
} helloName(&s);


// A variable number of arguments are passed, all doubles, result is their sum.
class Sum : public XmlRpcServerMethod
{
public:
  Sum(XmlRpcServer* s) : XmlRpcServerMethod("Sum", s) {}

  void execute(XmlRpcValue& params, XmlRpcValue& result)
  {
    int nArgs = params.size();
    double sum = 0.0;
    for (int i=0; i<nArgs; ++i)
      sum += double(params[i]);
    result = sum;
	scene::_main()->eq("xmlrpc","sum");
  }
} sum(&s);


int rpc_start()
{
  
  int port = 9000; //atoi(argv[1]);

  scene::_main()->eq("xmlrpc","listen");

  XmlRpc::setVerbosity(5);

  // Create the server socket on the specified port
  s.bindAndListen(port);

  // Enable introspection
  s.enableIntrospection(true);

  // Wait for requests indefinitely
  //s.work(-1.0);
  s.work(0.01);

  return 0;
}

static int xtime = 0;
int rpc_listen()
{
	xtime++;
	s.work(0.02);
	char buf[512];
	sprintf(buf,"[%d]",xtime);
	//scene::_main()->eq("xmlrpc:no",buf);
	return xtime; 
}
  
