
#include "object-grab.h"
#include <atlbase.h>

//#include <util/ARFrameGrabber.h>
#include "scene/slides.h"
//#include "extra/object-flag.h"
#include "scene/image.h"
#include <AR/ar.h>
#include <AR/gsub.h>

#include "scene/video.h"


IDirect3DTexture9* globaltex = 0;

extern "C" {
//#include "irender.h"
#include "util/vrml-object.h"
#include <AR/vrml97.h>
}

char            *model_name = "d:/vip/bin/Data/vip_data";
ObjectData_T    *object;
int             objectnum;

static char            *vconf = "";
static int             xsize, ysize;
static int             thresh = 100;
static int             count = 0;

static char           *cparam_name    = "d:/vip/bin/Data/camera_para.dat";
static ARParam         cparam;

static char           *patt_name      = "d:/vip/bin/Data/patt.kanji";
static char           *patt_name1      = "d:/vip/bin/Data/patt.hiro";
static int             patt_id;
static int             patt_id1;
static int             patt_width     = 80.0;
static double          patt_center[2] = {0.0, 0.0};
static double          patt_trans[3][4];

static int multiple = 1;

//static ARFrameGrabber* camera;


	//start the video capture
	

int object_grab::handle(char* type, char* ev) {

	if (0) {
	} else return scene::handle(type,ev);
	sprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}




object_grab::object_grab() {


		ARParam  wparam;

    /* Note: the video image captured is hard coded to 320x240 */
	xsize = 320; ysize = 240;
   // printf("Image size (x,y) = (%d,%d)\n", xsize, ysize);



 

    /* set the initial camera parameters */
    if( arParamLoad(cparam_name, 1, &wparam) < 0 ) {
        printf("Camera parameter load error !!\n");
        exit(0);
    }
    arParamChangeSize( &wparam, xsize, ysize, &cparam );
    arInitCparam( &cparam );
    printf("*** Camera Parameter ***\n");
    arParamDisp( &cparam );

	if (!multiple) {
    if( (patt_id=arLoadPatt(patt_name)) < 0 ) {
        printf("pattern load error !!\n");
        exit(0);
	} 
	} else {

		
	/* load in the object data - trained markers and associated bitmap files */
    if( (object=read_VRMLdata(model_name, &objectnum)) == NULL ) exit(0);
    printf("Objectfile num = %d\n", objectnum);
    
	}

	
    //camera = new ARFrameGrabber();
	//camera->Init(0);
	//camera.DisplayProperties();
	//camera.SetFlippedImage(true);
    

    count = 12;
	scenes[0] = new image();
	scenes[0]->translation(0.0f,1.2f,0.0f);
    scenes[0]->scale(0.8f,0.8f,0.8f);

	_exclude[0] = 1;
	scenes[1] = new slides("soutine.jpg");
	_exclude[1] = 1;
	scenes[1]->loop = true;

	//scenes[3] = new object_dolphin();
	_exclude[3] = 1;
	_exclude[4] = 1;

	//scenes[4] = new scene_2();
/*	
    scene* x;
    x = new object_flag();
    //x->rotation(0,1,0,0.5 * 3.14);
    x->scale(2.3,0.9,0.5);
    x->translation(0,-16.2,10); // no op
	scenes[2] = x;
	_exclude[2] = 1;
*/
  }


object_grab::~object_grab()
{
//delete scenes[];
}

HRESULT 
object_grab::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

	//static int once = 0;
	//if (_once != 0) return hr;
	_once++;

	//_scene = new video();

    //scenes[2]->rectangle(_scene->_tu,_scene->_tv);
    /*
	scenes[1]->rectangle(_main()->_scene->_tu,_main()->_scene->_tv);
	scenes[0]->rectangle(_main()->_scene->_tu,_main()->_scene->_tv);
	scenes[4]->rectangle(_main()->_scene->_tu,_main()->_scene->_tv);
	*/
	 
    

	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
object_grab::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
   // Setup render states
 

    return hr;
}


HRESULT object_grab::compose(IDirect3DDevice9* device,DWORD t) {
	//return S_OK;
	
    return S_OK;
}


HRESULT 
object_grab::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

   // check_cs();
   // CAutoLock lock(_cs);
    _captures(2, texture);
    scene::_project((_active() % 3));

   ARUint8         *dataPtr;
    ARMarkerInfo    *marker_info;
    int             marker_num;
    int             j, k;
	ARParam        xparam;

		_width = 320;
	_height = 240;

	arParamChangeSize( &cparam, _width, _height, &xparam );



 void* x = 0;
 //x = camera->GetBuffer();
 _exclude[1] = 1;
 
    int ff = 0;
    _texture = texture;
	ff = get_buffer();
	//_buffer = _parent->_buffer;
	dataPtr = (ARUint8 *) _buffer;



k = -2;
     
if (_buffer && multiple) {

	 if( arDetectMarker(dataPtr, thresh, &marker_info, &marker_num) < 0 ) {
        //cleanup();
        exit(0);
	 } else {
      
     int i;
	 for( i = 0; i < objectnum; i++ ) {
        k = -1;
        for( j = 0; j < marker_num; j++ ) {

            if( object[i].id == marker_info[j].id ) {
                if( k == -1 ) k = j;
                else {
                    if( marker_info[k].cf < marker_info[j].cf ) k = j;
                }
            }
		}
        if( k == -1 ) {
            object[i].visible = 0;
            continue;
        }

        if( object[i].visible == 0 ) {
            arGetTransMat(&marker_info[k],
                          object[i].marker_center, object[i].marker_width,
                          object[i].trans);
        }
        else {
            arGetTransMatCont(&marker_info[k], object[i].trans,
                          object[i].marker_center, object[i].marker_width,
                          object[i].trans);
        }
        object[i].visible = 1;
    }

} // detect multiple 
   } else if (_buffer) {

	
	if( arDetectMarker(dataPtr, thresh, &marker_info, &marker_num) < 0 ) {
        //cleanup();
        //exit(0);
	 } else {

    // check for object visibility 
    k = -1;
    for( j = 0; j < marker_num; j++ ) {
        if( patt_id == marker_info[j].id ) {
            if( k == -1 ) k = j;
            else if( marker_info[k].cf < marker_info[j].cf ) k = j;
        }
    }
    if( k == -1 ) {
       
	} else {

    // get the transformation between the marker and the real camera 
    arGetTransMat(&marker_info[k], patt_center, patt_width, patt_trans);
	}
	}
	}
   if (1) {
   _exclude[0] = 1;
   //_exclude[2] = 0;
   _exclude[3] = 1;
   _exclude[4] = 1;

   } else {
 //_exclude[0] = 0;
 _exclude[1] = 1;
   _exclude[2] = 0;
   _exclude[3] = 0;
   }

 //  argDrawMode3D();
 // argDraw3dCamera( 0, 0 );

	render_begin(device);
	   device->SetTexture( 0, texture );
	  
	   int active = -1;
	   if (_buffer && multiple) {
	   if (object[0].visible) { _exclude[4] = 0; active = 0; }
	   if (object[1].visible) { _exclude[3] = 0; _exclude[0] = 0; active = 1; }
	   }

	 //  scenes[1]->_texture = _captures[0];//(scene::_main)->_texture;
	 //  scenes[0]->_texture = _captures[0];//(scene::_main)->_texture;
	   

	   //scenes[0]->_texture = scene::_main->_scene->_texture;
	 //scenes[0]->_texture = globaltex; //scene::_video->_texture;
	   //scenes[1]->_texture = _texture;
	   scenes[2]->_texture = texture;
	   //scenes[3]->_texture = texture;
       //scenes[4]->_texture = texture;
	   _texture = _captures(0);

	hr = scene::render(device,_texture); // calls compose, restore,  render

    //  device->SetVertexShader(0 );
    
    //_selection = 0;

	if (_buffer) {
		char buf[512];
		int length = sizeof((char*) _buffer);
		if (multiple)
		sprintf(buf,"grab: %d  [%d,%d] (%d) %d/%d",objectnum, object[0].visible, object[1].visible,_format,_project,_active);
		else
        sprintf(buf,"grab: %d ",k);

		scene::_plain()->message(_x-_tab*0,_y,argb(133,255,255,255),buf);
		
		
		
		if (k != -1 || active !=-1 ) {
			int i = active;
			double t[3][4];
			for (int k = 0; k < 3; k++)
				for (int m = 0; m < 4; m++)
                    //t[k][m] = xparam.mat[k][m];
					t[k][m] = multiple?object[i].trans[k][m]:patt_trans[k][m];
			int width = multiple?object[i].marker_width:patt_width;
			double* center = multiple?object[i].marker_center:patt_center;


        sprintf(buf,"%d: %d (%d,%d) ", i, width, center[0], center[1]);
		scene::_plain()->message(_x-_tab*0,_y+25*2,argb(133,255,255,255),buf);
		sprintf(buf,"[%f,%f,%f,%f] ",  t[0,0],t[0,1],t[0,2],t[0,3]);
		scene::_plain()->message(_x-_tab*0,_y+25*3,argb(133,255,255,255),buf);
		sprintf(buf,"[%f,%f,%f,%f] ",  t[1,0],t[0,1],t[0,2],t[0,3]);
		scene::_plain()->message(_x-_tab*0,_y+25*4,argb(133,255,255,255),buf);
		sprintf(buf,"[%f,%f,%f,%f] ",  t[2,0],t[0,1],t[0,2],t[0,3]);
		scene::_plain()->message(_x-_tab*0,_y+25*5,argb(133,255,255,255),buf);
		}
	} else {
		char buf[512];
		sprintf(buf,"empty: %d (%d)",_format,ff);
		scene::_plain()->message(_x-_tab*1,_y,argb(133,255,255,255),buf);
	}
	render_end(device);

 

    return hr;
}

