#include <hush/source.h>

#include "panorama.h"
#include <scene/mesh.h>
#include <scene/shader.h>
#include <scene/background.h>
#include <scene/video.h>
#include "object-grab.h"

//#include <streams.h>
#include <scene/satelite.h>
#include <hush/scanner.h>

#include <hush/sim/sim.h>


static char* _help = "panorama";




int vip_panorama::handle(char* type, char* ev) {
	if (check(type,ev,"amico","down")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
		}
	} else if (check(type,ev,"amico","a")) {
	} else 	return dossier::handle(type,ev);
}



int vip_panorama::operator()()
{
  
return dossier::operator ()();
//state = random(0,2);

_sim->passivate(this);
float t = 5.0;
 
_sim->schedule(this,_gn->exponential(t));
return 0;
 
  
}

vip_panorama::vip_panorama(char* opts) 
{
	
	count = 12;
	//state = 2;

	ch();

_size = 20; //size;
wsprintf(_type,"dossier");
_display = _type;

_sim->passivate(this);
_sim -> schedule(this,20.0);


end(20);
loop = 1;


}




vip_panorama::~vip_panorama()
{
//delete scenes[];
}

int 
vip_panorama::_load()
{
    int hr = S_OK;

	//scenes[2] = new video( new object_grab());
	//_exclude[2] = 0;

	opt("text:head:x","panorama field test");
	opt("text:scroll:1:x","panorama test panorama test");
	//opt("text:scroll:2","self reflections panorama casual encounters panorama self reflections panorama casual encounters panorama");
	opt("text:scroll:2:x","self reflections panorama casual encounters panorama"); // self reflections panorama casual encounters panorama");

	hr = dossier::_load(); // loops through scenes	

	
    
	if (0) {
	scene* _sc = lst("slides/panorama/persons");
	if (_sc) {
		_sc->propagate("hide=1");
		_sc->exclude(0);
		ds(fm("movie:%d",7),7);
		_sc->iopt("ds",7);
	}

	 _sc = lst("slides/panorama/things");
	if (_sc) {
		_sc->propagate("hide=1");
		_sc->exclude(0);
		ds(fm("movie:%d",2),2);
		_sc->iopt("ds",2);
	}

	 _sc = lst("slides/panorama/places");
	if (_sc) {
		_sc->propagate("hide=1");
		_sc->exclude(0);
		ds(fm("movie:%d",9),9);
		_sc->iopt("ds",9);
	}

	_sc = lst("slides/panorama/media");
	if (_sc && 0) {
		_sc->propagate("hide=1");
		_sc->exclude(0);
		ds(fm("movie:%d",9),9);
		_sc->iopt("ds",9);
	}
	}

	_a = 255; 
    _r = _g = _b = 125;
	_hx = 800;
    _hy = 350;
	_ksx = 1024;
    _sx = _ksx;
    _sy = 550;
	_si = iopt("speed:1"); //4;

	
    _ssx = _ksx;
    _ssy = 600;
	_ssi = iopt("speed:2"); //7;

	_once =1;

	opt("text:head:x",unquote(opt("text:head")));
	opt("text:scroll:1:x",unquote(opt("text:scroll:1")));
	//opt("text:scroll:2","self reflections panorama 
	opt("text:scroll:2:x",unquote(opt("text:scroll:2"))); 

	opt("text:head",opt("text:head:x"));
	opt("text:scroll:1",opt("text:scroll:1:x"));
	opt("text:scroll:2",opt("text:scroll:2:x"));

	
	return hr;
}

int
vip_panorama::_restore()
{
    int hr = dossier::_restore(); // loops through scenes	

	if (0) {	
	lst("slides/panorama/persons")->exclude(0);
	//lst("slides/panorama/persons")->propagate("hide=1");
	lst("slides/panorama/things")->exclude(0);
	//lst("slides/panorama/things")->propagate("hide=1");
    //ds("walk:speed",30);
	lst("slides/panorama/places")->exclude(0);
	//lst("slides/panorama/media")->exclude(0);
	//lst("slides/panorama/media")->propagate("hide=1");
	}
	
	return hr;
}


int
vip_panorama::_render( ) 
{
HRESULT hr = S_OK;

if (iopt("update")) {
	opt("update","0");
	switch (state) {
		case 0:
		
			exec("n:ran:p4:bgmhfw:3c:z");
			ds("walk:speed",30);
			break;;
		case 1:
			exec("n:ran:p3:b0lwc:z");
			cm("bgcolor","(0,0,20)");
			ds("walk:speed",30);
			break;;

		case 2:
			exec("n:ran:b0glwc:p45:z");
			cm("bgcolor","(0,20,20)");
			ds("walk:speed",50);
			break;;
	
		case 3:
			exec("n:ran:brlwc:p1234567:z");
			cm("bgcolor","(30,0,0)");
			ds("walk:speed",100);
			break;;
		case 4:
			exec("n:ran:b0lwc:p123467:z");
			ds("walk:speed",100);
			break;;
		case 5:
			exec("n:ran:bclw:z");
			this->interval(now(),150);
			loop = 0;
			break;;
		default:
			exec("n:ran:b0lwc:p1234567:z");
			ds("walk:speed",50);
			break;;
	}

}

	if (state == 5) {
		float f = fraction();
		if (f > 0.1) lst("particles/1")->exclude(0);
		if (f > 0.2) lst("particles/2")->exclude(0);
		if (f > 0.3) lst("particles/4")->exclude(0);
		if (f > 0.4) lst("particles/3")->exclude(0);
		if (f > 0.5) lst("particles/6")->exclude(0);
		if (f > 0.6) lst("particles/5")->exclude(0);
		/*
		if (f > 0.7) lst("particles/3")->exclude(1);
		if (f > 0.8) lst("particles/5")->exclude(1);
		if (f > 0.9) lst("particles/2")->exclude(1);
		if (f > 0.95) lst("particles/1")->exclude(1);
		if (f > 0.95) lst("particles/4")->exclude(1);
		if (f > 0.95) lst("particles/6")->exclude(1);
		*/
		if (f < 5.0)
		opt("bgcolor", fm("(%d,%d,%d)", int(f * 50.0),0,int(30.0 * (1.1-f))));
		else 
		opt("bgcolor", fm("(%d,%d,%d)", int(50.0 - f * 50.0),0,0));
		
		cm("bgcolor",opt("bgcolor"));
		
		ds("walk:speed", int(10 + 200.0 * f));
	}


    

	



hr = dossier::_render(); // loops through scenes	

if (_once) {
    _once = 0;
    //ds("walk:speed",30);
	lst("particles/5")->exclude(1);
	lst("particles/5")->iopt("tx",10);
	lst("particles/4")->exclude(1);
	lst("particles/4")->iopt("tx",2);
	lst("particles/6")->exclude(1);
	lst("particles/6")->iopt("tx",9);
	ds("shift:10",1);
	ds("10",0);
	//ds("shift:11",1);
	//ds("11",0);
	//ds("shift:12",1);
	//ds("12",0);
	ds("total",9);


	lst("slides/panorama/persons")->propagate("hide=1");
	lst("slides/panorama/things")->propagate("hide=1");
	lst("slides/panorama/places")->propagate("hide=1");
	//lst("slides/panorama/media")->propagate("hide=1");
	}




if (0) {


	_small()->message(_hx,_hy,argb(_a,_r+20,_g,_b), opt("text:head"));
	_large()->message(_sx,_sy,argb(_a,_r+80,_g+100,_b+100), opt("text:scroll:1"));
	_plain()->message(_ssx,_ssy,argb(_a,_r+120,_g+50,_b+50), opt("text:scroll:2"));

int _kx = 0;
int _ls1 = strlen(opt("text:scroll:1")) * 23;
_sx -= _si; 
_kx = _sx + _ls1;
while (_kx < _ksx) { 
	//_large()->message(_kx,_sy,argb(_a,_r+50,_g,_b), opt("text:scroll:1"));
	_large()->message(_kx,_sy,argb(_a,_r+60,_g+80,_b+80), opt("text:scroll:1:x"));
	_kx += _ls1;
     }
if (_sx < -_ls1) _sx = 0;

int _ls2 = strlen(opt("text:scroll:2")) * 16;
_ssx -= _ssi; 
_kx = _ssx + _ls2;
while (_kx < _ksx) { 
	//_plain()->message(_kx,_ssy,argb(_a,_r+50,_g+50,_b+50), opt("text:scroll:2"));
	_plain()->message(_kx,_ssy,argb(_a,_r+100,_g+40,_b+40), opt("text:scroll:2:x"));
	_kx += _ls2;
     }
if (_ssx < -_ls2) _ssx = 0;
}


return hr;

}

