
#ifndef object_dolphin_h
#define object_dolphin_h
#include <hush/export.h>

#include "scene/scene.h"
#include "common90/d3d-util.h"





class  object_dolphin : public scene  
{
public:

    object_dolphin(char* opts = 0);

	scene* create(char* opts = 0);
	
    virtual ~object_dolphin();
    virtual HRESULT init(IDirect3DDevice9* device);
	virtual HRESULT restore(IDirect3DDevice9* device);
	virtual HRESULT compose(IDirect3DDevice9* device, DWORD t);
    

    virtual HRESULT render(  IDirect3DDevice9* device,
                        IDirect3DTexture9* texture );

	
	int handle(char* type, char* ev);

	//#define WATER_COLOR         0x00004080
	#define WATER_COLOR         0x00004080
	//#define WATER_COLOR         D3DCOLOR_ARGB(180,10,125,125)
struct D3DVERTEX
{
    D3DXVECTOR3 p;
    D3DXVECTOR3 n;
    FLOAT       tu, tv;

    static const DWORD FVF;
};

protected:
     // Font for drawing text
    //CD3DFont* m_pFont;

    // Transform matrices
    D3DXMATRIXA16              m_matWorld;
    D3DXMATRIXA16              m_matView;
    D3DXMATRIXA16              m_matProj;

    // Dolphin object
    LPDIRECT3DTEXTURE9      m_pDolphinTexture;
    LPDIRECT3DVERTEXBUFFER9 m_pDolphinVB1;
    LPDIRECT3DVERTEXBUFFER9 m_pDolphinVB2;
    LPDIRECT3DVERTEXBUFFER9 m_pDolphinVB3;
    LPDIRECT3DINDEXBUFFER9  m_pDolphinIB;
    DWORD                   m_dwNumDolphinVertices;
    DWORD                   m_dwNumDolphinFaces;
    LPDIRECT3DVERTEXDECLARATION9        m_pDolphinVertexDeclaration;
    LPDIRECT3DVERTEXSHADER9      m_pDolphinVertexShader;
    LPDIRECT3DVERTEXSHADER9      m_pDolphinVertexShader2;

    // Seafloor object
    LPDIRECT3DTEXTURE9      m_pSeaFloorTexture;
    LPDIRECT3DVERTEXBUFFER9 m_pSeaFloorVB;
    LPDIRECT3DINDEXBUFFER9  m_pSeaFloorIB;
    DWORD                   m_dwNumSeaFloorVertices;
    DWORD                   m_dwNumSeaFloorFaces;
    LPDIRECT3DVERTEXDECLARATION9        m_pSeaFloorVertexDeclaration;
    LPDIRECT3DVERTEXSHADER9      m_pSeaFloorVertexShader;
    LPDIRECT3DVERTEXSHADER9      m_pSeaFloorVertexShader2;

    // Water caustics
    LPDIRECT3DTEXTURE9      m_pCausticTextures[32];
    LPDIRECT3DTEXTURE9      m_pCurrentCausticTexture;

};
#endif 
