#include <hush/source.h>

#include "lectures/lecture.h"
#include "scene/image.h"
#include <scene/satelite.h>
#include <scene/shader.h>
#include <scene/mesh.h>

#include <hush/string.h>

// sub scenes

scene* lecture::create(char* opts) { return new lecture(opts); }

#include "odyssee/scene-0.h"
#include "odyssee/scene-1.h"
#include "odyssee/scene-2.h"
#include "odyssee/scene-3x.h"

//#include "extra/object-vsh.h"
#include "extra/object-dolphin.h"
#include "extra/object-water.h"
#include "extra/object-flag.h"

#include "extra/object-spectrum.h"

static scene* _hold = 0;
static scene* _water = 0;
static scene* _spectrum = 0;
static scene* _bulb = 0;
static scene* _flag = 0;
static scene* dolphin1;
static scene* dolphin2;

static float local = 0;


//#include "lectures/lecture-eca-text.h"
#include "objects/scene-text-3d.h"
#include "objects/background-scene.h"
//#include "lectures/lecture-eca-0.h"
//#include "lectures/scene-test.h"
#include "scene/text.h"
#include "scene/slides.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////



//static char _key[256];

static char* msg[12][12];



int lecture::handle(char* type, char* ev) {
	if (check(type,ev,"lbutton","down")) {
		//if (_condition == WAIT) _condition = RUNNING;
		//else (_condition = WAIT);
		if (_slides) _idx = _slides->next();
	} else if (check(type,ev,"arrow","down")) {
		if (_text) _text->next();
	} else if (check(type,ev,"arrow","up")) {
		if (_text) _text->next(-1);
	} else if (check(type,ev,"key","back")) {
		if (_slides) _slides->next(-1);
	} else if (check(type,ev,"key","return")) {
		if (_ctrl()) {
			state = 5;
			//_condition = RUNNING;
		} else
		if (state == 0) {
			_condition = START;
		} else {
		_slides->exclude(1);
		_exclude[4] = 1;
		_condition = WAIT; state = 0;
		_exclude[0] = 1;
		_exclude[1] = 1;
		}

	} else if (check(type,ev,"key","tab")) {
		if (_ctrl()) {
			//state = 5;
			int x = lst("space")->exclude();
            if (x == 0) x = 1; else x = 0;
			//lst("space")->exclude(x);
			if (!_hold) _hold = lst("space");
			else {
				_hold = 0;
				fx("walk",(ieffect*)_main());
			}
			if (_hold) _hold->exclude(1);

		} else
	
		if (state == 5 || state == 4) {
			int x = _slides->exclude();
			if (x == 0) x = 1; else x = 0;
			_slides->exclude(x);
			//if (!x) _show = scenes[4];
		} else { state = 0; _condition = WAIT; }
    } else if (check(type,ev,"key","space")) {
		//scenes[4]->interval(now(),10);
		if (_ctrl() || _shift()) {
			scenes[4]->interval(now(),10);
			local = now();
            //_condition = WAIT;
		} else
		if (state == 4) {
			if (0) {
			_idx = 0;
			scenes[4]->rate(-1);
			//scenes[4]->state = 1;
			state = 5;
			_show = 1;
			scenes[4]->index(_idx);
			} else {
				//_idx = 0;
				local = now();
				_slides = scenes[4];
				if (_slides) {
				_show = 1;
				_slides->rate(-1);
				_slides->state = 1;
				_slides->index(0);
				}
				state = 5;
			}
		} else if (state == 5) {
			//_idx = scenes[4]->next();
			//_idx = _slides->next();
			 if (_slides) _idx = _slides->next();
			//scenes[4]->state = 1;
		}
		else _condition = START;
	} else 
		return scene::handle(type,ev);
	sprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}


lecture::lecture(char* opts) 
{

	//_debug = 1;
    
	_select(1);
	_cx(40); _cy(0);
	sprintf(_type,"lecture");

	_master(this);
    _handler(this);
    scale(0.9f,0.9f,0.9f);

    loop = 0;
    end(125); // seconds
    _event = 1;

    count = 12; //8;
    _text3d = 7;
    _text3ds = 8;
    _text3d2 = 9;
    _txt = 10;

	opt("type","lecture");
	opt("name","vip");
	//opt("text","vip");
	//opt("space","space/imm")
	

	
	opt("phase(title)","<0,15>");
	opt("phase(sub)","<15,40>");
	opt("phase(authors)","<20,40>");
	opt("phase(0)","<0,15>");
	opt("phase(1)","<0,15>");
	opt("text(0)","<5,15>");
	opt("text(1)","<40,50>");
	opt("text(2)","<50,60>");
	opt("text(3)","<90,100>");
	opt("text(4)","<118,150>");

	


	
	if (opts) process(opts);

	opt("text",opt("name"));

	//if (!opt("space")) opt("space","vip/space");

	opt("display","(old) lecture");
	if (!opt("kind")) opt("kind",opt("text"));
	

	opt("info",fm("text/%s",opt("text")));
	scenes[_txt] = sc(opt("info")); //new text(&msg);
    _text = scenes[_txt];
	debug(fm("info %s (%d)",opt("info"), (int) _text));

	opt("display",_text->opt("display"));
	//opt("display",_text->opt("text(title)"));
	opt("text(title)",_text->opt("text(title)"));
	opt("text(authors)",_text->opt("text(authors)"));
	opt("text(sub)",_text->opt("text(sub)"));
	opt("slides",_text->opt("slides"));

	opt("logo(3d)",_text->opt("logo(3d)"));
	opt("logo(3ds)",_text->opt("logo(3ds)"));
	opt("logo(vip)",_text->opt("logo(vip)"));

	if (!opt("style")) opt("style",_text->opt("style"));
	if (!opt("space")) opt("space",_text->opt("space"));

	if (!opt("space")) opt("space","space/imm");


	instance = opt("text");

	
	if (instance == "eca") {
    _cx(0); // _cy(10);
	_x -= 100;
	}
     
	
	if (opt("style") && !strcmp(opt("style"),"plain")) {
    opt("phase(title)","<0,10>");
	opt("phase(sub)","<10,20>");
	opt("phase(authors)","<20,30>");

	opt("text(0)","<5,15>");
	opt("text(1)","<15,25>");
	opt("text(2)","<25,35>");
	opt("text(3)","<35,45>");
	opt("text(4)","<45,55>");
	}
	
	_display = opt("display");
	




_exclude[0] = 1;
_exclude[1] = 1;
_exclude[2] = 1;
_exclude[3] = 1; 
_exclude[4] = 1;
_exclude[5] = 1;
_exclude[6] = 0;
_exclude[7] = 1;
_exclude[8] = 1; 
_exclude[9] = 1;
_exclude[10] = 1;
_exclude[11] = 0;




if (1) {
scene* s = new scene();
s->count = 6;

//s->mode(1);



s->scenes[4] = new satelite("mesh=circle factor=0.2 distort=1"); //satelite();
s->scenes[4]->translation(2,0.8,2.0);
s->scenes[4]->scale(0.1,0.1,0.1);
s->_exclude[4] = 0;
s->scenes[5] = new satelite("distort=1 mesh=tiger scale=0.8 distance=2.0 factor=0.2");
s->scenes[5]->translation(2.0,0.8,2.0);
s->scenes[5]->scale(0.1,0.1,0.1);
s->_exclude[5] = 1;

s->translation(1,-2,0);


s->scenes[2] = new satelite();
s->scenes[2]->propagate("mesh=circle distort=1");
s->scenes[2]->translation(0,0,0);

s->scale(0.4,0.4,0.4);

poption("vip(x)",s);
_bulb = (scene*) poption("vip(x)");
} 


//_background = new background_scene();

scenes[0] = new scene_0();
popt("scene/0",scenes[0]);
(*this)[1] = new scene_1();
//scopt("2",new scene_2());
(*this)[2] = new scene_2();
//scenes[2] = new scene_2();
scenes[3] = new scene_3x(); //scene_3();
_stack = 1;

scene::declare("scene/0",scenes[0]);
scene::declare("scene/1",scenes[1]);
scene::declare("scene/2",scenes[2]);
scene::declare("scene/3",scenes[3]);



//scenes[4] = new lecture_0();

scenes[4] = _text->sc("slides");

scene::declare("space/imm",_text);

if (!scenes[4]) scenes[4] = new slides(opt("slides"));


_slides = scenes[4]; // 4

_slides->exclude(1); 


(*this)[11] = new object_dolphin();


_water = new object_water();

lst("bulb",_bulb);
lst("water",_water);



_spectrum = _scene = new object_spectrum();

_scene->translation(0,0,1); // no op

_tk->load("x");
_tk->load("shader");


lst("space",sc(opt("space"))->create(fm("text=%s",opt("info"))));
	//->create(fm("text=\"text/%s\"",opt("text"))) );
if (lst("space")) lst("space")->exclude(1);



scenes[6] = _flag = new object_flag();
//scenes[6]->rotation(0,1,0,0.5 * 3.14);
scenes[6]->scale(2.3,0.9,0.5);
scenes[6]->translation(0,-16.2,10); // no op
scene::declare("lecture/wave",scenes[6]);

//scenes[5]->translation(0,0,-4);


scenes[_text3d2] = new scene_text_3d(opt("logo(vip)"));
scenes[_text3d2]->scale(0.8,0.8,0.8);
scenes[_text3d2]->translation(-0.5,1.5,-2.5);

if (!is("kind","vip")) scenes[_text3d2]->scale(0.5,0.5,0.5);

if (!is("kind","eca")) {

scenes[_text3d] = new scene_text_3d(opt("logo(3d)"));
scenes[_text3d]->scale(0.4,0.4,0.4);
scenes[_text3d]->translation(-0.4,2.3,-2.5);
//scenes[_text3d]->rotation(0,1,0,-0.2);

scenes[_text3ds] = new scene_text_3d(opt("logo(3ds)"));
scenes[_text3ds]->scale(0.6,0.6,0.6);
scenes[_text3ds]->translation(-0.6,1.4,-2.5);

} else {

scenes[_text3d] = new scene_text_3d(opt("logo(3d)"));
scenes[_text3d]->scale(0.5,0.5,0.5);
scenes[_text3d]->translation(-0.5,2.2,-2.5);
//scenes[_text3d]->rotation(0,1,0,-0.2);

scenes[_text3ds] = new scene_text_3d(opt("logo(3ds)"));
scenes[_text3ds]->scale(0.3,0.3,0.3);
scenes[_text3ds]->translation(-0.7,1.5,-2.5);

}

/*
scenes[_txt] = scr(opt("text")); //new text(&msg);
_text = scenes[_txt];
debug(fm("text = %d",(int)_text),0);
*/
}

lecture::~lecture()
{
//delete scenes[];
}


int lecture::_load() {
HRESULT hr = S_OK;


//_tk->load("text");


hr = scene::_load();

return hr;
}

int lecture::_compose() {
HRESULT hr = S_OK;


if (!dolphin1) dolphin1 = ((dxscene*) dvscene::lookup("object/dolphin"));
//if (!dolphin2) dolphin2 = (scene*) ((dxscene*) dvscene::lookup("menu/vip"))->poption("dolphin");
dolphin2 = (*this)[11];
//dolphin2 = scenes[11];

dolphin1->state = 1;
dolphin2->state = 1;




_device->LightEnable(0, FALSE);


return hr;
}


int
lecture::_render( ) //IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

IDirect3DDevice9* device = _device;
IDirect3DTexture9* texture = _texture;


int _style = 0;
if (opt("style") && is("style","plain")) _style = 1;

if (_style) dolphin1->exclude(1);
if (_style) dolphin2->exclude(1);
if (_style) _flag->exclude(1);

if (_slides && _style) _slides->_texture = _captures(0);

_scene = _hold;

if (1) {
_bulb->_texture = _capture;
_water->_texture = _capture;
_spectrum->_texture = _capture;
_flag->_texture = _capture;

texture = _captures(_select());
}

	// set transform and render

render_begin(device);

scenes[0] = sc("scene/0");
scene::_main()->_scene->_exclude[10] = 0;
//_parent->_exclude[10] = 0;
//dolphin2 = _parent->scenes[10];
dolphin1->state = 1;
dolphin2->state = 1;

if (current()>95) {
	//dolphin1->state = 0;
	//dolphin2->state = 0;
}
	

// begin the lecture

//float f = fraction();


int states = 4;
 
//_background -> draw(device,texture);

if (state != 5 && condition() == START) {
	    _slides->rate(3);
		_slides->state = 0;
		_slides->exclude(0);
        interval(now(),_end);
		
		_condition = RUNNING;
		_event = 1;
}



//if (inbetween(2,12)) {
if (state != 5 && !_style &&  !condition() && inbetween(106,115)) {
	static int _not = 0;
	if (!_not++) scenes[_text3d2]->interval(now(),8);
	_exclude[_text3d2] = 0;
	float f = scenes[_text3d2]->fraction();
	scenes[_text3d2]->rotation(0,0,1,3.14 * f);
} else {
	_exclude[_text3d2] = 1;
	//_exclude[_text3ds] = 1;
}

if (state != 5 && !_style && !condition() && inbetween(15,26)) {
	if (is("kind","eca")) {
	 if (state != previous || event() > 0) scenes[_text3ds]->interval(now(),8);
	_exclude[_text3d] = 0;
	_exclude[_text3ds] = 0;
	float f = scenes[_text3ds]->fraction();
	scenes[_text3ds]->rotation(0,0,1,3.14 * f);
	} else {
			if (state != previous || event() > 0) {
		       scenes[_text3ds]->interval(now(),8);
	        }
	_exclude[_text3d] = 0;
	_exclude[_text3ds] = 0;
	float f = scenes[_text3ds]->fraction();
	scenes[_text3ds]->rotation(0,0,1,3.14 * f);
	}
} else {
	_exclude[_text3d] = 1;
	_exclude[_text3ds] = 1;
}



if (0 && !condition() && inbetween(5,15)) {
	_exclude[4] = 0;
	 _show = 1;
	 if (state != previous) {
	      scenes[4]->interval(now(),40);
	 }
}

if (state != 5 && !condition() && inbetween("text(0)")) {
	_text->state = 0;
	_exclude[_txt] = 0;
} else if (state != 5 && !condition() && inbetween("text(1)")) {
	_text->state = 1;
	_exclude[_txt] = 0;
} else if (state != 5 && !condition() && inbetween("text(2)")) {
	_text->state = 2;
	//_text->index(2);
	_exclude[_txt] = 0;
} else if (state != 5 && !condition() && inbetween("text(3)")) {
	_text->state = 3;
	_exclude[_txt] = 0;
} else if (state != 5 && !condition() && inbetween("text(4)")) {
	_text->state = 4;
	_exclude[_txt] = 0;
} else {
	_exclude[_txt] = 1;
}


if (_total()) _project( _active() % _total() );
_blend = 0;
_scene = _bulb;
if (_style) _scene = 0;

if (condition() > 0) {
	//_project = _active;
	//if (_project) _backdrop = 1 - _active;

	state = 0;
	if (condition() != WAIT)
		 for (int i = 0; i < count; i++) _exclude[i] = 1;
	if (current() > 10 && current() < 10.5) _bulb->scenes[2]->propagate("distort=1");
} else if (state != 5 && !condition() && in("phase(0)")) {
	//} else if (!condition() && inbetween(0,15)) {
	//_project = _active;
	_scene = _bulb; //(scene*) poption("vip(x)");
	if (current() > 5) _bulb->_exclude[2] = 1;
	//_bulb->scale(0.3,0.3,0.3);
	//_exclude[5] = 0;
	if (!_style && _project()) _backdrop( 1 - _project() );
    state = 0;
	_exclude[0] = 1;
	_exclude[1] = 1;
	_exclude[2] = 1;
	_exclude[3] = 1;
	_exclude[4] = 1;
	//_a = (int) 255 - current() * 20;
	//if (_a > 0) _ultra()->message(_x,_y,argb(_a,133,197,235),"  ViP 2004 ");
 
    
} else if (!_style && state != 5 && !condition() && inbetween(15,26)) {
	//_parent->_exclude[0] = 0;
	//_project = _active;
	_index = _select();
	 state = 0;
	 _exclude[3] = 1;
	 _exclude[0] = 0;
	 _exclude[5] = 0;
	 if (state != previous) {
		 scenes[0]->interval(now(),30); // until 
		 scenes[_text3d]->interval(now(),8);
		 //if (_hold) _scene = _hold;
	 }
	 dolphin1->state = 0;
	 dolphin2->state = 0;
	 if ((current()>20)) {
	 _bulb->_exclude[4] = 1;
	 _bulb->_exclude[5] = 0;
	 }
} else if (!_style && state != 5 && !condition() && inbetween(26,50)) {
	if (instance != "imm") {
		_scene = _spectrum;
	    _scene->_blend = 1; // AE
	}
	//_project = _select;
     state = 1;
	 _exclude[0] = 1;
	 _exclude[1] = 0;
	 _exclude[5] = 1;
	 scenes[10]->state = 1;
	 if (current() > 45.0) _scene->_blend = 1;
	 if (state != previous) {
	      scenes[1]->interval(now(),20);
     }
} else if (!_style && state != 5 && !condition() && inbetween(50,60)) {
	
     state = 2;
	 _exclude[1] = 1;
	 _exclude[2] = 0;
	  //scenes[11]->state = 0;
	 //dolpin2->state = 0;
	 
	 if (state != previous) {
	      scenes[2]->interval(now(),10);
	
	 }
}  else if (!_style && state != 5 && !condition() && inbetween(60,118)) {
     state = 3;
	 //_scene->_blend = 0;
	 _scene = 0;
	 _scene = _bulb;

	 scenes[6]->_lights = 1;
	 
	 if (state != previous) {
	      scenes[3]->interval(now(),30);
	
	 }

	 _exclude[3] = 0;
	 if (current()>95) _exclude[0] = 0; 
	 if (current()>80) _exclude[1] = 0;
	 if (current()>90) _exclude[3] = 1;
	 
	 //if (current()>85) _exclude[2] = 0;
	 _exclude[2] = 0;
	 
	 _exclude[4] = 0;
	 _show = 1;
	 if (state != previous) {
	      scenes[4]->interval(now(),40);
	 }
	 if (current()>85) { _exclude[4] = 1; _show = 0; }

}  else if (!_style && state != 5 && !condition() && current() > 110 && state < 5) {
	//_parent->_exclude[0] = 1;
	//_condition = END;
	int match = !strcmp(_main()->opt("application"),"animation");
	if (0 && is("kind","vip") && !match) _scene = _water; //(scene*) poption("vip(x)");
	//if (is("lecture","imm")) _scene = _water;
	//_scene->translation(1,1,0);
	_select(0);
	scenes[6]->_lights = 0;
	//_project = _active;
	_backdrop( 1 - _active() );
	state = 4;
	_exclude[0] = 1;
	_exclude[1] = 1;
	_exclude[2] = 1;
	_exclude[3] = 1;
	_exclude[4] = 0;
	_show = 1;
	if (state != previous) {
	      scenes[4]->interval(now(),20);
		  local = now() + 20;
	 }

	
	//state = 4;
}  else if (state == 5 || (!condition() && current() > 110 && state == 5)) {
	//_condition = END;
	state = 5;
	//_project = _active;
	_exclude[0] = 1;
	_exclude[1] = 1;
	_exclude[2] = 1;
	_exclude[3] = 1;
	_exclude[4] = 0;

	//_scene = _hold;

	static int once = 0;
	int match = !strcmp(_main()->opt("application"),"animation");
	//_hold = _scene;
   if (0 && is("kind","vip") &&  !match) _scene = _water;
   if (_bulb) {
	_bulb->_exclude[4] = 0;
	_bulb->_exclude[5] = 1;
	_bulb->_exclude[2] = 0;
	_bulb->translation(0,1,-2);
   }
	//_scene->_scene = _bulb;
	_scene = _hold;
	scenes[0] = _bulb; //_hold?_hold:_bulb;
	if (_scene) _exclude[0] = 1; // AE
	//_scene = 0;
	
	//if (!once++) _scene = new object_water();
	
	 scenes[4]->rate(0);

	if (_scene && dxtime() > 125) _scene->_max = 15;
	if (_scene && dxtime() > 140) _scene->_max = 25;
	if (_scene && dxtime() > 145) _scene->_max = 100;

	if (strcmp(opt("kind"),"vip")) {
	if (dxtime() > 125 ) {  _exclude[6] = 1; }
	if ((dxtime() > 150) || (previous != 4)) {
		//_scene = 0;
		dolphin1->exclude(1);
		dolphin2->exclude(1);
		_bulb->_exclude[5] = 0;
		_slides->scale(1.2,1.2,1);
		if ((now() - local) > 10) _exclude[6] = 1;
		else _exclude[6] = 0;

	}
	}
	if (dxtime() > 160) {
		//_scene = 0;
		_exclude[0] = 1;
	}
	//if (dxtime() > 160) _scene->_max = 1000;


	
	//state = 4;
}




	hr = scene::render(device,texture); // calls restore, compose, render


if (((state != 5) || (now()-local <10)) && !condition() && 
	                         //inbetween(1,15)) {
							 inbetween("phase(title)")) {
	_a = (int) 255 - current() * 20;
	if (_a > 0) _ultra()->message(_x-50,_y,argb(_a,133,197,235),opt("text(title)")); //"  ViP 2004 ");
}

if (((state != 5) || (now()-local <10)) && !condition() && inbetween("phase(sub)")) {
	float f = (current()-15.0)/25.0;
	_a = 250.0;//*f;
	_r = 133 + 120.0 * f;// + 5 * current();
	_g = 197;// - 150 * f;
	_b = 235;// - 200 * f;;
	scene::_large()->message(100+_x-_tab*10-100,height()-_inc*6,argb(_a,_r,_g,_b), opt("text(sub)"));
			//  "webcams           video             images");
	}
if (((state != 5) || (now()-local <10)) && !condition() && inbetween("phase(authors)")) {
	float f = (current()-20.0)/20.0;
	_a = 255 - 200.0 * f;
	_r = 255;// + 122.0 * f;
	_g = 80;// - 80.0 * f;
	_b = 80;// - 125.0 * current();
	
	scene::_small()->message(_x + 10,_y+_inc*5,argb(_a,_r,_g,_b), opt("text(title)"));
		      //"ViP 2004");
	
	
}

if (((state != 5) || (now()-local <10)) && !condition() && inbetween("phase(authors)") && opt("text(authors)")) {
	float f = (current()-20.0)/20.0;
	_a = 100 + 100.0 * f * 2;
	_r = 133;+ 100.0 * f * 2;
	_g = 197;+ 40.0 * f * 2;
	_b = 235 + 10.0 * f * 2; // * current();
	if (current() > 30) {
	_a = 255; _r = 255; _g =255; _b = 255;
	}
	scene::_plain()->message(100+_x-_tab*3,_y,argb(_a,_r,_g,_b),opt("text(authors)"));
			 // "A. Eliens, Z. Huang, J.F. Hoorn, C.T. Visser");
	scene::_small()->message(100+_x+_tab+50,_y+_inc*3,argb(_a,_r,_g,_b),
		      "Intelligent Multimedia");
	scene::_large()->message(100+_x+30,_y+_inc*6,argb(_a,_r,_g,_b),
		      "VU Amsterdam");
	
}

    //display(_display);


	render_end(device);

 

    return hr;
}

