
#ifndef image_scene_h
#define image_scene_h

#include "scene/scene.h"
#include <atlbase.h>

//#define NUM_VERTICES1 4

class image_scene : public scene  
{
public:

    image_scene(TCHAR* = 0); // capture or image(string)
    virtual ~image_scene();
    virtual HRESULT init(IDirect3DDevice9* device);
	virtual HRESULT restore(IDirect3DDevice9* device);
    

    virtual HRESULT render(  IDirect3DDevice9* device,
                        IDirect3DTexture9* texture );

    virtual void rectangle( float fTU, float fTV );

private:

	void init();
 //   int state;  // 0 image, 1 capture
	TCHAR* image;

	LPDIRECT3DTEXTURE9				g_pBackgroundTexture;

	struct CUSTOMVERTEX
    {
        struct Position {
            Position() : 
                x(0.0f),y(0.0f),z(0.0f) {            
            };
            Position(float x_, float y_, float z_) :
                x(x_),y(y_),z(z_) {
            };
            float x,y,z;
        };

        Position    position; // The position
        D3DCOLOR    color;    // The color
        FLOAT       tu, tv;   // The texture coordinates
    };

    CUSTOMVERTEX                    m_vertices[4];
    CComPtr<IDirect3DVertexBuffer9> m_vertexBuffer;
	

    DWORD  m_time;
	int initialized;

};
#endif 
