
#ifndef movie_scene_h
#define movie_scene_h

#include "scene/scene.h"
#include <atlbase.h>

//#define NUM_VERTICES1 4

class movie_scene : public scene  
{
public:

    movie_scene(char* = 0); // capture or image(string)
	movie_scene(char* path, char* name, int from, int to, char* ext = "jpg");


    virtual ~movie_scene();
    virtual HRESULT init(IDirect3DDevice9* device);
	virtual HRESULT restore(IDirect3DDevice9* device);
    

    virtual HRESULT render(  IDirect3DDevice9* device,
                        IDirect3DTexture9* texture );

    virtual void rectangle( float fTU, float fTV );


public:
	//void index(int i);
	//int index();
private:
 //   int state;  // 0 image, 1 capture
	char* image;

	void init();

#define MAXTEXTURES 256

	LPDIRECT3DTEXTURE9				_texture;
	LPDIRECT3DTEXTURE9				_textures[MAXTEXTURES];

	struct CUSTOMVERTEX
    {
        struct Position {
            Position() : 
                x(0.0f),y(0.0f),z(0.0f) {            
            };
            Position(float x_, float y_, float z_) :
                x(x_),y(y_),z(z_) {
            };
            float x,y,z;
        };

        Position    position; // The position
        D3DCOLOR    color;    // The color
        FLOAT       tu, tv;   // The texture coordinates
    };

    CUSTOMVERTEX                    m_vertices[4];
    CComPtr<IDirect3DVertexBuffer9> m_vertexBuffer;
	

    DWORD  m_time;
	int initialized;

	char* _path;
	char* _name;
	char* _ext;
	int _from;
	int _to;

	//int _cnt;
	//int _idx;

	//double _rate;
	//double _xtime;

};
#endif 
