

#include "scene-3x.h"

// sub scenes

#include "objects/cylinder-scene.h"
#include "objects/plane-scene.h"
#include "objects/background-scene.h"
#include "objects/image-scene.h"
#include "objects/sub-scene.h"
#include "scene-1.h"
#include "objects/movie-scene.h"
#include "scene/image.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


scene_3x::scene_3x() 
{

_end = 20;
loop = 1;
//scale(0.9f,0.9f,0.9f);
//translation(100,100,0);
//rotation(1.0f,0.0f,0.0f,0.5f);

count = 7;
_exclude[0] = 1; //0
_exclude[1] = 1; //0
_exclude[2] = 1; 
_exclude[3] = 1; //0 
_exclude[4] = 0;
_exclude[5] = 0;
_exclude[6] = 1;

scenes[1] = new scene_1(); 
scenes[0] = new cylinder_scene();
//scenes[0] = new cylinder_scene(1);
scenes[0] = new cylinder_scene(2);
scenes[0]->translation(-1.0f,0.0f,1.0f);
scenes[0]->scale(0.2f,0.3f,1.0f);
scenes[1] = new plane_scene();
//scenes[2] = new background_scene(_T("soutine.jpg"));
scenes[2] = new image();

scenes[3] = new sub_scene();
scenes[3]->scale(1.2f,1.1f,1.0f);
scenes[3]->translation(0.0f,-2.0f,1.0f);
//scenes[4] = new image_scene(_T("soutine.jpg"));
//scenes[4] = new movie_scene("soutine.jpg");

//scenes[4] = new movie_scene("C:\\AE\\media\\pictures\\storm","storm",1,19,"jpg");
scenes[4] = new image("\\vip\\present\\pictures\\storm","storm",1,19,"jpg");
scenes[4] = new image();
scenes[4]->scale(0.3f,0.3f,0.3f);
scenes[4]->translation(-1.0f,1.3f,0.0f);
//scenes[4]->rotation(1.0f,0.0f,0.0f,0.5f); // this is naive rotation
scenes[4]->set_mode(0); // 0 = absolute

//scenes[5] = new movie_scene("C:\\AE\\media\\pictures\\horror","horror",1,18);
//scenes[5] = new image("\\vip\\present\\pictures\\horror","horror",1,18);
scenes[5] = new image();
scenes[5]->scale(0.3f,0.3f,0.3f);
scenes[5]->translation(1.0f,1.3f,0.0f);
//scenes[5]->rotation(1.0f,1.0f,0.0f,0.5f); // this is naive rotation
scenes[5]->set_mode(0); // 0 = absolute

//scenes[6] = new movie_scene("C:\\AE\\media\\pictures\\life","life",1,27);
scenes[6] = new image("\\vip\\present\\pictures\\life","life",1,27);
scenes[6] = new image();
scenes[6]->scale(0.5f,0.5f,0.5f);
scenes[6]->translation(0.0f,0.0f,-0.5f);
//scenes[6]->rotation(1.0f,1.0f,0.0f,0.5f); // this is naive rotation
scenes[6]->set_mode(0); // 0 = absolute
scenes[2]->scale(0.5f,0.5f,0.5f);
scenes[2]->translation(0.0f,0.0f,-0.5f);
//scenes[2]->rotation(1.0f,1.0f,0.0f,0.5f); // this is naive rotation
scenes[2]->set_mode(0); // 0 = absolute



_shader = "scene";
opt("nofx","1");
iopt("overlay",1);



}

scene_3x::~scene_3x()
{
//delete scenes[];
}

HRESULT 
scene_3x::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

	// anything else ?

	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
scene_3x::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;





    return hr;
}


HRESULT 
scene_3x::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

if (opt("tx")) _texture = tx(opt("tx"));
if (_texture) texture = _texture;

static int odd = 0;
static int fac = 3;
	render_begin(device);

	scenes[6]->rate(0.1);

	float f = fraction();
    float m = 2;
	if (fraction() < 0.5) {
	scenes[4]->rate(0.1 + f * m);
    scenes[5]->rate(2.1 -  f * m);
	_exclude[6] = 1;
	
	} else {
	scenes[4]->rate(2.1 - f * m);
    scenes[5]->rate(0.1 + f * m);

	}

	if (odd % fac == 0) {
		_exclude[2] = 1;
		_exclude[6] = 1;
		_exclude[5] = 1;
		_exclude[4] = 1;
	} else {
	    if (f >0.3 && f < 0.8)_exclude[6] = 0;
        if (f >0.5) fac = 2;
		scenes[6]->rate(0.2);
		_exclude[2] = 1;
		_exclude[6] = 0;
		_exclude[5] = 0;
		_exclude[4] = 0;
	}
	odd++;


	/*
	scenes[4]->scale(0.4f,0.4f,0.4f);
    scenes[4]->translation(-1.0f,1.2f,0.0f);
    scenes[4]->rotation(1.0f,1.0f,0.0f,0.5f); // this is naive rotation
    scenes[4]->mode(0); // 0 = absolute
    
	
	scenes[5]->scale(0.4f,0.4f,0.4f);
    scenes[5]->translation(1.0f,1.2f,0.0f);
    scenes[5]->rotation(1.0f,1.0f,0.0f,0.5f); // this is naive rotation
    scenes[5]->mode(0); // 0 = absolute

	scenes[6]->scale(0.4f,0.4f,0.4f);
    scenes[6]->translation(0.0f,1.0f,-2.5f);
    scenes[6]->rotation(1.0f,0.0f,0.0f,1.5f); // this is naive rotation
    scenes[6]->mode(0); // 0 = absolute
*/
    // begin the scene_3x


	hr = scene::render(device,texture); // calls restore, compose, render

    
	render_end(device);

 

    return hr;
}

/*

  // don t bother, is inherited as is

void
scene_3x::rectangle( float fTU, float fTV )
{
	m_fTU = fTU;
	m_fTV = fTV;
    
	for (int i=0; i < count; i++) {
            scenes[i]->SetSrcRect(fTU,fTV);
	}
	

}
*/
