#include <hush/source.h>

#include "particles.h"

#include <scene/shader.h>
#include <scene/background.h>
#include <scene/face.h>


#include <streams.h>
#include <scene/satelite.h>
#include <hush/scanner.h>

#include <hush/sim/sim.h>




//#include "shader.h"


static char* _help = "particle";




scene* particles::create(char* opts) {
	return new particles(opts);
}

int particles::operator()()
{
  

state = random(0,2);

_sim->passivate(this);
float t = 5.0;
 
//_sim->schedule(this,_gn->exponential(t));
return 0;
 
  
}

particles::particles(char* opts) 
{
	
	count = 12;


_size = 20; //size;
wsprintf(_type,"particles");
_display = _type;

end(100);
loop = 1;

	m_pParticleBuffer  = NULL;
	m_kParticleList    = NULL;
	m_iMaxParticles    = 0;
	m_iNumParticles    = 0;
	m_fAccumulatedTime = 0.0f;

	choice = 0;

	/*
	    m_iMaxParticles = 150;
	    m_vOrigin		= D3DXVECTOR3(0.0f,0.0f,0.0f);
	    m_vForce		= D3DXVECTOR3(0.0f, -1.0f, 0.0f);

	    info.m_vPositionVariation   = D3DXVECTOR3(-10.0f, 0.0f, -10.0f);
		
		
		info.m_vStandardVelocity    = D3DXVECTOR3(0.5f, -1.0f, 0.5f);
		info.m_vVelocityVariation   = D3DXVECTOR3(-1.0f, 0.5f, -1.0f);
		info.m_vForceVariation      = D3DXVECTOR3(0.0f, 1.0f, 0.0f);
		info.m_cStandardStartColor  = D3DCOLOR_RGBA(255, 255, 255, 155);
		info.m_cStartColorVariation = D3DCOLOR_RGBA(0, 0, 0, 0);
		info.m_cStandardEndColor    = D3DCOLOR_RGBA(255, 255, 255, 155);
		info.m_cEndColorVariation   = D3DCOLOR_RGBA(0, 0, 0, 0);
		info.m_fStandardEnergy      = 15.0f;
		info.m_fSize		        = 1.5f;
		info.m_fStandardWeight      = 0.001f;
		info.m_iParticlesPerSecond  = 20;
    */
    opt("id","particles/0");
	opt("max","150");
	opt("origin","(5.0,5.0,5.0)");
	opt("force","(0.0,-1.0,0.0)");
	opt("velocity","(0.5,-1.0,0.5)");
	opt("energy","15.0");
	opt("size","1.5");
	opt("weight","0.001");
	opt("no/s","20.0");
	opt("speed","0.01");

	opt("v(position)","(-10.0,0.0,-10.0)");
	opt("v(force)","(0.0,1.0,0.0)");
	opt("v(velocity)","(-1.0,0.5,-1.0)");
	opt("v(color(start)))","(0,0,0,0)"); /// RGBA 255
	opt("v(color(end)))","(0,0,0,0)");

	opt("color(start))","(255,255,255,155)"); /// RGBA 255
	opt("color(end))","(255,255,255,155)");

	if (opts) process(opts);

 
  
}




particles::~particles()
{
//delete scenes[];
}

int 
particles::_load()
{
    int hr = S_OK;

	
	m_iMaxParticles = 150;
	m_vOrigin		= D3DXVECTOR3(0.0f,0.0f,0.0f);
	m_vForce		= D3DXVECTOR3(0.0f, -1.0f, 0.0f);
	
	float args[4];

	m_iMaxParticles = iopt("max");
	fval("origin",3,(float*)args); m_vOrigin = D3DXVECTOR3(args[0],args[1],args[2]);
	fval("force",3,(float*)args); m_vForce = D3DXVECTOR3(args[0],args[1],args[2]);

	
	

	/* Create vertex buffer */
	hr = _device->CreateVertexBuffer(m_iMaxParticles * sizeof(PointSprite),
                                            D3DUSAGE_DYNAMIC | D3DUSAGE_WRITEONLY | D3DUSAGE_POINTS, 
											D3DFVF_ParticleVertex,
                                            D3DPOOL_DEFAULT, &m_pParticleBuffer, NULL);

    m_kParticleList = new Particle[m_iMaxParticles];
	
	ZeroMemory(&info, sizeof(ParticleInfo));

	    //Reset();
		//SetOrigin(D3DXVECTOR3(5.0f, 5.0f, 5.0f));
		//SetForce(D3DXVECTOR3(0.0f, -1.0f, 0.0f));
		info.m_vPositionVariation   = D3DXVECTOR3(-10.0f, 0.0f, -10.0f);
		info.m_vStandardVelocity    = D3DXVECTOR3(0.5f, -1.0f, 0.5f);
		info.m_vVelocityVariation   = D3DXVECTOR3(-1.0f, 0.5f, -1.0f);
		info.m_vForceVariation      = D3DXVECTOR3(0.0f, 1.0f, 0.0f);
		info.m_cStandardStartColor  = D3DCOLOR_RGBA(255, 255, 255, 155);
		info.m_cStartColorVariation = D3DCOLOR_RGBA(0, 0, 0, 0);
		info.m_cStandardEndColor    = D3DCOLOR_RGBA(255, 255, 255, 155);
		info.m_cEndColorVariation   = D3DCOLOR_RGBA(0, 0, 0, 0);
		info.m_fStandardEnergy      = 15.0f;
		info.m_fSize		        = 1.5f;
		info.m_fStandardWeight      = 0.001f;
		info.m_iParticlesPerSecond  = 20;

	fval("velocity",3,(float*)args); info.m_vStandardVelocity = D3DXVECTOR3(args[0],args[1],args[2]);
	fval("v(position)",3,(float*)args); info.m_vPositionVariation = D3DXVECTOR3(args[0],args[1],args[2]);
	fval("v(velocity)",3,(float*)args); info.m_vVelocityVariation = D3DXVECTOR3(args[0],args[1],args[2]);
	fval("v(force)",3,(float*)args); info.m_vForceVariation = D3DXVECTOR3(args[0],args[1],args[2]);
	
	/*
	fval("v(color(start)))",4,(float*)args); info.m_cStartColorVariation = D3DCOLOR_RGBA(int(args[0]),int(args[1]),int(args[2]),int(args[3]));
	fval("v(color(end)))",4,(float*)args); info.m_cEndColorVariation = D3DCOLOR_RGBA(int(args[0]),int(args[1]),int(args[2]),int(args[3]));
	fval("color(start))",4,(float*)args); info.m_cStartColorVariation = D3DCOLOR_RGBA(int(args[0]),int(args[1]),int(args[2]),int(args[3]));
	fval("color(end))",4,(float*)args); info.m_cEndColorVariation = D3DCOLOR_RGBA(int(args[0]),int(args[1]),int(args[2]),int(args[3]));
	*/
	/*
	fval("energy",1,(float*)args); info.m_fStandardEnergy  = args[0];
	fval("size",1,(float*)args); info.m_fSize  = args[0];
	fval("weight",1,(float*)args); info.m_fStandardWeight  = args[0];
	fval("no/s",1,(float*)args); info.m_iParticlesPerSecond  = args[0];
*/
	args[0] = fopt("energy"); info.m_fStandardEnergy  = args[0];
	args[0] = fopt("size"); info.m_fSize  = args[0];
	args[0] = fopt("weight"); info.m_fStandardWeight  = args[0];
	args[0] = fopt("no/s"); info.m_iParticlesPerSecond  = args[0];


    m_pParticleInfo = &info;
	
	hr = scene::init(_device); // loops through scenes

	

	
	
    return hr;
}

int
particles::_restore()
{
    HRESULT hr = S_OK;
	if (iopt("reset")) {
		Reset();

	float args[4];
   
	fval("origin",3,(float*)args); m_vOrigin = D3DXVECTOR3(args[0],args[1],args[2]);
	fval("force",3,(float*)args); m_vForce = D3DXVECTOR3(args[0],args[1],args[2]);
	
	fval("velocity",3,(float*)args); info.m_vStandardVelocity = D3DXVECTOR3(args[0],args[1],args[2]);
	fval("v(position)",3,(float*)args); info.m_vPositionVariation = D3DXVECTOR3(args[0],args[1],args[2]);
	fval("v(velocity)",3,(float*)args); info.m_vVelocityVariation = D3DXVECTOR3(args[0],args[1],args[2]);
	fval("v(force)",3,(float*)args); info.m_vForceVariation = D3DXVECTOR3(args[0],args[1],args[2]);

	fval("v(color(start)))",4,(float*)args); info.m_cStartColorVariation = D3DCOLOR_RGBA(int(args[0]),int(args[1]),int(args[2]),int(args[3]));
	fval("v(color(end)))",4,(float*)args); info.m_cEndColorVariation = D3DCOLOR_RGBA(int(args[0]),int(args[1]),int(args[2]),int(args[3]));
	fval("color(start))",4,(float*)args); info.m_cStartColorVariation = D3DCOLOR_RGBA(int(args[0]),int(args[1]),int(args[2]),int(args[3]));
	fval("color(end))",4,(float*)args); info.m_cEndColorVariation = D3DCOLOR_RGBA(int(args[0]),int(args[1]),int(args[2]),int(args[3]));
	
	args[0] = fopt("energy"); info.m_fStandardEnergy  = args[0];
	args[0] = fopt("size"); info.m_fSize  = args[0];
	args[0] = fopt("weight"); info.m_fStandardWeight  = args[0];
	args[0] = fopt("no/s"); info.m_iParticlesPerSecond  = args[0];


    m_pParticleInfo = &info;
	


		opt("reset","0");
	}

	
	//Update(delta());
	//Update(0.01);
	Update(fopt("speed"));


    return hr;
}


int
particles::_render( ) 
{
HRESULT hr = S_OK;

    _texture = _capture;
	if (opt("tx") && tx(opt("tx"))) _texture = tx(opt("tx"));
  
	render_begin(_device);
	
	_device->SetTexture( 0, _texture );
       //int i = 0;

 if (m_iNumParticles == 0)
	{
		return -1; //noError;
	}

	/* Create point sprites */
	PointSprite *sprites = new PointSprite[m_iNumParticles];

	/* Set sprite properties */
	for (u_int32 i=0; i < m_iNumParticles; i++)
	{
		/* Set position */
		sprites[i].x = m_kParticleList[i].m_vPosition.x;
		sprites[i].y = m_kParticleList[i].m_vPosition.y;
		sprites[i].z = m_kParticleList[i].m_vPosition.z;

		sprites[i].u = 0;
		sprites[i].v = 1;




		/* Set color */
		sprites[i].color = m_kParticleList[i].m_cEndColor - ((m_kParticleList[i].m_fEnergy/m_kParticleList[i].m_fTotalEnergy) * (m_kParticleList[i].m_cEndColor - m_kParticleList[i].m_cStartColor));
	}

	/* Fill vertex buffer */
	PointSprite *ptr;

	/* Lock the vertex buffer */
	if(FAILED(m_pParticleBuffer->Lock(0, m_iNumParticles * sizeof(PointSprite), (void**)&ptr, 0)))
	{
		return -1; //errorLockBuffer;
	}

	/* Here we copy the vertex data into the vertex buffer */
	memcpy(ptr, sprites, m_iNumParticles * sizeof(PointSprite));

	/* Unlock when done copying data into the buffer. */
	m_pParticleBuffer->Unlock();

	/* free memory */
	delete [] sprites;

	/* Set texture */
	//m_kParticleTexture.SetActiveTexture();

	/* Set render states */
	
	if (!iopt("noblend")) _device->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
	_device->SetRenderState(D3DRS_ZENABLE, D3DZB_FALSE);
	_device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);
	
    _device->SetRenderState(D3DRS_POINTSPRITEENABLE, TRUE);
    _device->SetRenderState(D3DRS_POINTSCALEENABLE, TRUE);
	
    _device->SetRenderState(D3DRS_POINTSIZE, FtoDW(m_kParticleList[m_iNumParticles-1].m_fSize));
    _device->SetRenderState(D3DRS_POINTSIZE_MIN, FtoDW(1.0f));
    _device->SetRenderState(D3DRS_POINTSCALE_A, FtoDW(0.0f));
    _device->SetRenderState(D3DRS_POINTSCALE_B, FtoDW(0.0f));
    _device->SetRenderState(D3DRS_POINTSCALE_C, FtoDW(1.0f));

	_device->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
	//if (iopt("noblend")) _device->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1 );
	_device->SetTexture( 0, _texture );

	/* Draw point sprites */
	_device->SetStreamSource(0, m_pParticleBuffer, 0, sizeof(PointSprite));
    _device->SetFVF(D3DFVF_ParticleVertex);
    _device->DrawPrimitive(D3DPT_POINTLIST, 0, m_iNumParticles);

	/* Restore render states */
    _device->SetRenderState(D3DRS_POINTSPRITEENABLE, FALSE);
    _device->SetRenderState(D3DRS_POINTSCALEENABLE, FALSE);
    _device->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
	_device->SetRenderState(D3DRS_ZENABLE, D3DZB_TRUE);
	

	hr = scene::_render(); // calls compose, restore,  render


    
    //_selection = 0;

	
	if (iopt("debug")) {
		float args[4];
		int x = 500,y = 240;
		int inc=25;

	
		
		//_help = opt("origin");
		//fval("origin",3,args);
		//message(x,y,argb(255,255,120,120),fm("origin: %s [%.2f,%.2f,%.2f]",_help,args[0],args[1],args[2]));
		message(x,y,argb(255,255,120,120),fm("origin: %s [%s] %s",opt("origin"),opt("tx"),opt("id")));
		message(x,y+=inc,argb(255,255,120,120),fm("speed: %s ",opt("speed")));
		message(x,y+=inc,argb(255,255,120,120),fm("velocity: %s ",opt("velocity")));
		message(x,y+=inc,argb(255,255,120,120),fm("force: %s ",opt("force")));
		message(x,y+=inc,argb(255,255,120,120),fm("energy: %s ",opt("energy")));
		message(x,y+=inc,argb(255,255,120,120),fm("weight: %s ",opt("weight")));
		message(x,y+=inc,argb(255,255,120,120),fm("no/s: %s ",opt("no/s")));
		message(x,y+=inc,argb(255,255,120,120),fm("size: %s ",opt("size")));

	
		message(x,y+=inc,argb(255,255,120,120),fm("v(position): %s ",opt("v(position)")));
		message(x,y+=inc,argb(255,255,120,120),fm("v(velocity): %s ",opt("v(velocity)")));
		message(x,y+=inc,argb(255,255,120,120),fm("v(force): %s ",opt("elta(force)")));

		

	} 
	
	

	//display(_display);
   
	render_end(_device);

 

    return hr;
}

void particles::Update (real32 fTimePassed)
{
	/* Calculate current force */
	D3DXVECTOR3 vCurrentForce = m_vForce + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_vForceVariation;

	/* Loop through all particles */
	for (u_int32 i=0; i < m_iNumParticles; )
	{
		/* Calculate current weight */
		m_kParticleList[i].m_fWeight = m_kParticleList[i].m_fStartWeight + (m_kParticleList[i].m_fEnergy/m_kParticleList[i].m_fTotalEnergy) * m_kParticleList[i].m_fWeightDelta;

		/* Calculate new velocity */
		m_kParticleList[i].m_vVelocity += vCurrentForce * m_kParticleList[i].m_fWeight;

		/* Update the particle position */
		m_kParticleList[i].m_vPosition = m_kParticleList[i].m_vPosition + (m_kParticleList[i].m_vVelocity * fTimePassed);

		/* Check for reasons to kill it */
		m_kParticleList[i].m_fEnergy -= fTimePassed;
		if(m_kParticleList[i].m_fEnergy <= 0.0)
		{
			/* Move last particle to current position */
			m_kParticleList[i] = m_kParticleList[m_iNumParticles-1];

			/* Decrease nr of particles */
			m_iNumParticles--;
		}
		else
		{
			i++;
		}
	}

	/* Store accumulated time */
	m_fAccumulatedTime += fTimePassed;

	/* Calculate nr of particles needed */
	u_int32 iNewParticles = (u_int32) ((float)m_pParticleInfo->m_iParticlesPerSecond * m_fAccumulatedTime);

	/* Save remaining time */
	m_fAccumulatedTime -= 1.0f / (float) m_pParticleInfo->m_iParticlesPerSecond * iNewParticles;

	/* Emit new particles */
	Emit(iNewParticles);
}

/* Create a couple of new particles */
int particles::Emit (u_int32 iNrOfParticles)
{
	while (iNrOfParticles != 0 && m_iNumParticles < m_iMaxParticles)
	{
		/* Initialize new particle */
		InitializeParticle(m_iNumParticles);

		/* Increase number of particles */
		m_iNumParticles++;

		/* Decrease nr of particles to create */
		iNrOfParticles--;
	}

	/* Return nr of uncreated particles */
	return iNrOfParticles;
}

/* Particle initialization */
void particles::InitializeParticle (u_int32 index)
{
	/* Determine starting position */
	m_kParticleList[index].m_vPosition.x = m_vOrigin.x + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_vPositionVariation.x;
	m_kParticleList[index].m_vPosition.y = m_vOrigin.y + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_vPositionVariation.y;
	m_kParticleList[index].m_vPosition.z = m_vOrigin.z + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_vPositionVariation.z;

	/* Set the velocity */
	m_kParticleList[index].m_vVelocity.x = m_pParticleInfo->m_vStandardVelocity.x + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_vVelocityVariation.x;
	m_kParticleList[index].m_vVelocity.y = m_pParticleInfo->m_vStandardVelocity.y + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_vVelocityVariation.y;
	m_kParticleList[index].m_vVelocity.z = m_pParticleInfo->m_vStandardVelocity.z + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_vVelocityVariation.z;

	/* Set size */
	m_kParticleList[index].m_fSize = m_pParticleInfo->m_fSize;

	/* Set weight */
	m_kParticleList[index].m_fStartWeight = m_kParticleList[index].m_fWeight = m_pParticleInfo->m_fStandardWeight + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_fWeightVariation;
	m_kParticleList[index].m_fWeightDelta = m_pParticleInfo->m_fStandardWeightDelta + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_fWeightDeltaVariation;

	/* Set color */
	m_kParticleList[index].m_cStartColor.a = m_pParticleInfo->m_cStandardStartColor.a + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_cStartColorVariation.a;
	m_kParticleList[index].m_cStartColor.r = m_pParticleInfo->m_cStandardStartColor.r + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_cStartColorVariation.r;
	m_kParticleList[index].m_cStartColor.g = m_pParticleInfo->m_cStandardStartColor.g + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_cStartColorVariation.g;
	m_kParticleList[index].m_cStartColor.b = m_pParticleInfo->m_cStandardStartColor.b + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_cStartColorVariation.b;

	m_kParticleList[index].m_cEndColor.a = m_pParticleInfo->m_cStandardEndColor.a + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_cEndColorVariation.a;
	m_kParticleList[index].m_cEndColor.r = m_pParticleInfo->m_cStandardEndColor.r + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_cEndColorVariation.r;
	m_kParticleList[index].m_cEndColor.g = m_pParticleInfo->m_cStandardEndColor.g + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_cEndColorVariation.g;
	m_kParticleList[index].m_cEndColor.b = m_pParticleInfo->m_cStandardEndColor.b + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_cEndColorVariation.b;
	
	/* Set energy */
	m_kParticleList[index].m_fTotalEnergy = m_kParticleList[index].m_fEnergy = m_pParticleInfo->m_fStandardEnergy + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_fEnergyVariation;
}



/* Reset the particle system */
void particles::Reset (void)
{
	m_iNumParticles = 0;
}

/* Move the particle system */
void particles::Move (D3DXVECTOR3 vDirection)
{
	m_vOrigin += vDirection;
}

/* Set new origin */
void particles::SetOrigin (D3DXVECTOR3 vOrigin)
{
	m_vOrigin = vOrigin;
}

/* Change force */
void particles::SetForce (D3DXVECTOR3 vForce)
{
	m_vForce = vForce;
}

/* Get current origin */
D3DXVECTOR3 particles::GetOrigin (void)
{
	return m_vOrigin;
}

/* Get current force */
D3DXVECTOR3 particles::GetForce (void)
{
	return m_vForce;
}

/* Get current origin */
u_int32 particles::GetNrOfParticles (void)
{
	return m_iNumParticles;
}
