
#ifndef basic_h
#define basic_h

#include <hush/export.h>
#include "scene/scene.h"
#include <tchar.h>

#include "common90/d3d-util.h"

class HUSH_API basic : public scene  
{
public:

    //basic(char* f = 0);
	basic(scene* x, char* opts = 0);
	//basic(char* opts = 0);

	
    virtual ~basic();
    virtual HRESULT init(IDirect3DDevice9* device);
	virtual HRESULT restore(IDirect3DDevice9* device);
    

    virtual HRESULT render(  IDirect3DDevice9* device,
                        IDirect3DTexture9* texture );

	struct D3DVERTEX
{
    D3DXVECTOR3 p;
    D3DXVECTOR3 n;
    FLOAT       tu, tv;

    static const DWORD FVF;
};


	//int handle(char* type, char* ev);
protected:

    char _name[512];

    LPD3DXMESH          m_pMeshSysMem;      // system memory version of basic, lives through resize's
    LPD3DXMESH          m_pMeshEnhanced;    // vid mem version of basic that is enhanced
    UINT                m_dwNumSegs;        // number of segments per edge (tesselation level)
    D3DXMATERIAL*       m_pMaterials;       // pointer to material info in m_pbufMaterials
    LPDIRECT3DTEXTURE9* m_ppTextures;       // array of textures, entries are NULL if no texture specified
    DWORD               m_dwNumMaterials;   // number of materials

    
    D3DXVECTOR3         m_vObjectCenter;    // Center of bounding sphere of object
    FLOAT               m_fObjectRadius;    // Radius of bounding sphere of object

    LPD3DXBUFFER        m_pbufMaterials;    // contains both the materials data and the filename strings
    LPD3DXBUFFER        m_pbufAdjacency;    // Contains the adjacency info loaded with the basic

    BOOL                m_bUseHWNPatches; 
    BOOL                m_bWireframe;

	    LPD3DXEFFECT            m_pEffect;            // D3DX effect interface

    LPD3DXMESH              m_pMesh;              // Mesh object
    LPDIRECT3DTEXTURE9      m_pMeshTexture;       // Mesh texture

    D3DXHANDLE              m_hTime;                        // Handle to var in the effect 
    D3DXHANDLE              m_hWorld;                       // Handle to var in the effect 
    D3DXHANDLE              m_hMeshTexture;                 // Handle to var in the effect 
    D3DXHANDLE              m_hWorldViewProjection;         // Handle to var in the effect 
    D3DXHANDLE              m_hTechniqueRenderScene;        // Handle to technique in the effect 


};
#endif 
