#include <hush/source.h>

#include "dossier.h"
#include <scene/mesh.h>
#include <scene/shader.h>
#include <scene/basic.h>
#include <scene/background.h>
//#include <scene/character.h>
//#include "mesh.h"


#include "scene/character.h"
#include <direct/find.h>

#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>


enum eGameActions
{
    BASS_DRUM,           // base drum
    SNARE_DRUM,          // snare drum
    HIHAT_OPEN,          // open hihat
    HIHAT_CLOSE,         // closed hihat
    CRASH,               // crash
    USER1,               // user assigned one
    USER2,               // user assigned two
    USER3,               // user assigned three
	 USER4,               // user assigned three
	  USER5,               // user assigned three

    NUM_ACTIONS         // auto count for number of enumerated actions
};


//#include <streams.h>
#include <scene/satelite.h>
#include <hush/scanner.h>

#include <hush/sim/sim.h>
#include <scene/slides.h>
#include <scene/video.h>

//#include <ch/extern/embedch.h>
//#include "sampclass.h"

//static CCharacter* _tiny = 0;






static char* _help = "dossier";
//static char* _help = "abramovic";

static scene* dolphin;

void dossier::toggle_ds(char* k) {
	char* s = eq(k);
	int v = scene::ds(s);
	scene::ds(s,v?0:1);
}

void dossier::toggle_opt(char* k) {
	char* s = eq(k);
	int v = iopt(s);
	iopt(s,v?0:1);
}

void dossier::toggle_lst(char* k) {
	char* s = eq(k);
	if (lst(s)) {
	int x = lst(s)->exclude();
	if (x) lst(s)->exclude(0);
	else lst(s)->exclude(1);
	}
}

void dossier::toggle_text(char* k) {
	char* s = eq(k);
	//if (_text) _text->exclude(1);
	//_text = 0;
	if (lst(s)) {
	int x = lst(s)->exclude();
	if (x) {
		if (_text) _text->exclude(1);
		lst(s)->exclude(0);
		_text = lst(s); 
	} else {	
		lst(s)->exclude(1);
		_text = 0;
	}
	}
}

void dossier::toggle_game(char* k) {
	char* s = eq(k);
	//if (_text) _text->exclude(1);
	//_text = 0;
	if (lst(s)) {
	int x = lst(s)->exclude();
	if (x) {
		if (_game) _game->exclude(1);
		lst(s)->exclude(0);	
		_game = lst(s); 
	} else {	
		lst(s)->exclude(1);
		_game = 0;
	}
	}
}

void dossier::toggle_particles(char* k) {
	char* s = eq(k);
	//if (_text) _text->exclude(1);
	//_text = 0;
	if (lst(s)) {
	int x = lst(s)->exclude();
	if (x) {
		//if (_particles) _particles->exclude(1);
		lst(s)->exclude(0);	
		_particles = lst(s); 
	} else {	
		lst(s)->exclude(1);
		_particles = 0;
	}
	}
}

void dossier::toggle_slides(char* k) {
	char* s = eq(k);

	// debug(fm("slides: %s = %s",k,s),1);
	
	if (lst(s)) {
	int x = lst(s)->exclude();
	if (x) {
		
		lst(s)->exclude(0);
		//if (_slides) _slides->exclude(1);
		_slides = lst(s); 
		//_slides->rotation(1,0,0,-0.12);
		if (1) {
		_slides->rotation(1,0,0,-0.18); // 18
        _slides->fopt("ytrans",0.75);
		_slides->fopt("ytrans0",0.75);
		_slides->fopt("xfrac",1.1);
		_slides->fopt("yfrac",0.45);
		_slides->fopt("yfrac0",0.20);
		} else {
		_slides->fopt("ytrans",0.2);
		_slides->fopt("xfrac",1.0);
		_slides->fopt("yfrac",0.65);
		}

	} else { 
		lst(s)->exclude(1);
		_slides = 0;
	}
	if (_slides) _slides->interval(now(),5);
	}
}

void dossier::toggle_lecture(char* k) {
	char* s = eq(k);
	//if (_lecture) _lecture->exclude(1);
	//_lecture = 0;
	if (lst(s)) {
	int x = lst(s)->exclude();
	if (x)  {
		lst(s)->exclude(0);
		if (_lecture) _lecture->exclude(1);
		_lecture = lst(s); 
		
		if (0) {
		_slides = _lecture->_slides;
		if (0) {
		   _slides->rotation(1,0,0,-0.18);
           _slides->fopt("ytrans",0.4);
		   _slides->fopt("ytrans0",0.4);
		   _slides->fopt("xfrac",1.1);
		   _slides->fopt("yfrac",0.55);
		}
		}
	} else { 		
		lst(s)->exclude(1);
		_lecture = 0;
	}
	//if (_lecture) _lecture->handle("key","return");
	//if (_lecture) _lecture->handle("key","return");

	}
}



//static char execbuf[1024];

int dossier::exec(char* sx) {
char execbuf[1024];
char *pbuf = &execbuf[0];
if (!sx) strcpy(pbuf,"");// else strcpy(pbuf,eq(sx));
int status = 0;
if (sx && !strcmp(sx,"nil")) return status;
if (sx && !strcmp(sx,"c:c")) return status;

if (!sx) return status;

strcpy(pbuf,eq(sx));
//strcpy(pbuf,sx);
scene::_log(pbuf);

if (sx)  {
int x = iopt("exec");
iopt("exec",x+1);
//_inexec++;
//char* cx = eq(sx);
//char *cmx; if (cmx = cm(cx)) cx = cmx;
char xbuf[512];
char* p = &xbuf[0];
strcpy(p,pbuf);
debug(p,0);
char c = '\0';
if (p && *p != '\0') //&& (p[1] && (p[1] != ':')))
    while ( *p && (c = *p++) && (c != '\0')) {
	char b[2];
	b[0] = c; b[1] = '\0';
	//string xx = b;
	debug(b,0);
	handle("key",b);
	//debug(b,1);
    }
//_inexec--;
if (!x) opt("exec","0");
else iopt("exec",x);
}
return status;
}



/*
static char execbuf[1024];


int dossier::exec(char* sx) {
char *pbuf = &execbuf[0];
if (!sx) strcpy(pbuf,"");// else strcpy(pbuf,eq(sx));
int status = 0;

strcpy(pbuf,eq(sx));
scene::_log(pbuf);

if (sx)  {
int x = iopt("exec");
iopt("exec",x+1);
//_inexec++;
char* cx = eq(sx);
//char *cmx; if (cmx = cm(cx)) cx = cmx;
char* p = cx;
char c = '\0';
if (p && (p[1] && (p[1] != ':'))) while ((c = *p++) && (c != '\0')) {
	char b[2];
	b[0] = c; b[1] = '\0';
	handle("key",b);
    }
//_inexec--;
if (!x) opt("exec","0");
else iopt("exec",x-1);
}
return status;
}
*/


int dossier::ch(char* x) {
int status = 0;
if (!x) {

ds("z",1);
cm("slides","1");
cm("overlay","active");
fopt("xfac",0.4);

eq("e:w","wall");


eq("start","nranblcwz1zna12345kxshvbuwfnf1nvanc");

eq("tab","%");
eq("shift","&");
eq("control","^");

eq("meta","n:m");
eq("objects","n:x");

eq("neutral","n");
eq("space","+");
eq("select","~");

eq("command","n:c");
eq("effects","n:e");



eq("back","-");
eq("return","!");
eq("choice","?");

   

eq("b:a","alternate");
eq("b:w","wall");
eq("b:f","floor");
eq("b:l","frame");
eq("b:m","movie");
eq("b:c","character");
eq("b:p","");

eq("c:s","nranf0nblwnxtrnttnc");
eq("c:x","nranbclwnf0nvanc");
eq("c:0","nranf0nvanc");
eq("c:r","nranc");
eq("c:g",":cx:gxrf:bm:");

eq("c:m",":pcm:");
eq("c:o",":o1:pxm:");
eq("c:p",":pim:");


//eq("c:0","nranbwlnc");
eq("c:1","nranbclwn3uvnxunc");
//eq("c:2","nranbcn7bvnxrbunc");
eq("c:2","nranbcn7bvnxrbunc");
eq("c:3","nranx13tni1n213hnbmcnc");
eq("c:4","nranx13ni1n413hnbmcnc");
eq("c:5","nranf8nx23n8123nc");
eq("c:6","nranx3n813hnbmcnc");
eq("c:7","nrana12345hnbmhnx5nc");
eq("c:8","nranxu32n83n8hnc");
eq("c:9","nranxunc");

eq("d:d","display:off");
eq("d:m","message:off");

eq("e:x","n:e8:r8:e");
eq("e:z","n:za:n");
eq("e:s","n:sp8ft4:s");

eq("e:0","n:o0:pifmw:e");
eq("e:1","n:o1w:pxfm:e");
eq("e:2","n:o2w:pxfm:e");
eq("e:3","n:o3w:pxfm:e");
eq("e:4","n:o4w:pxfm:e");
eq("e:5","n:o5w:pxfm:e");
eq("e:6","n:o6w:pxfm:e");
eq("e:7","n:o7w:pxfm:e");
eq("e:8","n:o8w:pxfm:e");
eq("e:9","n:o9w:pxfm:e");


//eq("l:c","lecture/casus");
eq("l:c","lecture/create");
eq("l:d","lecture/design");
eq("l:v","lecture/vip");



eq("l:i","lecture/imm");
eq("l:m","lecture/imm");
eq("l:1","lecture/convergence");
eq("l:2","lecture/standards");
eq("l:3","lecture/retrieval");
eq("l:4","lecture/eca");


eq("l:a","lecture/awc");
eq("l:e","lecture/eca");
eq("l:s","lecture/step");
eq("l:t","lecture/tam");

//eq("p:x","particles/try");
eq("p:t","particles/try");

eq("p:0","particles/0");
eq("p:1","particles/1");
eq("p:2","particles/2");
eq("p:3","particles/3");
eq("p:4","particles/4");
eq("p:5","particles/5");
eq("p:6","particles/6");
eq("p:7","particles/7");
eq("p:8","particles/0");
eq("p:9","particles/9");

eq("s:c","slides/casus");
eq("s:d","slides/design");


eq("s:i","slides/imm");

eq("s:1","slides/convergence");
eq("s:2","slides/standards");
eq("s:3","slides/retrieval");
eq("s:4","slides/eca");

eq("s:a","slides/awc");
eq("s:s","slides/step");
eq("s:t","slides/tam");

eq("s:j","slides/jaap");

eq("s:m","slides/masereel");
eq("s:a","slides/masereel");

eq("s:e","slides/eca");


opt("text","text/design");
opt("help","help");


eq("t:x","display:off");
eq("t:m","message:off");
eq("t:t","text:off");

eq("t:h","help");
eq("t:t",opt("text"));


eq("t:h","text/help");

eq("t:a","text/awc");
eq("t:3","text/step");

eq("t:c","text/casus");
eq("t:d","text/design");
eq("t:v","text/vip");

eq("t:t","text/tam");

eq("t:i","text/imm");
eq("t:1","text/convergence");
eq("t:2","text/standards");
eq("t:3","text/retrieval");
eq("t:4","text/eca");

eq("t:e","text/eca");





eq("v:1","1");
eq("v:2","2");
eq("v:0","0");
eq("v:3","3");
eq("v:4","4");
eq("v:5","5");
eq("v:6","6");
eq("v:7","7");
eq("v:8","8");
eq("v:9","9");

eq("v:b","back");
eq("v:u","under");
eq("v:v","video");

eq("x:0","scene:0");
eq("x:1","scene:1");
eq("x:2","scene:2");
eq("x:3","scene:3");
eq("x:4","scene:4");
eq("x:5","scene:5");
eq("x:6","scene:6");
eq("x:7","scene:7");
eq("x:8","scene:8");
eq("x:9","scene:9");




eq("x:b","back");
eq("x:c","circle");
eq("x:d","dolphin");
eq("x:e","space");
eq("x:f","flag");
eq("x:g","game");
eq("x:k","knot");
eq("x:m","morph");
eq("x:o","bulbs");
eq("x:s","spectrum");
eq("x:t","trio");
eq("x:r","running");
eq("x:u","under");
eq("x:v","video");
eq("x:w","water");
eq("x:x","x");
eq("x:z","text");

eq("w:e","water:env:off");
eq("w:w","water:off");


//eq("s:x","x");
//cm("x","r67aut");
} else return exec(x); 
return status;
}




#define sclst ((dictionary<scene>*)_sclst)


static char _helpbuf[256];

int dossier::handle(char* xtype, char* xev) {

	char ev[128]; sprintf(ev,"%s",xev);
	char type[128]; sprintf(type,"%s",xtype);

	// normalize

	if (!strcmp(type,"key")) {
		if (!strcmp(ev,"^")) strcpy(ev,"control");
		else if (!strcmp(ev,"&")) strcpy(ev,"shift");
		else if (!strcmp(ev,"!")) strcpy(ev,"return");
		else if (!strcmp(ev,"+")) strcpy(ev,"space");
		else if (!strcmp(ev,"-")) strcpy(ev,"back");
		else if (!strcmp(ev,"%")) strcpy(ev,"tab");
		else if (!strcmp(ev,"'")) strcpy(ev,"nil");
		else if (!strcmp(ev,"~")) strcpy(ev,"select");
		else if (!strcmp(ev,"?")) strcpy(ev,"choice");
		else if (!strcmp(ev,"<")) { strcpy(type,"arrow"); strcpy(ev,"left"); }
		else if (!strcmp(ev,">")) { strcpy(type,"arrow"); strcpy(ev,"right"); }
	} else if (!strcmp(type,"arrow")) {
		if (!strcmp(ev,"<")) strcpy(ev,"left");
	    else if (!strcmp(ev,">")) strcpy(ev,"right");
		else if (!strcmp(ev,"'")) strcpy(ev,"nil");
		//else if (!strcmp(type,"command")) strcpy(type,"key");
    }


	ds("neutral",0);
	 
	if (ds("control") > 0) { ds("control",ds("control")-1); }
	if (ds("shift") > 0) { ds("shift",ds("shift")-1); }
    
	if (!strcmp(type,"key") && !iopt("exec")) {
		_command[_pcm++] = _lastc = ev[0];
		_command[_pcm] = '\0';
	}

    int newmode = 1;

	if (_cmode == 'm') cm("meta:m","-");
	else cm("meta:m",fm("%c",_metac));
	cm("meta:o",fm("%c",ev[0]));
	if (_cmode == 'n') cm("meta:c",":");
	else cm("meta:c",fm("%c",_cmode));
	

	//if (_game) _game->handle(type,ev);
		if (!strcmp(type,"command")) {
		//exec(eq(ev)); // cm("button:command")
		 // cm("button:command"))); // cm("button:command")
		_help = &_helpbuf[0];
		strcpy(_help,eq(fm("cmd:%s",machine::_cmd)));
		exec(eq(machine::_cmd));
	} else if (!strcmp(ev,"nil")) {
	} else if (!strcmp(ev,"escape")) {
		exit(1);
	} else if (!strcmp(ev,"choice")) {
		ds("choice",1);
	} else if (!strcmp(ev,"select")) {
		ds("select",1);
	} else if (check(type,ev,"lbutton","down")) {
		//debug("mouse dossier",1);
		if (_lecture) _lecture->handle(type,ev);
	} else if (check(type,ev,"arrow","up")) {
		if (_game) { moving = 1; sprintf(moved,"w"); }
	} else if (check(type,ev,"arrow","down")) {
		if (_game) { moving = 1; sprintf(moved,"z"); }
	} else if (check(type,ev,"arrow","left")) {
		if (_game) { moving = 1; sprintf(moved,"a"); }
		if (!_shift() && (!_game || _ctrl())) scene::handle(type,ev);
		if (_shift()) scene::ds("walk:speed",ds("walk:speed") - 20);
	} else if (check(type,ev,"arrow","right")) {
		if (!_shift() && (_game)) { moving = 1; sprintf(moved,"d"); }
		if (_shift()) scene::ds("walk:speed",ds("walk:speed") + 20);
	} else if (!strcmp(type,"stop")) {
		moving = 0;
	
	} else if (check(type,ev,"key","space")) {
		_cmode = 'n';
		cm("meta:c",":");
		ds("neutral",1);
		moving = 0;
		if (_game) ds("shoot",1);
		if (_lecture) _lecture->handle(type,ev);
		if (_slides) {
			_slides->next(1);
			if (_shift() || _ctrl()) _slides->interval(now(),5);
		} 
		if (_text) {
            _text->next(1);
		}
	} else if (check(type,ev,"key","back")) {
		if (_lecture) _lecture->handle(type,ev);
		if (_slides) _slides->next(-1);
		if (_text) _text->next(-1);
		if (_lecture) _lecture->handle(type,ev);
	} else if (check(type,ev,"key","return")) {
		if (_lecture) _lecture->handle(type,ev);
		else if (_slides) {
			//_slides->next(1);
			_slides->rate(0);
			//_slides->state = 1;
			_slides->index(0);
			_slides->next(-1);
			_slides->scenes[2]->_idx = 0;
		}
		if (_text) {
			_text->opt("random","0");
			_text->state = 0;
		}
		
	} else if (check(type,ev,"key","tab")) {
		if (_slides) {
			 int x = _slides->iopt("hide"); //_slides->exclude();
					   _slides->propagate(fm("hide=%d",x?0:1));
			//int x = _slides->exclude();
			//_slides->exclude(x?0:1);
		}
		if (_text) {
			int x = _text->exclude();
			_text->exclude(x?0:1);
		}
		if (_lecture) _lecture->handle(type,ev);
	} else
	if (newmode && !strcmp(type,"key") ) {
		char buf[256];
		char c = ev[0];
		if (c == 'n' || c == ':' || c == ';') { _cmode = 'n'; cm("meta:c","-"); }
		else if (_cmode == 'n') switch(c) {
			case 'b':
				_cmode = c; 
				if (_cmode == 'm') { 
					ds("meta:lecture",0); 
					ds("meta:keyboard",0);
					ds("meta:particle",0);
				}
				break;;
			default: _cmode = c;  break;;
		} else if (_cmode == 'z') switch (c) {
			case 'a': iopt("active",1);  iopt("random",1);
				_sim->schedule(this,5);
				break;;
			case 's': opt("active","0"); break;;
			default: if (instring(c,"0123456789")) {
            int d = c - '0'; state = d; opt("update","1"); break;;
			}; 
		
		} else if (_cmode == 'b') switch (c) {
			case 'b': ds("select:distort",0); break;;
			case 'w': toggle_ds("b:w"); break;;
			case 'a': toggle_ds("displace:a"); break;;
			case 'z': toggle_ds("displace:z"); break;
			case 'r': cm("bgcolor","(30,0,0)"); iopt("clr",1) ;break;;
			case 'e': cm("bgcolor","(0,0,30)"); iopt("clr",2); break;;
			case 'y': cm("bgcolor","(0,30,30)"); iopt("clr",3); break;;
			case 'g': cm("bgcolor","(0.0,40,40)"); iopt("clr",0); break;;
			//case '0': cm("bgcolor","(0,0,0)"); opt("clr","0"); break;
			//case '1': cm("bgcolor","(100,100,100)"); opt("clr","0"); break;
			case 'i': toggle_ds("frame"); break;;
			case 'm': toggle_ds("movie"); break;;
			case 'x': ds("select:distort",1); break;;

			

			default:  { 
				if (ds("select:distort") && instring(c,"0123456789")) {
                     ds("video:distort",c - '0');
				} 
				
				else if (c == '0') { cm("bgcolor","(0,0,0)"); opt("clr","0"); }
				else if (c == '1') { cm("bgcolor","(100,100,100)"); opt("clr","0"); }
			   
				else if (instring(c,"0123456789")) {
					
				sprintf(buf,"%c",c);
				int fc = 10 - (c - '0');
				int whc = iopt("clr");
				if (iopt("clr") > 0)
				cm("bgcolor", fm("(%d,%d,%d)", fc * 10, fc * 10, fc * 10));
				else {
					//cm("bgcolor", fm("(%.2f,%.2f,%.2f)", fc * 0.1, fc * 0.1, fc * 0.1));
					cm("bgcolor", fm("(%d,%d,%d)", fc * 10, fc * 10, fc * 10));
				}
				//if (ds("displace:a")) ds("a",atoi(buf));
				//if (ds("displace:z")) ds("z",atoi(buf));
				 }  else 
				{ sprintf(buf,"b:%c",c); toggle_ds(buf); }
				//break;;
				  
	       };  break;; 
		} else if (_cmode == 'c') switch (c) {
			//case 's': exec("start"); break;;
			default: sprintf(buf,"c:%c",c); exec(buf); break;;
		} else if (_cmode == 'd') switch (c) {
			case 'b':
				//eq("ffect","color-blue");
				//lst("scene:5")->process("fx=color-blue");
				ds("random:mode",0);
				break;;
			case 'c':
				eq("ffect","color-color");
				lst("scene:5")->propagate("fx=color-color"); break;;
			case 'd': ds("video:choice",0); 
				break;;
			case 'e': ds("video:choice",1); break;;
			case 'i':
				eq("ffect","color-id");
				lst("scene:5")->propagate("fx=color-id"); break;;
			case 'o':
			case 'x': {
				scene* sc = lst(eq(fm("x:%c",c)));
				int d = sc->iopt("nofx");
				if (!d) sc->iopt("nofx",1); else sc->opt("nofx","0"); break;;
				}
			
			case 'm': toggle_ds("movie:transform"); break;;
			default: 
				if (instring(c,"0123456789")) {
					if (ds("video:choice")) {
						ds("video:distort",c - '0');
					} else {
				scene* sc = lst(eq(fm("x:%c",c)));
				int d = sc->iopt("nofx");
				if (!d) sc->iopt("nofx",1); else sc->opt("nofx","0");
					} break;;
			} break;;
		} else if (_cmode == 'e') switch (c) {
			//case 'x': eq("ffect","color-mix");
			//	lst("scene:5")->propagate("fx=color-mix"); 
			//	break;;
			//case 's': eq("ffect","color-id");
			//	lst("scene:5")->propagate("fx=color-mix"); 
			//	break;;
			default: sprintf(buf,"e:%c",c); exec(eq(buf)); break;;
		} else if (_cmode == 'f') switch (c) {
			//case 's': exec("start"); break;;
			   case 'r': toggle_ds("focus:stop"); break;;
			   case 's': toggle_ds("focus:stop"); break;
			default:
				if (instring(c,"0123456789")) {
				sprintf(buf,"%c",c);int i; sscanf(buf,"%d",&i);
				scene::ds("flip",1);
				scene::ds("focus",i); 
				} break;;
		
		} else if (_cmode == 'g') switch (c) {
			case 's': ds("shoot",1); break;;
			case 'x': toggle_game("game"); break;;
			case 'f': toggle_ds("donuts:fog"); break;;
			case 'r': toggle_ds("radar"); break;;
			case 'c': exec("f:0"); break;;
			case 'a': moving = moving?0:1; sprintf(moved,"a"); break;;
			case 'z': moving = moving?0:1; sprintf(moved,"z"); break;;
			case 'd': moving = moving?0:1; sprintf(moved,"d"); break;;
			case 'w': moving = moving?0:1; sprintf(moved,"w"); break;;
			case 'q': moving = moving?0:1; sprintf(moved,"q"); break;;
			case 'e': moving = moving?0:1; sprintf(moved,"e"); break;;
			default:
				if (_game) _game->handle(type,ev);
				break;;
		} else if (_cmode == 'h') switch (c) {
			case 'h': toggle_text("t:h"); //if (_text) _text->index(1); break;;

			case 'l': if (_lecture) {
				        int x = _lecture->exclude();
						_lecture->exclude(x?0:1);
					  } break;;
			case 's': if (_slides) {
				        int x = _slides->iopt("hide"); //_slides->exclude();
					   _slides->propagate(fm("hide=%d",x?0:1));
					  } break;;
			case 't': if (_text) {
				        int x = _text->exclude();
						_text->exclude(x?0:1);
					  } break;;

			default: if (instring(c,"0123456789")) {
				toggle_ds(fm("hide:%c",c));
					 }
				break;;
		} else if (_cmode == 'i') switch (c) {

			case 's': if (_slides) { 
				      _slides->rate(-1); _slides->index(0); _slides->next(-1);
					  }
					  break;;
	
			default: if (instring(c,"0123456789")) {
				sprintf(buf,"scene:%c",c);
				int i; sscanf(buf,"%d",&i);
				if (lst(buf)) lst(buf)->interval(now(),10);
				} break;;
		} else if (_cmode == 'l') switch (c) {
			default: sprintf(buf,"l:%c",c); toggle_lecture(buf); break;;
		} else if (_cmode == 'm') switch (c) {
			case 'b': toggle_ds("video:nobg"); break;;
			case 'c': toggle_ds("video:show"); break;;
			case 'd': toggle_ds("video:nowave"); break;;
			case 'e': toggle_ds("nopreview"); break;;
			case 'f': toggle_ds("no:focus"); break;;
			case 'g': toggle_ds("video:nograb"); break;;
			case 'h': toggle_ds("track:moving"); break;;
			case 'k': ds("meta:keyboard",0); 
				      _drumidx = 1; _drumpad = _drumpads[_drumidx]; break;;
			case 'l': ds("meta:lecture",1); break;;
			case 'm': ds("meta:lecture",0); 
				      ds("meta:project",0);
				      ds("meta:keyboard",0); 
					  ds("meta:particle",0);
					  ds("meta:video",0);
					  break;;
		    case 'p': ds("meta:particle",1); break;;
			case 'x': lst(eq("x:x"))->process(fm("fx=%s",eq("ffect"))); break;;
			case 'r': toggle_ds("random:mode"); break;;
			//case 'b': if (_lecture && _slides) _lecture->_slides = _slides; break;;
			//case 's': if (_lecture) _slides = _lecture->_slides; break;;
			case 's': toggle_ds("scroll"); break;;
			case 'u': toggle_ds("noslides"); break;;
			case 'v': ds("meta:video",1); break;;
			case 't': if (_text) { _text->iopt("random",1); /*_sim->schedule(_text,1);*/ } break;;
			//case 'e': exit(1); break;;
			default:
				if (_lecture && ds("meta:lecture")) {
					if (instring(c,"0123456789"))
						_lecture->opt("select",fm("%d",c-'0'-1));
					else _lecture->opt("select","0");
				} else if (_lecture && ds("meta:project")) {
					if (instring(c,"0123456789"))
						_lecture->opt("project",fm("%d",c-'0'-1));
					else _lecture->opt("project","0");
				} else if (_particles && ds("meta:particle")) {
					if (instring(c,"0123456789"))
						_particles->opt("choice",fm("%d",c-'0'));
					    _particles->opt("reset",fm("%d",1));
					    
				} else if (ds("meta:video") ) { 
					if (instring(c,"az0123456789")) {
						_cmode = c; ds("meta:video",0);
					}
				} else if (ds("meta:keyboard") ) { 
                    if (instring(c,"0123456789"))
						_drumpad = _drumpads[c - '0'];
				} else if (instring(c,"0123456789")) { 
				sprintf(buf,"%c",c);
				int i; sscanf(buf,"%d",&i);
				_drumpad->Play(i, 0, 0);
			} else _drumpad->Play(9, 0, 0);
            break;


			
		} else if (_cmode == 'o') switch (c) {
			case 'f': scene::cm("overlay:floor",cm("overlay"));
			case 'w': scene::cm("overlay:wall",cm("overlay"));
			default: if (instring(c,"az0123456789")) { //123456789")) {
				sprintf(buf,"%c",c);
				//char* f = "color-blue";
				if (c != '0') scene::cm("overlay",buf);
				//else scene::cm("overlay","nil");
				else scene::cm("overlay","active");
				//if (lst(buf)) lst(buf)->interval(now(),10);
				} break;;
		} else if (_cmode == 'p') switch (c) {
			case 'b': eq("effect","color-blue"); break;;
			case 'c': eq("effect","color-color"); break;;
			//case '0':
			case 'i': eq("effect","color-id"); break;;
			//case 'm':
			case 'x': eq("effect","color-mix"); break;;
			case 'r': eq("effect","color-red"); break;;
			case 'd': scene::cm("wall:fx",eq("effect")); break;;
			case 'w': scene::cm("wall:fx",eq("effect")); break;;
			case 'f': scene::cm("floor:fx",eq("effect")); break;;
			case 'm': scene::cm("walk:fx",eq("effect")); break;;
			case 'e': lst(eq("x:x:"))->process(fm("fx=%s",eq("ffect"))); break;;
			

			default: 
				if (instring(c,"t0123456789")) {
				sprintf(buf,"p:%c",c);
				toggle_particles(buf);
					/*
					sprintf(buf,"p:%c",c);
				if (lst(eq(buf))) lst(eq(buf)->process(fm("fx=%s",eq("ffect"))); break;;
				*/
				} break;;
		} else if (_cmode == 's') 
			
			switch (c) {
			case 'h': { 

				       int x = _slides->iopt("hide"); //_slides->exclude();
					   _slides->propagate(fm("hide=%d",x?0:1));
				      //_slides->exclude(x?0:1);
					  }; break;;
			case 'l': _slides = _lecture->_slides; 
				      //_lecture->_slides = 0;
					  break;;
		    case 'u': _slides = 0; 
				      //_lecture->_slides = 0;
					  break;;
			case 'm': ds("project:slide",0);
				      ds("factor:slide",0);
				      ds("movie:slide",1); break;;
			case 'p': ds("project:slide",1); 
				      ds("movie:slide",0);
				      ds("factor:slide",0); break;;  
			case 't': ds("factor:slide",1); break;; 
			case 's': if (_slides) _slides->rate(3); 
				      //if (_lecture) _lecture->_slides->rate(3);
				      ds("project:slide",0);
					  ds("factor:slide",0);
					  ds("movie:slide",0);
				      break;;
			case 'x': if (_slides) {
				      int xs = _slides->state;
					  if (xs == 0) _slides->state = 1;
					  else  _slides->state = 0;
					  }; break;;
			case 'f': if (_slides) {
				      ds("project:slide",0);
					  ds("movie:slide",0);
					  ds("factor:slide",0);
					  _slides->_factor = fopt("xfac");
					  //_factor = 0.8;
				      int xs = _slides->iopt("nofx");
					  if (xs == 0) _slides->iopt("nofx",1);
					  else _slides->opt("nofx","0");

					 
				      //eq("effect-slides","slides-color");
				      //_slides->process(fm("nofx=%s","0"));
					  //_slides->_shader = "slides-red";
					  //_slides->effect("slides-red");
					  }; break;;
			default: 
				if (ds("project:slide")) {
				switch(c) {
			      case 'a': cm("slides","active"); break;;
				  case 'z':	cm("slides","z"); break;;	
				  case '0': ds("project:slide",0); break;;
				  default: if (c > '0' && c <= '9') {
					          cm("slides",fm("%c",c));
							  }
				}
				} else if (ds("factor:slide")) {
					if (c == '0') ds("factor:slide",0);
					if (c > '0' && c <= '9') {
					          opt("tmpf",fm("0.%c",c));
							  
							  fopt("xfac",1.0-fopt("tmpf"));
							  _slides->_factor = fopt("xfac");
							  }
				} else if (ds("movie:slide")) {
				switch(c) {
			//case 'a': cm("slide:movie","active"); break;;
			//case 'z':	cm("slide:movie","z"); break;;	
			case '0': 
				    ds(ds("slide:movie"),0);
				    ds("movie:slide",0); 
					break;;
				  default: if (c > '0' && c <= '9') {
					  //cm("slide:movie",fm("%c",c));
					  ds("slide:movie",c - '0');
					  //ds(fm("slide:%d",c-'0'),c-'0');
					  ds(fm("movie:%d",c-'0'),c-'0');
					  _slides->iopt("ds",c-'0');
					  ds(fm("nomovie:%c",c),0);
					  }
				}
				
				} else {
					char buf[64];
					sprintf(buf,"s:%c",c); toggle_slides(buf); 
				}
					break;;	
		} else if (_cmode == 't') switch (c) {
			case 'x': toggle_ds("t:x"); break;;
			case 'm': toggle_ds("t:m"); break;;
			default: sprintf(buf,"t:%c",c); toggle_text(buf); break;;
		} else if (_cmode == 'u') switch (c) {
			      case 's': _slides = 0; break;;
				  default: if (c > '0' && c <= '9') {
					  
					  toggle_ds(fm("nomovie:%c",c));
					  //_slides->iopt("ds",c-'0');
					  }
		} else if (_cmode == 'v') switch (c) {
			case 'a': 
				scene::ds("flip",1);
			    //scene::ds("focus",0);
				break;;
			case 'p':
				scene::ds("flip",1);
			    scene::ds("focus",4);
				break;;
			case 's': toggle_ds("mode:shift"); break; // toggle_opt
			//case 'w': toggle_ds("b:w"); break;;
			default: 
				sprintf(buf,"v:%c",c); toggle_ds(buf); 
				if (ds("mode:shift")) { sprintf(buf,"shift:%c",c); toggle_ds(buf); }
				     break;;

			//toggle_ds("1");
		    //toggle_ds("shift:1");
		} else if (_cmode == 'x') switch (c) {
			case 'v': sc("slides")->interval(now(),5); toggle_lst("x:v"); break;;
			case 'w': toggle_lst("x:w"); break;;
			default: sprintf(buf,"x:%c",c); toggle_lst(buf); break;;
		} else if (instring(_cmode,"az0123456789")) switch (c) {
			//case 'a':
			case '0': 
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9': {
				char buf[64];
				sprintf(buf,"scene:%c",c);
				scene* sx = lst(buf);
				if (sx) sx->opt("tx",fm("%c",_cmode));
				} break;;
			//case 'b': scene::cm("floor:tx",fm("%c",_cmode)); break;;
			case 'b': if (1) { 
				scene* _sc = (scene*) lookup("dots"); 
				if (_sc) _sc->opt("tx",fm("%c",_cmode)); 
					  } break;;
			case 'c': scene::cm("character",fm("%c",_cmode)); break;;
			//case 'u': scene::cm("wall:tx",fm("%c",_cmode)); break;;
			case 'h': scene::cm("hall",fm("%c",_cmode)); break;;
			case 'g': scene::cm("donuts:tx",fm("%c",_cmode)); break;;
			case 'l': if (_lecture) _lecture->opt("tx",fm("%c",_cmode)); break;;
			case 'm': lst("morph")->opt("tx",fm("%c",_cmode)); break;;
			case 'p': if (_particles) _particles->opt("tx",fm("%c",_cmode)); break;;
			//case 's': if (_slides) _lecture->opt("tx",fm("%c",_cmode)); break;;
			//case 't': sc("lecture/tam")->opt("tx",fm("%c",_cmode)); break;;
			
			
			default: /*sprintf(buf,"x:%c",c); toggle_lst(buf);*/
				//f (instring(c,"fkmopvwx")) {
				if (lst(eq(fm("x:%c",c))))
					lst(eq(fm("x:%c",c)))->opt("tx",fm("%c",_cmode));
				//}
				break;;
		} else if (_cmode == 'r') switch (c) {
			case 'a': { 
        int s = 0;
		if (!iopt("exec")) {
		cm("last",_command);
		_pcm = 0; _command[_pcm] = '\0';
		}
		char* ds[] = { "character","hall","floor","wall","movie","frame", 0 };
		
		for (int i = 0; i <= 10; i++) _exclude[i] = 1;	
		iter<string>& it = *sclst;
			scene* sc = 0;
			string* p = 0;
			while (p = it()) {
				sc = (*sclst)[p];
				sc->exclude(1);
			}
		
		char* pds = 0; int k = 0;
		scene::ds("alternate",0);
		while (pds = ds[k]) {
			scene::ds(pds,1);
			k++;
		} };
		break;;
			default: {
				if (instring(c,"123456789")) {
					toggle_ds(fm("run:%c",c));
				}
					 } break;;
		} else if (_cmode == 'w') switch (c) {
			case 'b': exec("npbwfmnw"); break;;
			case 'r': exec("nprwfmnw"); break;;
			case 'i': exec("npiwfmnw"); break;;
			case 'm': exec("npmwfnw"); break;;
			case 'x': exec("nprmnpbfnwenxwnw"); break;;
			case 'z': exec(":pxmbf:we:xw:w"); break;;
			//case 'w': toggle_lst("x:w"); break;;
			default: sprintf(buf,"w:%c",c); toggle_ds(buf); break;;
	   
	
		} else 	return scene::handle(type,ev);

	 
	  
	} else 	return scene::handle(type,ev);
	wsprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}

static int _allowsim = 0;

int dossier::operator()()
{
char xbuf[128];  
if (0 && !iopt("active")) {
	_sim->passivate(this);
    _sim->schedule(this,_gn->exponential(20));
     return 0;
} else {
	float t = fopt("next"); //20.0;

int stx = 0;
static cnt = 0;
//cnt++;
int rmode = ds("random:mode");//1;
static int _smode = 0;

if (rmode) {
	if (_smode) _smode = 0; else _smode = 1;
}
//debug("operator",1);


if (0 && _smode == 0) {
	t = 10;
    stx = random(0,_total()); // max
	sprintf(xbuf,"n:f%d:n",stx);
	if (iopt("active") && !ds("no:focus")) exec(xbuf);
}
else {
	cnt++;
	stx = random(0,9);
	//if (cnt > 10) { cnt = 0; stx = 0; }
	sprintf(xbuf,"c:%d",stx);
	if (iopt("active")) exec(eq(xbuf));
}

//if (cnt > 10) cnt = 0;
//if (_mode == 0 && cnt == 0) stx = 0;


//sprintf(xbuf,"n:f%d%d:n",stx,stx);
/*
if (_smode == 0) {
	//sprintf(xbuf,"n:f%d%d:n",stx,stx);
	//if (iopt("active")) exec(xbuf);
	t = 10.0;
} else {
	//sprintf(xbuf,"c:%d",stx);
    //if (iopt("active")) exec(eq(xbuf));
}
*/
_sim->passivate(this);

//if (iopt("active")) 
_sim->schedule(this,_gn->exponential(t));
return 0;
 
} 
}

dossier::dossier(char* opts) 
{
	_metac = '-';
	_slides = 0;
	_text = 0;
	_game = 0;
	_lecture = 0;
	_particles = 0;
	alternate = 0;
	txdur = 15;
	count = 12;
	_inexec = 0;
	_cmode = 'n';
	_lastc = 'n';
	//state = 2;
	_drumpad = 0;

	_pcm = 0;
	_command[_pcm]='\0';

	opt("next","20.0");

	ch();

	//char* cs = _tk->strvalue("X:dossier(start(X)))");
	

_size = 20; //size;
wsprintf(_type,"scene");
_display = "digital dossier";

_sim->passivate(this);
_sim -> schedule(this,0.0);


end(20);
loop = 1;

//_tiny = new CCharacter();



//scenes[1] = new satelite();
//scenes[0] = new shader(new background(),"fx=back");
//scenes[0]->opt("shaders","material");
sprintf(moved,"x");
moving = 0;







_exclude[0] = 1;
_exclude[1] = 1;
_exclude[2] = 1;
_exclude[3] = 1;
_exclude[4] = 1;
_exclude[5] = 1;
_exclude[6] = 1;
_exclude[7] = 1;
_exclude[8] = 1;
_exclude[9] = 1;
_exclude[10] = 1;



//scenes[2]->scale(0.3,0.3,0.3);




//scale(0.8,0.8,0.8);



 

 
  
}




dossier::~dossier()
{
//delete scenes[];
}

int 
dossier::_load()
{
    int hr = S_OK;

	_drumidx = 0;

	ds("in:dossier",1);

	opt("text:head:x","panorama field test");
	opt("text:scroll:1:x","dossier test dossier test");
	//opt("text:scroll:2","self reflections panorama casual encounters panorama self reflections panorama casual encounters panorama");
	opt("text:scroll:2:x","creativity convergence productivity literacy quality immersion "); // self reflections panorama casual encounters panorama");

	//if (_initialized) return hr;
	//_initialized = 1;

	for(int i = 0; i < 10; i++) {
	_drumpad = _drumpads[i] =  new DrumPad();
	_drumpad->Initialize( NUM_ACTIONS, (HWND) scene::ptr("VP","window")); //hwnd );
	
	//wsprintf( strFile, TEXT("d:/vip/media/desktop/evil-begin.wav")); //, strMediaPath );
    _drumpad->Load( 1, TEXT(loc("/vip/media/desktop/evil-begin.wav") ));
	_drumpad->Load( 0, TEXT("d:/vip/media/desktop/pr-end.wav") );
	_drumpad->Load( 2, TEXT("d:/vip/media/desktop/drumpad-bass_drum.wav") );
	_drumpad->Load( 3, TEXT("d:/vip/media/desktop/drumpad-crash.wav") );
	_drumpad->Load( 4, TEXT("d:/vip/media/desktop/drumpad-hhat_down.wav") );
	_drumpad->Load( 5, TEXT("d:/vip/media/desktop/drumpad-hhat_up.wav") );
	_drumpad->Load( 6, TEXT("d:/vip/media/desktop/drumpad-rim_reverb_10.wav") );
	_drumpad->Load( 7, TEXT("d:/vip/media/desktop/drumpad-snare_drum.wav") );
	_drumpad->Load( 8, TEXT("d:/vip/media/desktop/drumpad-voc_female_ec.wav") );
	_drumpad->Load( 9, TEXT("d:/vip/media/desktop/chimes.wav") );
	}

	_drumpad = _drumpads[0];

	//_drumpad->Play(BASS_DRUM, 0, 0);
	
    //if (cm("dossier(start)")) { eq("start",cm("dossier(start)")); }
    //debug(eq("start"),1);
    //scenes[0] = sc("lecture/dossier");
	scenes[0] = sc("vip/xml");
	_exclude[0] = 0;
	/*
	scenes[6] = sc("vip/trio");
	scenes[7] = sc("anim/trio");
    scenes[8] = sc("effect/spectrum");
	scenes[8]->_blend = 1;
    scenes[10] = sc("vip/water");
	scenes[9] = sc("vip/flag");
*/
	iopt("start",1);

	scene* scx = new mesh("sphere");
    lst("circle",new shader(scx,"fx=project-color"));
    lst("circle")->translation(1.5,0,0);
    lst("circle")->scale(0.3,0.3,0.3);
	lst("circle1",new shader(scx,"fx=color-blue"));
	lst("circle2",new shader(scx,"fx=color-red"));
	lst("circle3",new shader(scx,"fx=color-color"));
	lst("circle4",new shader(scx,"fx=color-mix"));

	lst("particle/text",sc("particle/text"));
	lst("particle/try",sc("particle/try"));
	lst("particles/try",sc("particles/try"));
	lst("particles/0",sc("particles/0"));
	lst("particles/1",sc("particles/1"));
	lst("particles/2",sc("particles/2"));
	lst("particles/3",sc("particles/3"));
	lst("particles/4",sc("particles/4"));
	lst("particles/5",sc("particles/5"));


    lst("text",sc("text/casus")->create());
    _sim->schedule(lst("text"),0);

  

	scene* s = lst("text")->sc("slides");
	popt("slides",s);
	//scene* v = new video(s);
	//v->opt("type","2");
	//v->opt("name","..\\media\\isabelle.avi");
	//v->opt("name","d:\\video\\clockwork.avi");
	lst("video",new slides());
	//s->opt("tx","a");

    scene* x = sc("lecture/wave");//->create();
	x->iopt("tx",5);
	//v = new video(x);
	//v->opt("type","2");
	//v->opt("name","..\\media\\isabelle.avi");
	//v->opt("name","d:\\video\\clockwork.avi");
	lst("under",x);

	x = sc("scene/3")->create();
	//v = new video(x);
	//v->opt("type","2");
	//v->opt("name","..\\media\\isabelle.avi");
	//v->opt("name","d:\\video\\clockwork.avi");
	lst("back",x);
	x->opt("tx","a");

	lst("trio", sc("vip/trio"));
	lst("running", sc("anim/trio"));

	lst("help",sc("text/help"));
	lst("knot",sc("dossier/knot"));
	lst("flag",sc("vip/flag"));
	lst("morph",sc("vip/morph"));
	lst("water",sc("vip/water"));
	lst("spectrum",sc("effect/spectrum"));
	lst("spectrum")->_blend = 1;
	lst("x",sc("x/seafloor"));
	lst("dolphin",sc("vip/dolphin"));
	lst("game",sc("vip/game")->create("scene=vip/donuts"));

	lst("space",sc("vip/space"));

	s  = new satelite("mesh=circle");
    s->translation(1.0,1.0,0);
    s->scale(0.01,0.01,0.01);
	scene::declare("x/bulbs",s);
	lst("bulbs",sc("x/bulbs"));

	
	char* pls[] = {
		"imm", "convergence", "standards", "retrieval", "environments", 
		"casus", "design","create",
        "eca", "awc", "step",
		"tam", "vip", 
		0 };
    int i = 0; char* p = 0;
	while (p = pls[i]) {
		i++;
		char* pl = fm("lecture/%s",p);
		char* pt = fm("text/%s",p);
		char* ps = fm("slides/%s",p);
        if (sc(pl)) lst(pl,sc(pl));
	    if (sc(pt)) lst(pt,sc(pt)->create());
		if (lst(pt)) _sim->schedule(lst(pt),0);
		if (lst(pt)) lst(ps,lst(pt)->sc("slides"));
		//if (lst(pl)) lst(pl)->opt("tx","active");
		if (lst(ps)) lst(ps)->opt("tx","a");
		//if (lst(ps)) lst(ps)->opt("tx","z");
	}

	lst("slides/jaap", new slides("..\\present\\images\\jaap","img0",1,10,"jpg"));
	lst("slides/game", new slides("..\\present\\images\\game","img0",0,5,"jpg"));
	lst("slides/masereel", new slides("..\\present\\images\\masereel","img0",1,21,"jpg"));
	

	lst("scene:0",sc("scene/0"));
	lst("scene:1",sc("scene/1"));
	lst("scene:2",sc("scene/2"));
	//lst("scene:2")->opt("fx","color-red");
	lst("scene:3",sc("scene/3"));
	lst("scene:4",sc("scene/3x"));
	//lst("scene:5",sc("scene/x")->create());
	lst("scene:5",sc("vip/display")->create());

	/*
    lst("morph")->exclude(1);
	lst("morph")->exclude(1);
	lst("flag")->exclude(1);
	lst("water")->exclude(1);
	lst("spectrum")->exclude(1);
	lst("knot")->exclude(1);
	lst("x")->exclude(1);
	//lst("dolphin")->exclude(1);
	*/
	_lst = 1;
	//lst("morph")->exclude(1);
    
	dolphin = ((dxscene*) dvscene::lookup("menu/dots"))->scenes[10];
	lst("dolphin",dolphin);
	//handle("key","n");
	//handle("key","r");
	//handle("key","a");
	//handle("key","n");

    //lst("slides")->exclude(0);
    //_cmode = 'n';
	exec("nran");

	hr = scene::init(_device); // loops through scenes

	//exec("nran");
	char* k = "dossier";
	char* cat =  _tk->strvalue("X:category(X)");
	char* sel = _tk->strvalue("X:selection(X)");

    if (ds("debug:program")) debug(fm("category = %s; program = %s",cat, sel),1);

	eq("category",cat);
	eq("program",sel);
    
	eq("display",fm("%s %s",cat,sel));
	eq("help","");

    scene:;declare("dossier",this);
	scene::declare("this",this);

	char* q;

	int already = ds("already");

	if (!already) {
	ds("alrady",0);
    declare("this",this);

	_flt = parser::lookup("dossier-ml");
	

	

	_tk->eval(fm("X:ds(%s,X)",sel));
	if (1) while (q = _tk->result()) {
		attribute p(q);
		ds(p.key(),atoi(p.value()));
		if (ds("debug:ds")) debug(fm("ds:  %s = %d",p.key(),atoi(p.value())),1);
	    }

	//if (_flt) _flt->soinc(loc("/vip/cfg/startup/text/dossier.txt"));
	if (_flt) _flt->soinc(loc("/vip/cfg/vip.cfg"));
	}
	
	_tk->eval(fm("X:eq(%s,X)",sel));
	if (1) while (q = _tk->result()) {
		attribute p(q);
		if (ds("debug:eq")) debug(fm("eq:  %s = %s",p.key(),p.value()),1);
		eq(p.key(),p.value());
	    }

	//if (_flt) _flt->soinc("dossier.txt");
		
	_tk->eval(fm("X:cm(%s,X)",sel));
	if (1) while (q = _tk->result()) {
		attribute p(q);
		cm(p.key(),p.value());
		if (ds("debug:cm")) debug(fm("cm:  %s = %s",p.key(),p.value()),1);
	    }



	_tk->eval(fm("X:opt(%s,X)",sel));
	if (1) while (q = _tk->result()) {
		attribute p(q);
		opt(p.key(),p.value());
		if (ds("debug:opt")) debug(fm("opt:  %s = %s",p.key(),p.value()),1);
	    }

	_tk->eval(fm("X:lst(%s,X)",sel));
	if (1) while (q = _tk->result()) {
		attribute p(q);
		lst(p.key(),sc(p.value()));
		if (ds("debug:lst")) debug(fm("lst:  %s = sc(%s)",p.key(),p.value()),1);
	    }

	_tk->eval(fm("X:shader(%s,X)",sel));
	if (1) while (q = _tk->result()) {
		attribute p(q);
		//debug(fm("shader:  lst(%s)->effect(%s)",p.key(),p.value()),1);
		//lst(p.key())->_shader = p.value();
		if (ds("debug:shader")) debug(fm("shader:  lst(%s)->effect(%s)",p.key(),p.value()),1);
	    }

//_drumpad->Load( 1, TEXT("d:/vip/media/desktop/evil-begin.wav") );
    int maxs = 10;
	for (int i=0; i < maxs; i++) {
	for (int j = 0;  j < 10; j++) {
    q = _tk->strvalue(fm("X:sound(%s,%d,%d,X)",sel,i,j));
		if (q && ds("debug:sound")) debug(fm("sound: (%d) %d = %s",i,j,q),1);
		//_drumpad->Load( j, TEXT(q) );
		if (q) _drumpads[i]->Load( j, q );
	    }
	}

	char* msg = _tk->strvalue(fm("X:start(%s,X)",sel));
	if (ds("debug:start")) debug(fm("start(%s) = %s",sel,msg),1);
	eq("start(dossier)",msg);
	
    _display = eq("display");
	_help = eq("help");

	_a = 255; 
    _r = _g = _b = 125;
	_hx = 800;
    _hy = 350;
	_ksx = 1024;
    _sx = _ksx;
    _sy = 550;
	_si = iopt("speed:1"); //4;

	
    _ssx = _ksx;
    _ssy = 600;
	_ssi = iopt("speed:2"); //7;

	_once =1;

	opt("text:head:x",unquote(opt("text:head")));
	opt("text:scroll:1:x",unquote(opt("text:scroll:1")));
	//opt("text:scroll:2","self reflections panorama 
	opt("text:scroll:2:x",unquote(opt("text:scroll:2"))); 

	opt("text:head",opt("text:head:x"));
	opt("text:scroll:1",opt("text:scroll:1:x"));
	opt("text:scroll:2",opt("text:scroll:2:x"));

	ds("nopreview",0); //AE
    return hr;
}

int
dossier::_restore()
{
    HRESULT hr = S_OK;
    float txtime = txdur;
	if (ds("alternate")) {
	static float tm = dxtime();
	if ((dxtime() - tm) > txtime) { tm = dxtime(); scene::ds("flip",1); } //_main()->iopt("flip",2);  }
	}

	//if (iopt("start")) { opt("start","0"); exec("start"); }
	if (iopt("start")) { opt("start","0"); exec(eq("start(dossier)")); }

	if (0 && scenes[0]) {
		_handler(scenes[0]);
	} else {
		//_handler(this);
    }
	


    return hr;
}


int
dossier::_render( ) 
{
HRESULT hr = S_OK;

    if (_game && moving) _game->handle("key",moved);
   
   
    dolphin->state = 1;
	render_begin(_device);
	_exclude[0] = 0;
	//_tiny->Compose((DWORD) 1000 * fraction());
	//scenes[1]->rotation(sin(dxtime()),sin(dxtime()),cos(dxtime()),1);
    CCritSec m_cs;
	CAutoLock lock(&m_cs);
    //CComPtr< IDirect3DSurface9> lpS;
	if (ds("xmlrpc")) {
		this->exec(_main()->eq("xmlrpc"));
		ds("xmlrpc",0);
	}

    //check_cs();
    //CAutoLock lock(_cs);
	int xS = 0, xL = 0, xD = 0;
	if (1) {
	_texture = tx("1");
    D3DSURFACE_DESC ddsd;
	hr = _texture->GetLevelDesc( 0, &ddsd );
	_format = ddsd.Format;
    _width = ddsd.Width;
    _height = ddsd.Height;
	
	static BYTE*  buffer = new BYTE[800*600*4];
	_buffer = (void*) buffer;
	BYTE* pbuf = buffer;
	BYTE* tbuf = NULL;

	int row;
    int col;

	RECT rcDst;
    RECT rcSrc;

	ZeroMemory( &rcSrc, sizeof(RECT));
    rcSrc.right = _width;
    rcSrc.bottom = _height;
	
	IDirect3DSurface9 *pS = 0;
	HRESULT hx = _texture->GetSurfaceLevel(0,&pS);
	if (hx == D3D_OK) xS = 1;
    HRESULT hg = -23;
	D3DLOCKED_RECT LR;
    ZeroMemory( &rcSrc, sizeof(D3DLOCKED_RECT ));
	//if (hx) hg = pS->LockRect(&LR,&rcSrc,D3DLOCK_DONOTWAIT);
	if (hx) hg = pS->LockRect(&LR,0,0);
	HRESULT hd = -23;;
	if (hg) hd = pS->GetDesc(&ddsd);
	if (hd == D3D_OK) {
		xD = 1;
		_format = ddsd.Format;
        _width = ddsd.Width;
        _height = ddsd.Height;
	}
		

	
    if (hg == D3D_OK) xL = 1;
	else if (hg == D3DERR_INVALIDCALL) xL = -1;
	else if (hg == D3DERR_WASSTILLDRAWING) xL = -2;

	int lpitch = 0;
	int  psize = 0;
	if (xL == 1) { 
		lpitch = (int) LR.Pitch;  
		//psize = sizeof(d3dlr.pBits); 
	    tbuf = static_cast<byte *>(LR.pBits);
   

	    //_buffer = (void*) d3dlr.pBits;


	if( 0 && _format == D3DFMT_A8R8G8B8 )
        {
			_buffer = (void*) buffer;
            for(row = 0; row < _height; row++ ) 
			//for(row = _height-1; row >= 0; row-- ) 
            {

                BYTE *told = tbuf;
                BYTE *pold = pbuf;   
				//pTextureBuffer += lTexturePitch;

                for (col = 0; col < _width; col++) 
                {
                    unsigned char a = *(tbuf++);
                    unsigned char r = *(tbuf++);
		            unsigned char g = *(tbuf++);
		            unsigned char b = *(tbuf++);
					*(pbuf++) = a;
		            *(pbuf++) = r; //r;
		            *(pbuf++) = g; //g;
		            *(pbuf++) = b; //b;
					*(tbuf-4) = (long) 0;
				}

                //pSampleBuffer  = pBmpBufferOld + lSamplePitch;
                tbuf = told + lpitch;
            }  

        }
	}
	if (xL) hg = pS->UnlockRect();
	}

	
	
	_device->SetTexture( 0, _texture );
  
	hr = scene::_render(); // calls compose, restore,  render


    
    //_selection = 0;

	
	if (1) {
	    float dim = 0.7;
		//if (opt("parser:log")) scene::_log(opt("parser:log"));
		char* _cmd = machine::_cmd;
		if (!ds("message:off")) message(100,_y-200,argb(255*dim,255*dim,120*dim,120),
		//if (!ds("message:off")) message(100,_y-200,argb(255,255,120,120),
		fm("%s [%d] (%c) {%d/%d} [%s=%s]                                %s",
		_help,state,_cmode,iopt("active"),
		ds("random:mode"),eq(fm("cmd:%s",_cmd)),
		eq(_cmd),scene::_log())); //execbuf)); //,_command));
        if (0 && !ds("message:off")) message(500,_y-170,argb(200*dim,200*dim,200*dim,120),
			fm("(%d/%d/%d)[%d/%d] %s:%s",xS,xL,xD,_width,_height,
			_main()->eq("xmlrpc:no"),_main()->eq("xmlrpc")));  
		if (1 && !ds("message:off")) message(300,_y-170,argb(200*dim,200*dim,200*dim,120),
			// fm("%d: [%d/%d] (%d/%d/%d)[%d/%d]  %s: %s",
			fm(" %d: [%d/%d] %s: %s",
			scene::ds("socket"),
			ds("video:choice"),
			ds("video:distort"),
			// xS,xL,xD,_width,_height, 
			_main()->eq("xmlrpc:no"),_main()->eq("xmlrpc")));  

	} 

	if (1) {
		for (int i = 1; i <= 26; i++) {
			int cw = 35; //
			int yoff = height() / 50.3;
			cw = width() / 30;
			message(width() - (i * cw), 15, argb(130,130,130,130),fm("%c",'z'-(i-1)));
		}
	}

	if (1) {
		for (int i = 1; i <= 9; i++) {
			int cw = 35; //
			cw = width() / 9.75; //105; //width() / 30;
			int b = i;
			int yoff = height() / 7.5;
			if (b == 10) b = 0;
			//if (!tx(i)) 
				message(width() - (cw/3) - 0.5 * cw - ((i-1) * cw), height()-yoff, argb(130,130,130,130),fm("%d",b));
		}
	}
	
	if (ds("scroll")) {


	_small()->message(_hx,_hy,argb(_a,_r+20,_g,_b), opt("text:head"));
	_large()->message(_sx,_sy,argb(_a,_r+80,_g+100,_b+100), opt("text:scroll:1"));
	_plain()->message(_ssx,_ssy,argb(_a,_r+120,_g+50,_b+50), opt("text:scroll:2"));

int _kx = 0;
int _ls1 = strlen(opt("text:scroll:1")) * 23;
_sx -= _si; 
_kx = _sx + _ls1;
while (_kx < _ksx) { 
	//_large()->message(_kx,_sy,argb(_a,_r+50,_g,_b), opt("text:scroll:1"));
	_large()->message(_kx,_sy,argb(_a,_r+60,_g+80,_b+80), opt("text:scroll:1:x"));
	_kx += _ls1;
     }
if (_sx < -_ls1) _sx = 0;

int _ls2 = strlen(opt("text:scroll:2")) * 16;
_ssx -= _ssi; 
_kx = _ssx + _ls2;
while (_kx < _ksx) { 
	//_plain()->message(_kx,_ssy,argb(_a,_r+50,_g+50,_b+50), opt("text:scroll:2"));
	_plain()->message(_kx,_ssy,argb(_a,_r+100,_g+40,_b+40), opt("text:scroll:2:x"));
	_kx += _ls2;
     }
if (_ssx < -_ls2) _ssx = 0;
}
	

	if (!ds("display:off")) display(_display);
    //dolphin->state = hold;
	render_end(_device);

 

    return hr;
}

