#include <hush/source.h>
#include "image.h"
#include "scene/util.h"
#include <objbase.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
//#include <comdef.h>
//#include <atlbase.h>
//#include <commdlg.h>
#include <tchar.h>

#include <d3dx9.h>
#include "common/D3DUtil.h"
#include "common/DXUtil.h"
//#include "D3DEnumeration.h"
//#include "D3DSettings.h"
//#include "D3DApp.h"
//#include "D3DFile.h"
//#include "D3DFont.h"


#define _UNICODE


//const DWORD FVF = (D3DFVF_XYZRHW | D3DFVF_TEX1);
const DWORD FVF = ( D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1 );

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

image::image(char* s)
{
	init();
	

	if (s) { // image
	    //state = 1;
	    _image = s;
		
	}
	init();
}

scene* image::create(char* opts) { return new image(opts); }

image::image(TCHAR* path, TCHAR* name, int from, int to, TCHAR* ext) {
init();
	_path = path;
_name = name;
_from = from;
_to = to;
_ext = ext;

}


void image::init() {
_image = 0;
_path = 0;
_name = 0;
_from = 0;
_ext = _T("jpg");
_to = 0;
_imgtexture = 0;
//_cnt = 0;
//_idx = -1;
//_rate = 0;
//_xtime = 0;

//for (int i = 0;  i < MAXTEXTURES; i++) _textures = 0;

    float off = -1.0f;

	m_vertices[0].position = CUSTOMVERTEX::Position(-1.0f,  1.0f, off + 0.0f); // top left
    m_vertices[1].position = CUSTOMVERTEX::Position(-1.0f, -1.0f, off + -1.5f); // bottom left
    m_vertices[2].position = CUSTOMVERTEX::Position( 1.0f,  1.0f, off + 0.0f); // top right
    m_vertices[3].position = CUSTOMVERTEX::Position( 1.0f, -1.0f, off + -1.5f); // bottom right

    // set up diffusion:
 /*
	m_vertices[0].color = 0xfffffff; // 0xffffffff;
    m_vertices[1].color = 0xfffffff; //0xff0000ff;
    m_vertices[2].color = 0xfffffff; //0xffffffff;
    m_vertices[3].color = 0xfffffff; // 0xff0000ff;
*/
		m_vertices[0].color =  0xffffffff;
    m_vertices[1].color = 0xff0000ff;
    m_vertices[2].color = 0xffffffff;
    m_vertices[3].color = 0xff0000ff;

    // set up texture coordinates
    m_vertices[0].tu = 0.0f; m_vertices[0].tv = 0.0f; // low left
    m_vertices[1].tu = 0.0f; m_vertices[1].tv = 1.0f; // high left
    m_vertices[2].tu = 1.0f; m_vertices[2].tv = 0.0f; // low right
    m_vertices[3].tu = 1.0f; m_vertices[3].tv = 1.0f; // high right
}

image::~image()
{

}

//int image::index() { return _idx; }
//void image::index(int k) { if (k < _cnt) _idx = k; else _idx = 0; }

HRESULT 
image::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;


    m_vertexBuffer = NULL;


    hr = device->CreateVertexBuffer(sizeof(m_vertices),
		//0,FVF,D3DPOOL_DEFAULT,& m_vertexBuffer.p, NULL );
	0,FVF,D3DPOOL_DEFAULT,& m_vertexBuffer, NULL );

	 
    if (_image) {
	if( FAILED( D3DUtil_CreateTexture( device, _image,
		&_imgtexture) ) ) {
		//ASSERT(10!=10);
        return 0;
	}
	}

	if (_path && _name) {
		int k = 0;
		for(int i = _from; i <= _to; i++) {
			char buf[1024];
			if (i < 10) wsprintf(buf,TEXT("%s\\%s0%d.%s"),_path,_name,i,_ext);
			else wsprintf(buf,TEXT("%s\\%s%d.%s"),_path,_name,i,_ext);
			hr = D3DUtil_CreateTexture( device, (TCHAR*)buf,&_textures[k]);
			if (!FAILED(hr)) k++;
			//else //ASSERT(9!=9);
			//MessageBox(0,buf,"odyssee",MB_OK);
		}
		if (k > 0) _idx = 0; else _idx = -1;
		_max = k;
		//image = path; //??
	}

	hr = scene::init(device);
    //m_time = GetTickCount();

	 void* pData;
    FAIL_RET( m_vertexBuffer->Lock(0,sizeof(pData), &pData,0) );
    memcpy(pData,m_vertices,sizeof(m_vertices));  
	//ASSERT(0);
    FAIL_RET( m_vertexBuffer->Unlock() ); 

    return hr;
}

HRESULT 
image::restore(IDirect3DDevice9* device)
{
	HRESULT hr = S_OK;


	
   

	return hr;
}

int image::next(int t) { 
	int x = t==0?1:t; _idx += x;
    if (_idx >= _max) _idx = 0;
	if (_idx < 0) _idx = 0;
	return _idx;
}

HRESULT 
image::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
    HRESULT hr = S_OK;
	if (opt("tx")) _texture = tx(opt("tx"));
	if (_texture) texture = _texture;
	_texture = texture;
 
    //char buf[512];
	//wsprintf(buf,"movie");

	render_begin(device);


    //_idx = 0;
	// Set up texture stage states for the image
    //device->SetTexture( 0, 0 );
	if (_max > 0 && _path) {// && _idx >= 0 ) {
		//_event = 1;
		//if (0 && event()) { _idx++; index(_idx);
		//wsprintf(buf,"%s: %d (%1.1f) %0.2f",_path,_idx,(float)_rate,
		//			(float) delta());
		//}
		if (state == 0 && _rate > 0.001) {
			_elapsed += delta();

			if (_elapsed > _rate) {
				_elapsed = 0;
				_idx++; index(_idx);
				if (_idx >= _max) _idx = 0;
				
				//wsprintf(buf,"%s: %d (%1.1f) %0.2f",_path,_idx,(float)_rate,
				//	(float) delta());
			}
		}
		if (_idx >= _max) _idx = 0;
		if (_idx >= 0) device->SetTexture(0, _textures[_idx]);
		_texture = _textures[_idx];
		if (iopt("ds")) {
		tx("slide:movie",_texture);
		cp(ds("slide:movie"),_texture);
		tx(ds("slide:movie"),_texture);
		//cp(opt("ds"),_texture);
		tx(fm("movie:%d",iopt("ds")),_texture);
		cp(fm("movie:%d",iopt("ds")),_texture);
		}
		//tx(ds("slide:movie"),_texture);
	}
	else if (_image && _imgtexture) {
	       device->SetTexture( 0, _imgtexture );
		   _texture = _imgtexture;
	} else device->SetTexture( 0, texture );
	
	//wsprintf(buf,"%s: %d (%1.1f) %0.2f",_path,_idx,(float)_rate,
	//				(float) delta());
		
	device->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
	device->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1 );

		
    hr = device->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_MODULATE);
    hr = device->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE);
    hr = device->SetTextureStageState(0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE);
    hr = device->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
    

	if (!iopt("hide")) {
	
	_effect = 0; //scene::fx(g_index);
			//_effect = scene::fx(g_index);
	char* s = opt("effect");
	if (s) _effect = scene::fx(s); //s);
    //_effect = scene::fx("color-red"); //s);
	if (_effect) {
		update_effect();

		
         UINT iPass, cPasses;
		 hr = _effect->Begin(&cPasses, 0);
		
        
        for (iPass = 0; iPass < cPasses; iPass++)
        {
          hr = _effect->BeginPass(iPass);
           
		 
		hr = device->SetFVF( FVF ) ;
    //hr = device->SetStreamSource(0, m_vertexBuffer.p, 0,
	//	                              sizeof(image::CUSTOMVERTEX)  ); 	
	hr = device->SetStreamSource(0, m_vertexBuffer, 0,
		                              sizeof(image::CUSTOMVERTEX)  ); 	
    device->DrawPrimitive(D3DPT_TRIANGLESTRIP,0,2);  //draw quad 
		
        _effect->EndPass();
	 } 

     _effect->End();

	} else {

	hr = device->SetFVF( FVF ) ;
    //hr = device->SetStreamSource(0, m_vertexBuffer.p, 0,
	//	                              sizeof(image::CUSTOMVERTEX)  ); 	
	hr = device->SetStreamSource(0, m_vertexBuffer, 0,
		                              sizeof(image::CUSTOMVERTEX)  ); 	
    device->DrawPrimitive(D3DPT_TRIANGLESTRIP,0,2);  //draw quad 

	}

	}
    //char buf[256];
	//wsprintf(buf,"effect [%d]: %s", scene::fx(opt("fx"))?1:0, opt("effect"));
	//message(_rx,_ry,0xff1ff1ff0,buf);
	render_end(device);

    return hr;
}

void
image::rectangle( float fTU, float fTV )
{
	if (!_image && !_path) {
    m_vertices[0].tu = 0.0f; m_vertices[0].tv = 0.0f; // low left
    m_vertices[1].tu = 0.0f; m_vertices[1].tv = fTV;  // high left
    m_vertices[2].tu = fTU;  m_vertices[2].tv = 0.0f; // low right
    m_vertices[3].tu = fTU;  m_vertices[3].tv = fTV;  // high right
	}
}
