#include <hush/source.h>

#include "slides.h"

// sub scenes

//#include "objects/cylinder-scene.h"
//#include "objects/plane-scene.h"
//#include "objects/background-scene.h"
//#include "objects/image-scene.h"
//#include "objects/sub-scene.h"
//#include "odyssee/scene-1.h"
//#include "objects/movie-scene.h"
#include "scene/image.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

scene* slides::create(char* opts) {
	return new slides(opts);
}

slides::slides(char* lect, char* fm, int b, int no, char* ext) 
{

_end = 10;
loop = 0;
fopt("xfrac",1.1);
fopt("frac",0.75);
fopt("trans",0.1);
//scale(0.9f,0.9f,0.9f);
//translation(100,100,0);
//rotation(1.0f,0.0f,0.0f,0.5f);
_x = 400; _y = 400;

opt("dir",lect);
opt("base",fm);
iopt("start",b);
iopt("end",no);
opt("ext",ext);



}


slides::slides(char* img) 
{

process(img);

}



void slides::_init() {

_end = 10;
loop = 0;
fopt("xfrac",1.1);
fopt("frac",0.75);
fopt("trans",0.1);
//scale(0.9f,0.9f,0.9f);
//translation(100,100,0);
//rotation(1.0f,0.0f,0.0f,0.5f);
_x = 400; _y = 400;

_idx = 0;
count = 4;
_exclude[0] = 1; //0
_exclude[1] = 1; //0
_exclude[2] = 0; 
_exclude[3] = 0; //0 
_exclude[4] = 0;
_exclude[5] = 0;
_exclude[6] = 0;


_shader = "slides";
iopt("nofx",1);
//scenes[0] = new background_scene();
iopt("overlay",1);

scenes[0] = new image();
scenes[0]->translation(0.0f,0.61f,1.0f);
scenes[0]->scale(1.5,1.5,1.5);

scenes[1] = new image();// cylinder_scene();
//scenes[1] = new movie_scene("C:\\AE\\media\\pictures\\storm","storm",1,19,"jpg");



scenes[3] = new image();
scenes[3]->translation(0.0f,1.2f,-0.2f);
    //scenes[1]->rotation(1.0f,1.0f,0.0f,0.5f); // this is naive rotation
scenes[3]->scale(1.0f,1.0f,1.0f);  
//scenes[1]->rate(3.0); 
//scenes[1]->mode(0); // 0 = absolute
scenes[2]->_x = 500;
scenes[2]->_y = 450;

_slides = scenes[2];


}

//int slides::next(int t) { return _idx = scenes[2]->next(t); }

slides::~slides()
{
//delete scenes[];
}

HRESULT 
slides::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

	if (opt("img")) {
char* img = opt("img");
_end = 10;
loop = 0;
//scale(0.9f,0.9f,0.9f);
//translation(100,100,0);
//rotation(1.0f,0.0f,0.0f,0.5f);
_x = 400; _y = 400;


//scenes[2] = new image("..\\present\\imm-intro","img0",1,6,"jpg");
//scenes[2] = new image(buf,"img0",b,no,"jpg");
scenes[2] = new image(img);


//scenes[1] = new movie_scene(".\\pictures\\storm","storm",1,5,"jpg");
//scenes[2]->mode(0); // 0 = absolute
scenes[2]->translation(0.0f,1.2f,0.0f);
    //scenes[1]->rotation(1.0f,1.0f,0.0f,0.5f); // this is naive rotation
scenes[2]->scale(1.0f,1.0f,1.0f);  
scenes[2]->rate(3.0);  
	} else {


		//scenes[2] = new image("..\\present\\imm-intro","img0",1,6,"jpg");
//scenes[2] = new image(buf,"img0",b,no,"jpg");
//scenes[2] = new image(lect,"img0",b,no,ext);
scenes[2] = new image(opt("dir"),opt("base"),iopt("start"),iopt("end"),opt("ext"));


//scenes[1] = new movie_scene(".\\pictures\\storm","storm",1,5,"jpg");
//scenes[2]->mode(0); // 0 = absolute
scenes[2]->translation(0.0f,1.2f,0.0f);
    //scenes[1]->rotation(1.0f,1.0f,0.0f,0.5f); // this is naive rotation
scenes[2]->scale(1.0f,1.0f,1.0f);  
scenes[2]->rate(3.0);  
	}
    _init();
	// anything else ?

	hr = scene::init(device); // loops through scenes

		 // Turn off culling
    device->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );

    // Turn off D3D lighting
    device->SetRenderState( D3DRS_LIGHTING, FALSE );

    // Turn on the zbuffer
    //device->SetRenderState( D3DRS_ZENABLE, TRUE );
	
	//load_effect("slides-red");
    return hr;
}

HRESULT 
slides::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

	if (state == 1) {
		translation(0,fopt("ytrans"),0);
	} else {
		translation(0,fopt("ytrans0"),0);
	}

    scenes[2]->opt("ds",opt("ds"));

    return hr;
}


HRESULT 
slides::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;


if (opt("tx") && tx(opt("tx"))) _texture = tx(opt("tx"));
if(_texture) texture = _texture;


//if (ds("slide:movie") && iopt("slide:movie")) 
//tx("slide:movie",_texture);
	
if (state == 1) {
//scenes[2]->rate(0);
//scenes[2]->index(_idx);
}

	
    float f = fraction();
	if ( (1.0 - f) < 0.5 ) _exclude[3] = 1; else _exclude[3] = 0;
	if (state == 1) {
	scenes[2]->scale(f*fopt("xfrac"),f*fopt("yfrac"),0.5 + 0.5 * f);
	
	} else  {
    scenes[2]->scale(f*0.5,f*fopt("yfrac0"),0.5 + 0.5 * f);
	} 
	//scenes[2]->translation(0,-0.2,0);
	scenes[3]->scale(1.0-2.0*f,1.0-2.0*f,1.0 - 2.0 * f * 0.5);
	//scenes[2]->rotation(1,0,0,f);

	render_begin(device);
	

    // begin the slides


	hr = scene::render(device,texture); // calls restore, compose, render

    _texture = scenes[2]->_texture; 
	//char buf[256];
	//wsprintf(buf,"index: %d",_idx);
	//message(_rx,_ry,0xff1ff1ff0,buf);
	render_end(device);

    

    return hr;
}

