#include <hush/source.h>
#include "scene/find.h"
#include <windows.h>
#include <atlbase.h>
#include <d3d9.h>


#include "scene/scene.h"
#include "scene/main.h"
#include "scene/video.h"

#include <comutil.h>
#include <assert.h>
//#include <hush/hush.h>
#include <hush/query.h>
#undef text
//#include <hush/sim/simulation.h>
#include <scene/sim.h>

#undef text
#undef query
#define query dvquery


//int IO::silent = 0;

static int count = 0;
static IDirect3DDevice9*  _device = 0;
static IDirect3DTexture9* _texture = 0;
static HWND _window = 0;


#include <tchar.h>
char* machine::fm(char* szFormat, ...)
{
    static TCHAR szBuffer[1024];  // Large buffer for long filenames or URLs
    const size_t NUMCHARS = sizeof(szBuffer) / sizeof(szBuffer[0]);
    const int LASTCHAR = NUMCHARS - 1;

    // Format the input string
    va_list pArgs;
    va_start(pArgs, szFormat);

    // Use a bounded buffer size to prevent buffer overruns.  Limit count to
    // character size minus one to allow for a NULL terminating character.
    _vsntprintf(szBuffer, NUMCHARS - 1, szFormat, pArgs);
    va_end(pArgs);

    // Ensure that the formatted string is NULL-terminated
    szBuffer[LASTCHAR] = TEXT('\0');

	return (char*) szBuffer;

    
}

void machine::debug(char* x, int m) { scene::_main()->debug(x,m); }
ieffect* machine::fx(char* k, ieffect* x) { return scene::fx(k,x); }

machine::machine(char* type, int embed, char* opt) {
    char args[1024];
	char* mach = "any";
    scene::fullscreen = 0;
	scene::_embedded = embed;


	simulation* _sim = scene::__sim = new simulation();
	generator* _gn = scene::__gn = new generator(255,89,1009); // in logic ...
	//_sim->realtime(10.0);
	_sim->realtime(1.0); // AE -- experimental
	
	//_sim->factor(2.0);
    //_sim->speed(1.0);
    
	query* _tk = 0;
	int with_pl = 1;
	if (with_pl)  _tk = scene::__tk = new query("kit=pl src=vip.pl");
	//_tk->eval("W:vip(_,W,_)");
	//char* ws = _tk->result(); 
	
	//char* ws = _tk->evaluate("W:vip(_,W,_)");
	//int w; sscanf(ws,"%d",&w);
	if (_tk) {
	char* dr = _tk->strvalue("X:drive(X)");
	dvscene::_drive(dr);
	//dxscene::_drive(dr);

	dr = _tk->strvalue("X:cache(X)");
	dvscene::_cache(dr);

	mach =  _tk->strvalue("X:machine(X)");


	int w = _tk->intvalue(scene::fm("W:vip(%s,%s,_)",mach,"W"));
	int h = _tk->intvalue(scene::fm("H:vip(%s,_,H)",mach));

	//_tk->eval("H:vip(_,_,H)");
	//char* hs = _tk->result();
	//int h; sscanf(hs,"%d",&h);
    
	scene::width(w);
	//scene::width = 1280;
	scene::height(h);
	}
	if (1) {
	
	//	scene::_embedded = 1;
	scene::__main = new scene();//scene::_main = new video();
	//if (opt) scene::__main =  new video();
	if (opt) scene::__video = new video();
	//_sim->passivate(scene::__main);
	//_sim->schedule(scene::__main,0);

	if (_tk) {
	_tk->eval("X:load(X)");
	char* p;
	if (1) while (p = _tk->result()) {
		//debug(p);
		_tk->load(p);
	    }

	_tk->load("text");
	//_tk->load("scene");
	//_tk->load("menu");
	_tk->load("menu");	
	}

	//scene::_main = (dxscene*) dvscene::lookup("main");
	scene::_main()->_scene =  new main_scene();
	scene::_main()->_stack = 1;
	scene::_main()->opt("application",type);
	scene::_main()->opt("machine",mach);
	//_tk->load("text");
	}

	char* cms = _tk->strvalue("X:dossier(start(X))");
	if (cms) scene::cm("dossier(start)",cms);
	//debug(cms);

    //scene::width = 1440;
    //scene::height = 900;

     // scene::width = 800;
     // scene::height = 600;
     // scene::width = 640;
     // scene::height = 480;
	scene::ptr("scene","VP",(void*) this);

}

char* machine::svalq(char* x) { query* tk = scene::__tk; return tk?tk->strvalue(x):0; }
int machine::ivalq(char* x)  { query* tk = scene::__tk; return tk?tk->intvalue(x):0; }
void machine::eval(char* x)  { query* tk = scene::__tk; if (tk) tk->eval(x); }
char* machine::result() { query* tk = scene::__tk; return tk?tk->unquote(tk->result()):0; }
//float machine::fvalq(char* x)  { query* tk = scene::__tk; if (tk) return tk->fvalue(x); }

int machine::width() { return scene::width(); }
int machine::height() { return scene::height(); }
int machine::shift(int k) { return scene::_shift(k); }
int machine::ctrl(int k) { return scene::_ctrl(k); }

scene* machine::_main() { return scene::_main(); }

int machine::project() { return scene::_project(); }
IDirect3DTexture9* machine::get_capture(int k) { return scene::_captures(k); }
void machine::set_capture(int k, IDirect3DTexture9* x) { scene::_captures(k,x); }
void machine::set_active(int k) { scene::_active(k); }
int machine::get_active() { return scene::_active(); }
int machine::get_select() { return scene::_select(); }

int machine::get_shift() { return scene::_shift(); }
void machine::set_total(int k) { scene::_total(k); }

extern "C" {

	void HUSH_API set_window(HWND x) { _window = x; }

void*  machine::scene_create() {

	if (0) {
		return new machine("unknown",1,"video");
	} else {
	scene::_embedded = 1;
	scene::__main = new scene();//scene::_main = new video();
	scene::__video = new video();
	scene::__main->_scene =  new main_scene();
	
	scene::__main->_stack = 1;
	//scene::tk = new query("kit=pl");
	}
	return 0;
}

HRESULT HUSH_API scene_init(IDirect3DDevice9*  device) {
	if (!device) { 
		return 0;
		//xdevice_create();
	//device = _device;
	}
	scene::_main()->init(device);
	return S_OK;
}


HRESULT HUSH_API set_texture0(IDirect3DTexture9* texture) {
	_texture = texture;
	return S_OK;
}

HRESULT HUSH_API set_texture(int k, IDirect3DTexture9* texture) {
	scene::_captures(k,texture);
	return S_OK;
}

HRESULT HUSH_API scene_render(IDirect3DDevice9*  device, IDirect3DTexture9* texture ) {
	if (!device) device = _device;
	if (!texture) texture = _texture;
	if (!texture) texture = scene::_captures(0);
	if (scene::_main()) scene::_main()->render(device,texture);
	return S_OK;
}

IDirect3DTexture9* machine::find_texture(int k) {
	return scene::_captures(k); // = texture;
}

IDirect3DTexture9* machine::find_capture(int k) {
	return scene::_captures(k); // = texture;
}

}

HRESULT machine::find_capture(IBaseFilter** gottaFilter, wchar_t* matchName, int idx, char* display)
{
	BOOL done = false;
    count++;
	// Create the System Device Enumerator.
	ICreateDevEnum *pSysDevEnum = NULL;
	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER,
		IID_ICreateDevEnum, (void **)&pSysDevEnum);
	if (FAILED(hr))
	{
		return hr;
	}

	// Obtain a class enumerator for the video input category.
	IEnumMoniker *pEnumCat = NULL;
	hr = pSysDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory, &pEnumCat, 0);
    int cnt = 0;
	if (hr == S_OK) 
	{
		// Enumerate the monikers.
		IMoniker *pMoniker = NULL;
		ULONG cFetched;
		while ((pEnumCat->Next(1, &pMoniker, &cFetched) == S_OK) && (!done))
		{
			// Bind the first moniker to an object
			IPropertyBag *pPropBag;
			hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, 
				(void **)&pPropBag);
			if (SUCCEEDED(hr))
			{
				cnt++;
				// To retrieve the filter's friendly name, do the following:
				VARIANT varName;
				VariantInit(&varName);
				hr = pPropBag->Read(L"FriendlyName", &varName, 0);
					char buf[256];
					sprintf(buf,"(%d): %d-%s",count,cnt, varName.bstrVal);
					//wprintf(L"Testing Video Input Device: %s\n", varName.bstrVal);
                HRESULT mb = IDNO;
				if (idx == 0) mb = MessageBox(0,buf,display,MB_YESNO | MB_ICONQUESTION );
				if (((mb == IDYES) || (cnt == idx) )  && SUCCEEDED(hr))
				{
					
					wprintf(L"Testing Video Input Device: %s\n", varName.bstrVal);
                   
					// Do a comparison, find out if it's the right one
					if (1 || (mb == IDYES && !matchName) || wcsncmp(varName.bstrVal, matchName, 
						wcslen(matchName)) == 0) {
                        //MessageBox(g_hwnd,buf,"found",MB_OK);
						// We found it, so send it back to the caller
						hr = pMoniker->BindToObject(NULL, NULL, IID_IBaseFilter, (void**) gottaFilter);
						done = true;
					}
				}
				VariantClear(&varName);	
				pPropBag->Release();
			}
			pMoniker->Release();
		}
		pEnumCat->Release();
	}
	pSysDevEnum->Release();
	if (done) {
		return hr;	// found it, return native error
	} else {
		return VFW_E_NOT_FOUND;	// didn't find it error
	}
}



HRESULT machine::find_capture0(IBaseFilter ** ppSrcFilter, wchar_t* matchName)
{
    HRESULT hr;
    IBaseFilter * pSrc = NULL;
    CComPtr <IMoniker> pMoniker =NULL;
    ULONG cFetched;

    if (!ppSrcFilter)
        return E_POINTER;
   
    // Create the system device enumerator
    CComPtr <ICreateDevEnum> pDevEnum =NULL;

    hr = CoCreateInstance (CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC,
                           IID_ICreateDevEnum, (void **) &pDevEnum);
    if (FAILED(hr))
    {
        //Msg(TEXT("Couldn't create system enumerator!  hr=0x%x"), hr);
        return hr;
    }

    // Create an enumerator for the video capture devices
    CComPtr <IEnumMoniker> pClassEnum = NULL;

    hr = pDevEnum->CreateClassEnumerator (CLSID_VideoInputDeviceCategory, &pClassEnum, 0);
    if (FAILED(hr))
    {
        //Msg(TEXT("Couldn't create class enumerator!  hr=0x%x"), hr);
        return hr;
    }

    // If there are no enumerators for the requested type, then 
    // CreateClassEnumerator will succeed, but pClassEnum will be NULL.
    if (pClassEnum == NULL)
    {
        //MessageBox(ghApp,TEXT("No video capture device was detected.\r\n\r\n")
          //         TEXT("This sample requires a video capture device, such as a USB WebCam,\r\n")
            //       TEXT("to be installed and working properly.  The sample will now close."),
              //     TEXT("No Video Capture Hardware"), MB_OK | MB_ICONINFORMATION);
        return E_FAIL;
    }

    // Use the first video capture device on the device list.
    // Note that if the Next() call succeeds but there are no monikers,
    // it will return S_FALSE (which is not a failure).  Therefore, we
    // check that the return code is S_OK instead of using SUCCEEDED() macro.
    if (S_OK == (pClassEnum->Next (1, &pMoniker, &cFetched)))
    {
        // Bind Moniker to a filter object
        hr = pMoniker->BindToObject(0,0,IID_IBaseFilter, (void**)&pSrc);
        if (FAILED(hr))
        {
            //Msg(TEXT("Couldn't bind moniker to filter object!  hr=0x%x"), hr);
            return hr;
        }
    }
    else
    {
        //Msg(TEXT("Unable to access video capture device!"));   
        return E_FAIL;
    }

    // Copy the found filter pointer to the output parameter.
    // Do NOT Release() the reference, since it will still be used
    // by the calling function.
    *ppSrcFilter = pSrc;

    return hr;
}


char* get_movie_path()
{
    OPENFILENAME ofn;
	//_bstr_t result = 0;
    ZeroMemory(&ofn, sizeof(ofn));
    static TCHAR  szBuffer[MAX_PATH];
    szBuffer[0] = NULL;

    static const TCHAR szFilter[]  
                            = TEXT("Video Files (.ASF, .AVI, .MPG, .MPEG, .VOB, .QT, .WMV)\0*.ASF;*.AVI;*.MPG;*.MPEG;*.VOB;*.QT;*.WMV\0") \
                              TEXT("All Files (*.*)\0*.*\0\0");
    ofn.lStructSize         = sizeof(OPENFILENAME);
    //ofn.hwndOwner           = g_hWnd;
    ofn.hInstance           = NULL;
    ofn.lpstrFilter         = szFilter;
    ofn.nFilterIndex        = 1;
    ofn.lpstrCustomFilter   = NULL;
    ofn.nMaxCustFilter      = 0;
    ofn.lpstrFile           = szBuffer;
    ofn.nMaxFile            = MAX_PATH;
    ofn.lpstrFileTitle      = NULL;
    ofn.nMaxFileTitle       = 0;
    ofn.lpstrInitialDir     = NULL;
    ofn.lpstrTitle          = TEXT("Select a video file to play...");
    ofn.Flags               = OFN_HIDEREADONLY;
    ofn.nFileOffset         = 0;
    ofn.nFileExtension      = 0;
    ofn.lpstrDefExt         = TEXT("AVI");
    ofn.lCustData           = 0L;
    ofn.lpfnHook            = NULL;
    ofn.lpTemplateName  = NULL; 
    
    if (GetOpenFileName (&ofn))  // user specified a file
    {
		static char result[512];
		strcpy(result,szBuffer);
        return  (char*) ( szBuffer );
    }

   return "";
}

void machine::handle(char* s1, char* s2) { scene::handle_event(s1,s2); }

char* machine::find_video(int type, char* name, IBaseFilter** pSource, wchar_t* match, int idx, char* display) {
	// 0 all, 1 capture, 2 video
	// return 0 capture, 1 video
	HRESULT hr = S_OK;
	char* path;
	if (type == 0) hr = MessageBox(0,"play from capture?",display,MB_YESNO | MB_ICONQUESTION );
   //hr = g_graph->AddSourceFilter( L"C:\\AE\\media\\sebas.avi", L"Source1", &pSource);
    
	if ((type == 0 && hr != IDYES) || type == 2) { 
		if (!name) {
			path = get_movie_path();
			return path;
		} else { return name; }
		//if (path.length()) cold = 1;
		//scene::_source = (char*) path;
		//find_capture(&pSource,0);
	//hr = g_graph->AddSourceFilter( L"media/isabelle-2.avi", L"Source1", &pSource);
	} else {
		find_capture(pSource,match,idx,display);
		return 0;
    }
}