
#ifndef vip_face_h
#define vip_face_h

#include <hush/export.h>
#include "scene/scene.h"

#include <d3dx9.h>
#include <util/direct3d.h>


class vip_face : public scene  
{
public:

    vip_face(char* opts = 0);

	int operator()();
    virtual ~vip_face();
    virtual int _load();
	virtual int _restore();
    virtual int _render();

	int ch(char* x=0);

	int handle(char* type, char* ev);


// Base, target morphing, and blended mesh objects
D3DXMESHCONTAINER_EX *g_BaseMesh;//    = NULL;
D3DXMESHCONTAINER_EX *g_Mesh1;//       = NULL;
D3DXMESHCONTAINER_EX *g_Mesh2;//       = NULL;
D3DXMESHCONTAINER_EX *g_Mesh3;//       = NULL;
D3DXMESHCONTAINER_EX *g_Mesh4;//       = NULL;
D3DXMESHCONTAINER_EX *g_BlendedMesh;// = NULL;

// Flags to toggle blending
BOOL g_BlendMesh1;// = TRUE;
BOOL g_BlendMesh2;// = TRUE;
BOOL g_BlendMesh3;// = TRUE;
BOOL g_BlendMesh4;// = TRUE;

// Guide texture and sprite interface
IDirect3DTexture9 *g_GuideTexture;// = NULL;
ID3DXSprite       *g_Guide;//        = NULL;

// Morphing mesh vertex structure and FVF
typedef struct {
  D3DXVECTOR3 vecPos;
  D3DXVECTOR3 vecNormal;
  float       u, v;
} sVertex;
#define BLENDFVF (D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1)

void DrawBlendedMesh(D3DXMESHCONTAINER_EX *BaseMesh,
                     D3DXMESHCONTAINER_EX *Mesh1, float Blend1,
                     D3DXMESHCONTAINER_EX *Mesh2, float Blend2,
                     D3DXMESHCONTAINER_EX *Mesh3, float Blend3,
                     D3DXMESHCONTAINER_EX *Mesh4, float Blend4);



};
#endif 
