#include <hush/source.h>
#include <scene/text.h>
#include <scene/sim.h>
#include <scene/slides.h>

#include "casus.h"


int text_casus::operator()() {

if (state != 5) state = 5; 
else state = random(0,5);

_sim->passivate(this);
float t = 10.0;
if (state == 5) t = 5.0; 
_sim->schedule(this,_gn->exponential(t));
return 0;

}

scene* text_casus::create(char* opts) { return new text_casus(opts); }

text_casus::text_casus(char* opts) 
{
  
	clear(&msg);

	//opt("style","plain");
	opt("display","multimedia casus");
	opt("text(title)","multimedia casus ");
	opt("text(sub)","      digital                          dossiers");
	opt("space","vip/morph");

	//opt("text(authors)","A. Eliens, Z. Huang, J.F. Hoorn, C.T. Visser");
	

	opt("slides","\\vip\\media\soutine.jpg");

	opt("logo(3d)","media");
	opt("logo(3ds)","@VU");
	opt("logo(vip)","@VU");

	//sc("slides",new slides("..\\present\\casus","img0",1,3,"jpg"));

	declare("local/slides/casus",new  slides(loc("\\vip\\present\\casus"),"img0",1,3,"jpg"));
    opt("slides","local/slides/casus");



	// --------------------------------------------------------

	msg[5][11] = "http://www.cs.vu.nl/~eliens/casus";

   	msg[0][1] = "the multimedia casus";
	msg[0][3] = "focusses";
	msg[0][5] = "on digital dossiers";
	msg[0][7] = "containing all";
	msg[0][9] = "relevant information";
	msg[0][11] = "in a virtual environment";
	


	msg[2][0] = "the purpose of";
	msg[2][1] = " digital dossiers";
	msg[2][2] = "is to capture the";
	msg[2][3] = " knowledge ";
	msg[2][4] = "needed for the";
	msg[2][5] = " preservation";
	msg[2][6] = "and ";
	msg[2][7] = " re-installation";
	msg[2][8] = "of ";
	msg[2][9] = " contemporary art";
	msg[2][10] = "works";


	msg[1][1] = msg[2][1];
	msg[1][3] = msg[2][3];
	msg[1][5] = msg[2][5];
	msg[1][7] = msg[2][7];
	msg[1][9] = msg[2][9];


	msg[3][0] = "in this period ";
	msg[3][3] = "we developed a dossier ";
	msg[3][4] = "for Marina Abramovic";
	msg[3][7] = "with support from";
	msg[3][8] = "Michela Negrini, Tatja Scholte";
	msg[3][9] = "Bart Rutten, and Ysbrand Hummelen";
	msg[3][11] = "  ...   ";

	
	msg[4][1] = "      Multimedia Casus 2004";
	msg[4][6] = "      ism ICN / Montevideo";	
	msg[4][8] = "        Vrije Universiteit";
	msg[4][9] = "             Amsterdam";



}

text_casus::~text_casus()
{
//delete scenes[];
}

int 
text_casus::_load()
{
    HRESULT hr = S_OK;
    count = 4;

	_text = scenes[1] = new text(&msg);
    

	hr = scene::_load(); // loops through scenes

    return hr;
}

int
text_casus::_restore()
{
    HRESULT hr = S_OK;
 

    return hr;
}


int
text_casus::_render( ) 
{
int hr = S_OK;


    _text->state = state;

	render_begin(_device);

    
   

	hr = scene::_render(); // calls compose, restore,  render

	
    
	render_end(_device);

 

    return hr;
}

