#include <hush/source.h>
#include <scene/text.h>
#include <scene/sim.h>
#include <scene/slides.h>

#include "design.h"


int text_design::operator()() {

if (state != 5) state = 5; 
else state = random(0,5);

_sim->passivate(this);
float t = 10.0;
if (state == 5) t = 5.0; 
_sim->schedule(this,_gn->exponential(t));
return 0;

}

scene* text_design::create(char* opts) { return new text_design(opts); }

text_design::text_design(char* opts) 
{
  
	clear(&msg);

	//opt("style","plain");
	opt("display","visual design");
	opt("text(title)","visual design ");
	opt("text(sub)","      digital                          content");
	opt("space","vip/morph");

	//opt("text(authors)","A. Eliens, Z. Huang, J.F. Hoorn, C.T. Visser");
	

	opt("slides","\\vip\\media\soutine.jpg");

	opt("logo(3d)","visual");
	opt("logo(3ds)","design");
	opt("logo(vip)","@VU");

	//sc("slides",new slides("..\\present\\design","img0",1,6,"jpg"));

	declare("local/slides/design",new  slides(loc("\\vip\\present\\design"),"img0",1,6,"jpg"));
    opt("slides","local/slides/design");

	// --------------------------------------------------------

	msg[5][11] = "http://www.cs.vu.nl/~eliens/design";

   	msg[0][1] = "visual design";
	msg[0][3] = "is a course";
	msg[0][5] = "in which you develop";
	msg[0][7] = "a personal portfolio";
	msg[0][9] = "to learn";
	msg[0][11] = "visual design";
	


	msg[2][0] = "the success of";
	msg[2][1] = " visual design";
	msg[2][2] = "depends on";
	msg[2][3] = " aesthetic judgement";
	msg[2][4] = "as well as your";
	msg[2][5] = " craftmanship";
	msg[2][6] = "but remind that ";
	msg[2][7] = " a clear message";
	msg[2][8] = "is necessary ";
	msg[2][9] = " and an eye for meaning";
	msg[2][10] = "indispensable";


	msg[1][1] = msg[2][1];
	msg[1][3] = msg[2][3];
	msg[1][5] = msg[2][5];
	msg[1][7] = msg[2][7];
	msg[1][9] = msg[2][9];


	msg[3][0] = "you will work on ";
	msg[3][3] = "style";
	msg[3][5] = "          content";
	msg[3][7] = "                          technology";
	//msg[3][8] = "Michela Negrini, Tatja Scholte";
	msg[3][10] = "there will be guest speakers,";
	msg[3][11] = "presentations, and peer reviews   ";

	
	msg[4][1] = "          multimedia @ VU";
	msg[4][6] = "      ";	
	msg[4][8] = "        Vrije Universiteit";
	msg[4][9] = "             Amsterdam";



}

text_design::~text_design()
{
//delete scenes[];
}

int 
text_design::_load()
{
    HRESULT hr = S_OK;
    count = 4;

	_text = scenes[1] = new text(&msg);
    

	hr = scene::_load(); // loops through scenes

    return hr;
}

int
text_design::_restore()
{
    HRESULT hr = S_OK;
 

    return hr;
}


int
text_design::_render( ) 
{
int hr = S_OK;


    _text->state = state;

	render_begin(_device);

    
   

	hr = scene::_render(); // calls compose, restore,  render

	
    
	render_end(_device);

 

    return hr;
}

