#include <hush/source.h>
#include <scene/text.h>
#include <scene/sim.h>
#include <scene/slides.h>

#include "imm.h"


int text_imm::operator()() {

if (state != 5) state = 5; 
else state = random(0,5);

_sim->passivate(this);
float t = 10.0;
if (state == 5) t = 5.0; 
_sim->schedule(this,_gn->exponential(t));
return 0;

}

scene* text_imm::create(char* opts) { return new text_imm(opts); }

text_imm::text_imm(char* opts) 
{
  
	clear(&msg);

    opt("lecture","multimedia @VU");
	opt("display","multimedia @VU");
	opt("text(title)","multimedia @VU ");
	opt("text(sub)","convergence     standards      retrieval");
	//opt("text(authors)","       A. Eliens");

	//opt("slides","\\vip\\media\soutine.jpg");

	opt("logo(3d)","media");
	opt("logo(3ds)","@VU");
	opt("logo(vip)","@VU");

	scene* sc = new  slides(loc("\\vip\\present\\imm-intro"),"img0",1,10,"jpg");
	//declare("slides/imm",sc);
	declare("local/slides/imm",sc);
    opt("slides","local/slides/imm");
	// ------------------------------------------

	msg[5][11] = "http://www.cs.vu.nl/~eliens/media";

    msg[0][0] = "this is";
	msg[0][2] = "a first";
	msg[0][4] = "introduction";
	msg[0][6] = "both practically";
	msg[0][8] = "and theoretically";
	msg[0][10] = "in the subject of";
	

	
	msg[1][1] = " digital convergence";
	
	msg[1][3] = " media, platforms and networking";

	msg[1][5] = " encoding standards";

	msg[1][7] = " multimedia information retrieval";
	
	msg[1][9] = " intelligent multimedia";




	msg[2][0] = "it covers";
	msg[2][1] = " digital convergence";
	msg[2][2] = "which is the confluence of";
	msg[2][3] = " media, platforms and networking";
	msg[2][4] = "and includes transport and display";
	msg[2][5] = " encoding standards";
	msg[2][6] = "and the intriguing topic of";
	msg[2][7] = " multimedia information retrieval";
	msg[2][8] = "with as additional subjects";
	msg[2][9] = " intelligent multimedia";
	msg[2][10] = "and presentation VR";
	

	msg[3][0] = "for the practicum ";

	msg[3][3] = " you will create an";
	msg[3][4] = "annotated tour in Amsterdam";

	msg[3][7] = " with a focus on content";
	msg[3][8] = "and special effects";

	msg[3][11] = " to find your edge codes";


	msg[4][1] = "       multimedia @VU";


	msg[4][6] = "        A. Eliens";
	
	msg[4][8] = "    Vrije Universiteit";
	msg[4][9] = "        Amsterdam";




}

text_imm::~text_imm()
{
//delete scenes[];
}

HRESULT 
text_imm::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
    count = 4;

	_text = scenes[1] = new text(&msg);
    

	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
text_imm::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
 

    return hr;
}


HRESULT 
text_imm::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;


    _text->state = state;

	render_begin(device);

    
   

	hr = scene::render(device,texture); // calls compose, restore,  render

	
    
	render_end(device);

 

    return hr;
}

