#include <hush/source.h>
#include <scene/text.h>
#include <scene/sim.h>
#include <scene/slides.h>

#include "retrieval.h"


int text_retrieval::operator()() {

if (state != 5) state = 5; 
else state = random(0,5);

_sim->passivate(this);
float t = 10.0;
if (state == 5) t = 5.0; 
_sim->schedule(this,_gn->exponential(t));
return 0;

}

scene* text_retrieval::create(char* opts) { return new text_retrieval(opts); }

text_retrieval::text_retrieval(char* opts) 
{
  
	clear(&msg);

	//opt("style","plain");
	opt("space","vip/morph");

	opt("lecture","information retrieval");
	opt("display","multimedia @VU");
	opt("text(title)","information retrieval ");
	opt("text(sub)","convergence     standards      retrieval");
	//opt("text(authors)","       A. Eliens");

	opt("slides","\\vip\\media\soutine.jpg");

	opt("logo(3d)","media");
	opt("logo(3ds)","@VU");
	opt("logo(vip)","@VU");
	//sc("slides",new slides("..\\present\\imm-retrieval","img0",1,20,"jpg"));

	declare("local/slides/retrieval",new  slides(loc("\\vip\\present\\imm-retrieval"),"img0",1,20,"jpg"));
    opt("slides","local/slides/retrieval");

	// --------------------------------------------------------

		msg[5][11] = "http://www.cs.vu.nl/~eliens/media";

    msg[0][0] = "information retrieval";
	msg[0][2] = "allows for";
	msg[0][4] = "the effective use of";
	msg[0][6] = "digital content";
	msg[0][8] = "in the (global)";
	msg[0][10] = "information space";
	

	msg[2][0] = "it encompasses";
	msg[2][1] = " content description";
	msg[2][2] = "that is, both automatic";
	msg[2][3] = " content search";
    msg[2][4] = "establishing ";
	msg[2][5] = " similarity";
    msg[2][6] = "as well as";
	msg[2][7] = " meta information";
	msg[2][8] = "to characterize the";
	msg[2][9] = " attribute space";
    msg[2][10] = "of information items";

	
	msg[1][1] = msg[2][1];
	msg[1][3] = msg[2][3];
	msg[1][5] = msg[2][5];
	msg[1][7] = msg[2][7];
	msg[1][9] = msg[2][9];

	msg[3][0] = "multimedia information retrieval";

	msg[3][3] = " must be provided for";
	msg[3][4] = "at authoring time";

	msg[3][7] = " to allow ";
	msg[3][8] = "uniform search";

	msg[3][11] = " of digital content";


	msg[4][1] = "    multimedia @VU";


	msg[4][6] = "  information  retrieval";
	
	msg[4][8] = "   Vrije Universiteit";
	msg[4][9] = "        Amsterdam";



}

text_retrieval::~text_retrieval()
{
//delete scenes[];
}

int 
text_retrieval::_load()
{
    HRESULT hr = S_OK;
    count = 4;

	_text = scenes[1] = new text(&msg);
    

	hr = scene::_load(); // loops through scenes

    return hr;
}

int
text_retrieval::_restore()
{
    HRESULT hr = S_OK;
 

    return hr;
}


int
text_retrieval::_render( ) 
{
int hr = S_OK;


    _text->state = state;

	render_begin(_device);

    
   

	hr = scene::_render(); // calls compose, restore,  render

	
    
	render_end(_device);

 

    return hr;
}

