#include <hush/source.h>
#include <scene/text.h>
#include <scene/sim.h>
#include <scene/slides.h>

#include "standards.h"


int text_standards::operator()() {

if (state != 5) state = 5; 
else state = random(0,5);

_sim->passivate(this);
float t = 10.0;
if (state == 5) t = 5.0; 
_sim->schedule(this,_gn->exponential(t));
return 0;

}

scene* text_standards::create(char* opts) { return new text_standards(opts); }

text_standards::text_standards(char* opts) 
{
  
	clear(&msg);

	//opt("style","plain");
	opt("space","vip/morph");

	opt("lecture","codecs & standards");
	opt("display","multimedia @VU");
	opt("text(title)","codecs & standards ");
	opt("text(sub)","convergence     standards      retrieval");
	//opt("text(authors)","       A. Eliens");

	opt("slides","\\vip\\media\soutine.jpg");

	opt("logo(3d)","media");
	opt("logo(3ds)","@VU");
	opt("logo(vip)","@VU");
	//sc("slides",new slides("..\\present\\imm-standards","img0",1,20,"jpg"));

	declare("local/slides/standards",new  slides(loc("\\vip\\present\\imm-standards"),"img0",1,20,"jpg"));
    opt("slides","local/slides/standards");

	// --------------------------------------------------------

		msg[5][11] = "http://www.cs.vu.nl/~eliens/media";

    msg[0][0] = "codecs & standards";
	msg[0][2] = "determine";
	msg[0][4] = "effective delivery of";
	msg[0][6] = "digital content";
	msg[0][8] = "for presentation";
	msg[0][10] = "on a variety of platforms";
	

	msg[2][0] = "to determine";
	msg[2][1] = " codecs";
	msg[2][2] = "take into account";
	msg[2][3] = " platforms";
    msg[2][4] = "and the bandwidth of ";
	msg[2][5] = " delivery";
    msg[2][6] = "however, there are many";
	msg[2][7] = " standards";
	msg[2][8] = "for the";
	msg[2][9] = " compression";
    msg[2][10] = "of digital content";

	
	msg[1][1] = msg[2][1];
	msg[1][3] = msg[2][3];
	msg[1][5] = msg[2][5];
	msg[1][7] = msg[2][7];
	msg[1][9] = msg[2][9];

	msg[3][0] = "multimedia standards";

	msg[3][3] = " provide a toolkit";
	msg[3][4] = "for authoring and delivery";

	msg[3][7] = " on a variety of devices";
	msg[3][8] = "embodying";

	msg[3][11] = " digital convergence";


	msg[4][1] = "    multimedia @VU";


	msg[4][6] = "  codecs & standards";
	
	msg[4][8] = "   Vrije Universiteit";
	msg[4][9] = "        Amsterdam";



}

text_standards::~text_standards()
{
//delete scenes[];
}

int 
text_standards::_load()
{
    HRESULT hr = S_OK;
    count = 4;

	_text = scenes[1] = new text(&msg);
    

	hr = scene::_load(); // loops through scenes

    return hr;
}

int
text_standards::_restore()
{
    HRESULT hr = S_OK;
 

    return hr;
}


int
text_standards::_render( ) 
{
int hr = S_OK;


    _text->state = state;

	render_begin(_device);

    
   

	hr = scene::_render(); // calls compose, restore,  render

	
    
	render_end(_device);

 

    return hr;
}

