%{
//@auto=0
//@class inc
%}
%class dossier_ml
%{
static char* ext = ".txt";
static int pr = 0;

#include <hush/sys/unistd.h>
#include <hush/grammar/input.h>
#include <hush/grammar/string.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>
#include <hush/iostream.h>

#include <hush/dictionary.h>
#include <hush/agent/resolver.h>
#include <hush/agent/query.h>

#include <hush/set.h>

#include <hush/iostream.h>
#include <string.h>

#ifdef VIP
#include <scene/scene.h>
#include <scene/slides.h>
#include <scene/lecture.h>
#endif
#define out if (pr) cout

static char name[64];
static int slino = 0;

static scene* _scene = 0;
static scene* _lecture = 0;
static scene* _slides = 0;
static scene* _text = 0;
static scene* _this = 0;
static scene* _dossier = 0;
static int _debug = 1;
static int in_text = 0;
static int in_lecture = 0;
static int in_slides = 0;
static int in_display = 0;
static char cfgdir[1024] = "d:/vip/cfg/startup/text";
static char* _cfgdir;

static char slidesdir[1024] = "d:/vip/cfg/startup/text";
static char* _root;

static char linebuf[1024];
static int _cursor = 0;

static char textdir[1024] = "d:/vip/cfg/startup/text";
static char* _textroot;


static char particledir[1024] = "d:/vip/cfg/startup/particles";
static char* _particleroot;

static int _line = 0;
static int _row = 0;

static void check() {
    if (!_dossier) _dossier = (scene*) scene::lookup("dossier");
    if (!_this) _this = (scene*) scene::lookup("this");
    _cfgdir = &cfgdir[0];
    _root = &slidesdir[0];
    _textroot = &textdir[0];
    _particleroot = &particledir[0];
    if (!_text) _text = (scene*) scene::lookup("_text");
    if (!_scene) _scene = (scene*) scene::lookup("_scene");
    strcpy(linebuf,"");
    _cursor = 0;
    _row = 0;
    }




static void deprecated(char* s) {
	//cerr << "## DEPRECATED " << s << endl; 
	cout << "## DEPRECATED " << s << endl; 
	}

static int nl = 0;
%}
escape ("\\\"")
ident [A-Za-z0-9]+
stringelem ({escape}|[^\"\n])
string (\"{stringelem}+\")

path  [A-Za-z0-9\@\~\#\:\-\.\/\?]+

value  ({path}|{string})
attrib ({ident}|{ident}[ \t\n]*"="[ \t\n]*{value})

attribs ([ \t\n]|{attrib})*

simple   ("<"{ident}">")
begintag ("<"{ident}{attribs}">")
endtag   "</"{ident}">")
beginpr  "<?"{ident}{attribs}">"
endpr    "<?/"{ident}">"

any ([^\>]|{string})
atts {any}*
%%@ rules

"#".* {  }
"//".* { }
"%% ".* { }

"</cfg>" { return 0; }
^"%%</cfg>" { return 0; }

^"%%<cfg "{atts}">" { 
      check();
      if (_debug && scene::ds("parser:debug:cfg")) _dossier->debug(yytext+2,1);
      yytext[yyleng-1] = '\0';
        string_converter x(yytext+6);
        for (int i = 1; i <= x.argc(); i++ ) {
          attribute p(x[i]);
          if ( p.matches("dir")  ) {   
              strcpy(_cfgdir,p.value());
         } else if ( p.matches("slides") ) {   
              strcpy(_root,p.value());
         } else if ( p.matches("text") ) {   
              strcpy(_textroot,p.value());
         } else if ( p.matches("debug")  ) {   
              _debug = atoi(p.value());          
         } else if ( p.matches("file") || p.matches("name") ) {   
              soinc(scene::fm("%s/%s",_cfgdir,p.value()));
              }
       }
  }
       
"<cfg "{atts}">" { 
      check();
      if (_debug && scene::ds("parser:debug:cfg")) _dossier->debug(yytext,1);
      yytext[yyleng-1] = '\0';
        string_converter x(yytext+4);
        for (int i = 1; i <= x.argc(); i++ ) {
          attribute p(x[i]);
          if ( p.matches("dir")  ) {   
              strcpy(_cfgdir,p.value());
          } else if ( p.matches("slides") ) {   
              strcpy(_root,p.value());
          } else if ( p.matches("text") ) {   
              strcpy(_textroot,p.value());
          } else if ( p.matches("debug")  ) {   
              _debug = atoi(p.value()); 
          } else if ( p.matches("file") || p.matches("name") ) {   
              soinc(scene::fm("%s/%s",_cfgdir,p.value()));
              }
       }
  }

^"%%<include "{atts}">" { 
      check();
      if (_debug && scene::ds("parser:debug:include")) _dossier->debug(yytext+2,1);
      yytext[yyleng-1] = '\0';
        string_converter x(yytext+10);
        for (int i = 1; i <= x.argc(); i++ ) {
          attribute p(x[i]);
          if ( p.matches("file") || p.matches("name") ) {   
              soinc(p.value());
              }
       }
  }
       
"<include "{atts}">" { 
      check();
      if (_debug && scene::ds("parser:debug:include")) _dossier->debug(yytext,1);
      yytext[yyleng-1] = '\0';
        string_converter x(yytext+8);
        for (int i = 1; i <= x.argc(); i++ ) {
          attribute p(x[i]);
          if ( p.matches("file") || p.matches("name") ) {   
              soinc(p.value());
              }
       }
  }
  
 "<opt "{atts}">" { 
      check();
      if (_debug && scene::ds("parser:debug:opt")) _dossier->debug(yytext,1);
      yytext[yyleng-1] = '\0';
        string_converter x(yytext+4);
        for (int i = 1; i <= x.argc(); i++ ) {      
          attribute p(x[i]);
          //if (_debug && scene::ds("parser:debug")) _dossier->debug(p.key(),1);
          _scene->opt(p.key(),p.value());
          
       }
  }
  
"<slides "{atts}">" {
       //scene::_log(yytext);
       in_slides++;
        check();
        char* _dir = "";
        char* _ext = "jpg";
        char* _base = "img0";
        char bdir[256];
        char bext[256];
        char bbase[256];
        _dir = &bdir[0];
        _ext = &bext[0];
        _base = &bbase[0];
        strcpy(_dir,"");
        strcpy(_base,"img0");
        strcpy(_ext,"jpg");
        
        int _start = 1;
        int _end = 0;
        char name[256];
        char* _name = &name[0];
        check();
        if (_debug && scene::ds("parser:debug:slides")) _dossier->debug(yytext,1);
        yytext[yyleng-1] = '\0';
        string_converter x(yytext+7);
        for (int i = 1; i <= x.argc(); i++ ) {
          attribute p(x[i]);
          if ( p.matches("root")  ) {   
              strcpy(_dir,p.value());      
          } else if ( p.matches("dir")  ) {   
              strcpy(_dir,p.value());
              }
          else if ( p.matches("id") || p.matches("name") ) {
              strcpy(_name,p.value());
          } else if ( p.matches("ext")) {
              strcpy(_ext,p.value());
          } else if ( p.matches("base")) {
              strcpy(_base,p.value());
          } else if ( p.matches("start")) {
              _start = atoi(p.value());
          } else if ( p.matches("end")) {
              _end = atoi(p.value());
          }
          }
          _scene = _slides = 
              new slides(scene::fm("%s/%s",_root,_dir),_base,_start,_end,_ext);
          scene::declare(_name,_slides);
          if (0 && _debug && scene::ds("parser:debug:slides")) 
             _dossier->debug(scene::fm("%s/%s %s %d %d %s",_root,_dir,_base,_start,_end,_ext),1);
          if (!in_lecture && !in_text) _this->lst(_name,_slides);
          //_dossier->lst(_name,_slides);
          if (in_text && _text) _text->opt("slides",_name);
          if (in_lecture && _lecture) _lecture->opt("slides",_name);
}

"</slides>" { in_slides--; _scene = _this; }

"<particles "{atts}">"|"<particle "{atts}">"  {
        check();
        char bid[256];
        char* _id = &bid[0];
        strcpy(_id,"\0");
        yytext[yyleng-1] = '\0';
        string_converter x(yytext+10);
        for (int i = 1; i <= x.argc(); i++ ) {
          attribute p(x[i]);
          if ( p.matches("id") || p.matches("name") ) {
              strcpy(_id,p.value());
          } else if ( p.matches("src") ) {
            soinc(scene::fm("%s/%s",_particleroot,p.value()));
            //_dossier->debug(scene::fm("%s/%s",_particleroot,p.value()),1);
          }
        }
        if (_id[0] != '\0') {
           _scene = ((scene*)scene::lookup("particles/0"))->create(yytext+10);
           scene::declare(_id,_scene);
            //if (scene::lookup(_id)) _dossier->debug(scene::fm("%s: %s [%s]",_particleroot,_id,yytext+10),1);
           _this->lst(_id,_scene);
           }
}

"</particles>"|"</particle>" {  }


"<lecture "{atts}">" {
        check();
        in_lecture++;
        char bid[126];
        char* _id = &bid[0];
        strcpy(_id,"\0");
        char bname[256];
        char* _name = &bname[0];
        char btext[256];
        char* _ptext = &btext[0];
        int has_text = 0;
        check();
        if (_debug && scene::ds("parser:debug:lecture")) _dossier->debug(yytext,1);
        yytext[yyleng-1] = '\0';
        string_converter x(yytext+8);
        for (int i = 1; i <= x.argc(); i++ ) {
        
          attribute p(x[i]);     
          //_dossier->debug(scene::fm("%s=%s",p.key(),p.value()),1); 
          if ( p.matches("name") ) {
              strcpy(_name,p.value());
              strcpy(_name,_name);
          } else if ( p.matches("id") ) {
              strcpy(_id,p.value());
          } else if ( p.matches("text")) {
              has_text = 1;
              strcpy(_ptext,p.value());     
          }
          }
          if (_id[0] == '\0') sprintf(_id,"lecture/%s",_name); 
          if (_name[0] == '\0' && _id[0] != '\0') sprintf(_name,"%s",_id + 8); 
          if (has_text)
          _scene = 
              ((scene*)scene::lookup("lecture"))->create(scene::fm("name=%s text=%s",_name,_ptext));
          else
              _scene = 
              ((scene*)scene::lookup("lecture"))->create(scene::fm("name=%s",_name));
          
          _lecture = _scene;
          if (_debug && scene::ds("parser:debug:lecture"))
             _dossier->debug(scene::fm("%s %s %s",_id,_name,_ptext));
          scene::declare(_id,_scene);
          _this->lst(_id,_scene);
          //_dossier->lst(_id,_scene);
}

"</lecture>" { in_lecture--; _lecture = _this; }
       
"<text "{atts}">" {
        scene::_log(yytext);
        
        in_text++;
        check();
        //_dossier->opt("parser:log",yytext);
        if (_debug && scene::ds("parser:debug:text")) _dossier->debug(yytext,1);
        _line = 0;
        _text = 0;
        yytext[yyleng-1] = '\0';
        string_converter x(yytext+6);
        for (int i = 1; i <= x.argc(); i++ ) {
          attribute p(x[i]);
          if ( (in_text == 1) && (p.matches("id") || p.matches("name")) ) {
          //if (_debug && scene::ds("parser:debug:text")) _dossier->debug(p.value(),1);
          _scene = _text = ((scene*)scene::lookup("text"))->create();
          scene::declare(p.value(),_text);
          if (!in_lecture) _this->lst(p.value(),_text);
          scene::declare("_text",_text);
          if (in_lecture && _lecture) _lecture->opt("text",p.value());
          } else if ( p.matches("src") ) {
            soinc(scene::fm("%s/%s",_textroot,p.value()));
            //_dossier->debug(scene::fm("%s/%s",_textroot,p.value()),1);
          } else if ( p.matches("random") ) {
            if(_text) _text->opt("random",p.value());
          }
          
   }
   
}
"</text>" { 
           
           _line = 0; in_text--; 
           //_scene->iopt("random",1);
           _text = 0;
           _scene = _this;
           }

"<page "{atts}">" {
        scene::_log(yytext);
        check();
        _line++;
        yytext[yyleng-1] = '\0';
        string_converter x(yytext+6);
        for (int i = 1; i <= x.argc(); i++ ) {
          attribute p(x[i]);
          if ( p.matches("no") ) {
                     _line = atoi(p.value());
          }
   }
}
"</page>" { if (_text) _text->iopt("max",_line);  }

"<display "{atts}">" {
        check();
        nl = 0;
        _line++;
        in_display++;
        yytext[yyleng-1] = '\0';
        string_converter x(yytext+8);
        for (int i = 1; i <= x.argc(); i++ ) {
          attribute p(x[i]);
          if ( p.matches("no") ) {
                     _line = atoi(p.value());
          } else if ( p.matches("src") ) {
            soinc(scene::fm("%s/%s",_textroot,p.value()));
            //_dossier->debug(scene::fm("%s/%s",_textroot,p.value()),1);
          }
   }
}

"</display>" { in_display--; if (_text) _text->iopt("max",_line);  }





       
[0-9]":"{string} { 
               yytext[yyleng-1] = '\0';
               int k = yytext[0]-'0'; 
               if (_text) _text->opt(scene::fm("line(%d,%d)",_line,k),yytext+3);
               //if (_debug) _dossier->debug(scene::fm("line(%d,%d)=\"%s\"",_line,k,yytext+3),1);
               }

"msg["[0-9]"]["[0-9]"]="{string}";" {
               int x = yytext[4] - '0';
               int y = yytext[7] - '0';             
               yytext[yyleng-2] = '\0'; _line = x;
               if (_text) _text->opt(scene::fm("line(%d,%d)",x,y),yytext+11);
               if (_text) _text->iopt("max",_line); 
               //if (_debug) _dossier->debug(scene::fm("line(%d,%d)=\"%s\"",x,y,yytext+11),1);
               }
  "msg["[0-9]"]["[0-9][0-9]"]="{string}";" {
               int x = yytext[4] - '0';
               int y = (yytext[7] - '0') * 10 + yytext[8] - '0';             
               yytext[yyleng-2] = '\0'; _line = x;
               if (_text) _text->opt(scene::fm("line(%d,%d)",x,y),yytext+12);
               if (_text) _text->iopt("max",_line); 
               //if (_debug) _dossier->debug(scene::fm("line(%d,%d)=\"%s\"",x,y,yytext+12),1);
               }  
  "msg["[0-9][0-9]"]["[0-9]"]="{string}";" {
               int x = (yytext[4] - '0') * 10 + yytext[5] - '0';
               int y = (yytext[8] - '0');             
               yytext[yyleng-2] = '\0'; _line = x;
               if (_text) _text->opt(scene::fm("line(%d,%d)",x,y),yytext+13);
               if (_text) _text->iopt("max",_line); 
               //if (_debug) _dossier->debug(scene::fm("line(%d,%d)=\"%s\"",x,y,yytext+13),1);
               }  
  "msg["[0-9][0-9]"]["[0-9][0-9]"]="{string}";" {
               int x = (yytext[4] - '0') * 10 + yytext[5] - '0';
               int y = (yytext[8] - '0') * 10 + yytext[9] - '0';             
               yytext[yyleng-2] = '\0'; _line = x;
               if (_text) _text->opt(scene::fm("line(%d,%d)",x,y),yytext+14);
               if (_text) _text->iopt("max",_line); 
               //if (_debug) _dossier->debug(scene::fm("line(%d,%d)=\"%s\"",x,y,yytext+14),1);
               }             
           
           


[0-9][0-9]":"{string} {
               yytext[yyleng-1] = '\0';
               int x = yytext[0]-'0'; int y = yytext[1]-'0'; int k = 10 * x + y;
               if (_text) _text->opt(scene::fm("line(%d,%d)",_line,k),yytext+4);
               //if (_debug) _dossier->debug(scene::fm("line(%d,%d)=\"%s\"",_line,k,yytext+4),1);
               }
               
\n { if (nl > 0 && in_display > 0) {
       linebuf[_cursor] = '\0';
       if (_text) _text->opt(scene::fm("line(%d,%d)",_line,_row),linebuf);
       //_dossier->debug(scene::fm("line(%d,%d) -- %s",_line,_row,linebuf),1);
       _row++;
       _cursor = 0; sprintf(linebuf,"%s","");
     }
     nl++;
     }
. {  
     if (nl > 0 && in_display > 0) { linebuf[_cursor++] = yytext[0]; }

#ifdef VIP
 //scene::_log(scene::fm(": dossier(%d)",nl));
#endif
 }
%%
//@ main

static char _argv[24][256];


#ifndef VIP
int main(int argc, char* argv[]) {
dossier l;
//align = "BEGIN";
strcpy(name,"temp");
int _argc = 0;
cerr << "ARGC " << argc << endl;
argc--; argv++;
while ((argc > 0) && (argv[0][0] == '-')) {
	if ( argv[0][1] == 'N' ) {
	strcpy(name,argv[0]+2);
	} else if ( ( argv[0][1] == 'I' ) || ( argv[0][1] == 'R' ) ) { 
		strcpy(_argv[_argc],argv[0]);
		//cerr << "Copied " << _argv[_argc] << endl;
		_argc++;
		}
        cerr << "ARGC " << argc << endl;
	argc--; argv++;
	}

cerr << "ARGC " << argc << endl;
//l.paths(_argc, _argv);
pr = 1;
if ( argc == 0 )  l(); 
else
	while (--argc > 0) 
		l.soinc( *++argv );
return 0;
}
#endif
//term* lex::operator()() { return 0; }
//</>
