// csclient.cc

#include <hush/net/cs/csclient.h>
#include <hush/net/cs/csclientimp.h>
#include <hush/net/cs/samlib.h>

#include <stdio.h>

//---------------------------- csclient implementation ---------------------

csclient::csclient(csclientimp* imp, const csaddress* addr)
{
    init(imp, addr);
}


csclient::csclient(csclientimp* imp)
{
    init(imp, NULL);
}


void csclient::init(csclientimp* imp, const csaddress* addr)
{
    _imp = imp;
    if (_imp == NULL)
    {
        warn("csclient::init : _imp = NULL");
        return;
    }
    if (addr != NULL)
        _imp -> connect_imp(addr);
}


csclient::~csclient()
{
    _imp = NULL;
}


int csclient::connect()
{
    return _imp -> connect_imp();
}


int csclient::connect(const csaddress* addr)
{
    return _imp -> connect_imp(addr);
}


int csclient::connected()
{
    return _imp -> connected_imp();
}


void csclient::disconnect()
{
    _imp -> disconnect_imp();
}


data_connection* csclient::connection() const
{
    return _imp -> connection_imp();
}


csaddress* csclient::address() const
{
    return _imp -> address_imp();
}


int csclient::read(char* buffer, int maxbytes)
{
    return _imp -> read_imp(buffer, maxbytes);
}


int csclient::readmsg(char* buffer, int maxbytes)
{
    return _imp -> readmsg_imp(buffer, maxbytes);
}


int csclient::write(const char* buffer, int nrbytes)
{
    return _imp -> write_imp(buffer, nrbytes);
}


int csclient::writemsg(const char* buffer, int nrbytes)
{
    return _imp -> writemsg_imp(buffer, nrbytes);
}


int csclient::ready(timeval* timeout)
{
    return _imp -> ready_imp(timeout);
}


int csclient::fd() const
{
    return _imp -> fd_imp();
}

