include resource.mk

platform = `hush-platform`

component = dv-objects
objects = `ls $(component)-*.cpp | sed -e "s:\.cpp:.o:g"`
library = lib$(component)

purge = 

component-cflags = 
component-ldflags = -L../lib -lhush 

make = $(MAKE) -f $(component).mk

##

all: purge compile link install

CFLAGS = $(component-cflags) -I../include 
LDFLAGS = -L../lib $(component-ldflags) 

purge:
	rm -f $(purge)

compile:
	$(make) $(objects)
link:
	$(LD) -o $(library).so $(objects) $(LDFLAGS)

static:
	$(AR) $(library).a $(objects)

install:
	cp $(library).so ../lib/$(platform)

clean:
	rm -f $(library).* $(component)*.o
