include resource.mk

component = dv-pl
objects = `ls $(component)-*.cpp | sed -e "s:\.cpp:.o:g"`
library = lib$(component)

purge = 

component-cflags = -DLIBRARY="\"`hush-root`/library/pl\"" \
		   -DPLATFORM="\"`hush-platform`\""

component-ldflags = -L../lib -lhush -L$(SHARE)/lib -lpl

make = $(MAKE) -f $(component).mk

##

all: purge compile link install

CFLAGS = $(component-cflags) -I../include 
LDFLAGS = $(component-ldflags) -L../lib -lsocket -lnsl -ldl

purge:

compile:
	$(make) $(objects)
link:
	$(LD) -o $(library).so $(objects) $(LDFLAGS)

static:
	$(AR) $(library).a $(objects)

install:
	cp $(library).so `hush-lib-platform`

clean:
	rm -f $(library).* $(component)*.o
