#include <hush/source.h>
#include <hush/agent/finder.h>

#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include <hush/iostream.h>

#ifndef WIN32
#include <sys/param.h>
#include <unistd.h>
#endif


finder* finder::_default = 0;

#define TYPE finder
#include <hush/sys/table.i>

#ifndef WIN32
extern "C" char *getwd(char*);
#endif

//static char _prefix[1024] = "";

static char hush_local_search_dirs[24][256];
static int ndir=0;

static char root[BUFSIZ];
//static int nroot=0;

finder::finder(const char* kind) {
	_finder = finder::lookup(kind);
	}

finder::finder(int argc, char* argv[])  {
	_finder = 0;
	reset(argc,argv);
	}



void 
finder::reset(int argc, char* argv[]) 
{
if (_finder) _finder->reset(argc,argv);
else {
char c;
char wd[512];

strcpy(hush_local_search_dirs[ndir++],".");
//cerr << "Sofar ... " << endl;
#ifndef WIN32
getwd(wd); // AE
strcpy(root,wd);
#endif
//cerr << "Sofar ... " << endl;
while ( (argc > 0 ) && ( argv[0][0] == '-' ) ) {
        //cerr << "Checking for paths " << argv[0] << endl;
        c = argv[0][1];
        switch(c) {
                case 'I': strcpy(hush_local_search_dirs[ndir++],argv[0]+2);
                //cerr << argv[0] << endl;
                break;
                case 'R': strcpy(root,argv[0]+2); break;
                default: // cerr << "No option: " << c << endl;
                         break;
                }
	argc--; argv++;
        }
#ifndef WIN32
chdir(root); 
getwd(wd);
#endif
//cerr << "ROOT: " << root << endl;
}
}

void finder::add(const char* dir) {
	if (_finder) _finder->add(dir);
	else
		strcpy(hush_local_search_dirs[ndir++],dir);
	}
        


char* finder::find(const char* s, const char* ext, int fl) 
{
if (_finder) return _finder->find(s,ext,fl);
ifstream *is;
int i=0;  
static char fs[1024];
if (fl);//Wall

sprintf(fs,"%s%s",s,ext);

is = new ifstream();
is->open(fs,ios::in);
int fp = !is->fail();

if (!fp)
    while ( i < ndir ) {
        fs[0]='\0';
        if (s[0]=='/' || s[0]=='.' || s[0]=='~' ) {
                sprintf(fs,"%s%s",s,ext); i=ndir;
                }
        else
                sprintf(fs,"%s/%s%s",hush_local_search_dirs[i],s,ext);
        is->open(fs,ios::in);
        fp = !is->fail();
        if (fp) i=ndir; else i++;
        }
//if (fp) cerr << "FILE: " << fs << endl;
if (is->fail()) {
	//cerr << "WARNING: " << fs << " DOES NOT EXIST" << endl;
	return 0;
	}
else is->close();
//assert(!is->fail());
if (fs) mark(s,fs);
return fs;
}



