// resolver.c -- nothing yet

#include <hush/source.h>

#include <hush/hush.h>
#include <hush/agent/resolver.h>
#include <hush/net/client/client.h> 
#include <hush/net/client/url.h> 
#include <hush/scene.h>

#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include <hush/io.h>


resolver* resolver::_default = 0;

#define TYPE resolver
#include <hush/sys/table.i>


#ifdef __MSWIN__
#include <io.h> // for mktemp
#endif

static const char* TMPFILE     = "@tmp_";

static int _filenumber = 0;


struct resolver_state {
resolver_state() { _client = new client(); }
client* _client;
char _buffer[2*1024];
char _filename[1024];
};

#define RESOLVER  ((resolver_state*)_state)
#define CLIENT ((client*)RESOLVER->_client)
#define buffer (CLIENT->_buffer)
#define filename (CLIENT->_filename)

resolver::resolver(const char* kind) {
_resolver = 0;
if (kind) _resolver = resolver::lookup(kind);
if (!_resolver)
	_state = (void*) new resolver_state();
}

int resolver::check(const char* x) {
	if (_resolver) return _resolver->check(x);
	url u(x);
	if (!strcmp(u.protocol(),"any")) {
		//AE delete CLIENT;
		RESOLVER->_client = new client();
		return 1;
		}
	return 0;
	}

static char g_tmpname[1024];
static char g_filename[1024];

char* resolver::file(const char* url, const char* name) {
	if (_resolver) return _resolver->file(url,name);
	check(url);
	ofstream tmp;
	
	char* _name = g_filename;
	sprintf(_name,"%s",dvscene::_cache());
	if (!name) {
		sprintf(g_tmpname,"%s%d_XXXXXX",TMPFILE,::_filenumber++);
		mktemp(g_tmpname);
		strcat(_name,g_tmpname);
		strcat(_name,".tmp");
		}
	else
		strcat(_name,name);
	int n; char* p;
	CLIENT->get(url);
	//cerr << "Resolving: " << url << " for: " << _name << endl;
	if (!CLIENT->send_request()) {
		//cerr << "Failed to locate " << url << endl;
		return 0;
		}
	if (!CLIENT->get_reply_body(p,n)) {
		//cerr << "Failed to get data " << url << endl;
		return 0;
		}
	tmp.open(_name);
	tmp.write(p, n);
	tmp.close();
	mark(url,_name); //AE: ...
	return _name;
}

char* resolver::get(const char* url) {
	if (_resolver) return _resolver->get(url);
	int n; char* p;
	CLIENT->get(url);
	CLIENT->send_request();
	CLIENT->get_reply_body(p,n);
	return p;
}
