#include <hush/source.h>

#include <hush/item.h>
#include <hush/sys/bind.h>

#define TYPE item
#include "hush/sys/table.i"

item::item()  { it = 0; refs = 0; item::created++; }
item::item(const char*)  { it = 0; refs = 0; item::created++; }
item::item(item* x)  { it = x; refs = 1; item::created++; }

item::item(item& x) { 
	item::created++;
	it = x.it;
	if (it) it->refs++;
	}

item& item::operator=(item& x) {
	if ( it && it->refs == 0) delete it;
	else if (it)  it->refs--;
	it = x.it;
	if (it) it->refs++;
	return *this;
	}

item::~item() {
	item::deleted++;
	if (it && it->refs==0) {
		delete it;
		}
	else if (it) it->refs--;
	}

int item::no() const { return it?it->no():0; }

char* item::id() const { return it?it->id():0; }

item::operator int() const { return it?it->no():0; }

char* item::name() const { return it?it->name():0; }


//item::operator char*() const { return it?it->id():0; }

item* item::operator ->() { return it?it:this; }

void item::tag(const char* s) { if (it) it->tag(s); }
char* item::tags() const { return it?it->tags():0; }
char* item::coords() const { return it?it->coords():0; }
char* item::bbox() const { return it?it->bbox():0; }

void item::configure(const char* s) { if (it) it->configure(s); }

void item::move(int x, int y) {
	if (it) it->move(x,y);
	}

void item::del() { if (it) it->del(); }

/// binding

int item::bind(const char *s, handler* h, const char* args) {
	item* x = it;
	return x?x->bind(s,h,args):0;
	}


int item::bind(const char *s, binding* a, const char* args ) {
	return direct(s,a,args);
	}

/// For Gnu


int item::bind(class handler* h, const char* args ) {
	return it?it->bind(h,args):0;
	}

int item::direct(const char*s, binding* ac, const char* args) {
	return it?it->direct(s,ac,args):0;
	}

class widget* item::widget() {
	return it?it->widget():0;
	}


void item::install(binding* ac, const char* args) {
	if (it) it->install(ac,args);
	}
