#include <hush/source.h>

// garbage.c -- to clean it all up

#include "hush/sys/garbage.i"

#include <hush/hush.h>
#include <hush/garbage.h>

#include <hush/iter.h>
#include <hush/string.h>
#include <hush/dictionary.h>

#ifndef NOLIST
#include <hush/list.h>
#endif

#include <hush/sys/cell.h>

#include "hush/sys/local.i"
#include "hush/sys/macros.i"
 

int garbage_type::created = 0;
int garbage_type::deleted = 0;

garbage_type::garbage_type() { created ++; }
garbage_type::~garbage_type() { deleted++; }

hush_garbage::hush_garbage() {
vmgarb = 0, agarb = 0; tgarb = 0; bgarb = 0;
garb = 0; hgarb=0; cgarb=0; sgarb=0; lgarb=0; igarb=0; dgarb=0; rgarb=0;
clgarb = 0; srgarb = 0;
}

hush_garbage::~hush_garbage() {
  HUSHDELETE(tgarb,term);
  HUSHADELETE(agarb,char);
  HUSHDELETE(garb, garbage<void>);
  HUSHDELETE(hgarb,handler);
  HUSHDELETE(cgarb,cell);
  HUSHDELETE(sgarb,string);
#ifndef NOLIST
  HUSHDELETE(lgarb,list<void>);
#endif
  HUSHDELETE(igarb,iter<void>);
  HUSHDELETE(dgarb,dictionary<void>);
  HUSHDELETE(rgarb,hush_garbage);
  HUSHDELETE(bgarb,dvbinding);
  HUSHDELETE(clgarb,clt_type);
  HUSHDELETE(srgarb,srv_type);
  HUSHDELETE(vmgarb,vm_type);
  }

void hush_garbage::_register( const handler* h) { REGISTER(hgarb,h); }
void hush_garbage::_register( const term* t) { REGISTER(tgarb,t); }
void hush_garbage::_register( const char* a) { REGISTER(agarb,a); }
void hush_garbage::_register( const cell* c) { REGISTER(cgarb,c); } 
void hush_garbage::_register( const string* s) { REGISTER(sgarb,s); } 

#ifndef NOLIST
void hush_garbage::_register( const list_type* l) { REGISTER(lgarb,l); } 
#endif

void hush_garbage::_register( const dictionary_type* d) { REGISTER(dgarb,d); } 
void hush_garbage::_register( const hush_garbage* r) { REGISTER(rgarb,r); } 
void hush_garbage::_register( const iter_type* i) { REGISTER(igarb,i); } 
void hush_garbage::_register( const garbage_type* g) { REGISTER(garb,g); } 
void hush_garbage::_register( const dvbinding* b) { REGISTER(bgarb,b); } 
void hush_garbage::_register( const srv_type* i) { REGISTER(srgarb,i); } 
void hush_garbage::_register( const clt_type* i) { REGISTER(clgarb,i); } 
void hush_garbage::_register( const vm_type* i) { REGISTER(vmgarb,i); } 
