#include <hush/source.h>

#include <hush/widgets/entry.h>
#include <hush/sys/bind.h>

char* entry::type() const { return "entry"; }

#define TYPE entry
#include "hush/widgets/create.i"



void entry::insert(const char* s) {
	if (_exists()) _this()->insert(s);
	else _error("insert");
	}




void entry::insert(const char* s, const char* options) {
	if (_exists()) _this()->insert(s,options);
	else _error("insert");
	}
 
void entry::insert(const char* s, int i) {
	if (_exists()) _this()->insert(s,i);
	else _error("insert");
	}

void entry::del() {
	if (_exists()) _this()->del();
	else _error("del");
	}

void entry::del(const char* options) {
	if (_exists()) _this()->del(options);
	else _error("del");
	}

void entry::del(int from, int to) {
	if (_exists()) _this()->del(from,to);
	else _error("del");
	}

char* entry::get() const {
	if (_exists()) return _this()->get();
	else return (char*) _error("get");
	}

int entry::index(const char* i) const {
	if (_exists()) return _this()->index(i);
	else return (int) _error("index");
	}

void entry::install(binding* ac, const char* args) {
	if (_exists()) _this()->install(ac,args);
	else _error("install");
	}
