#include <widgets/source.h>

#include <hush/widgets/text.h>
#include <hush/sys/bind.h>

#define text dvtext

char* text::type() const { return "text"; }

#define TYPE text
#include "hush/widgets/create.i"




void text::insert(const char* s) {
	if (_exists()) _this()->insert(s);
	else _error("insert");
	}

void text::insert(int l, int n, const char* s, const char* tags) {
	if (_exists()) _this()->insert(l,n,s,tags);
	else _error("insert");
	}

void text::insert(const char* ind, const char* s, const char* tags) {
	if (_exists()) _this()->insert(ind,s,tags);
	else _error("insert");
	}

void text::del(const char* from, const char* to) {
	if (_exists()) _this()->del(from,to);
	else _error("del");
	}

void text::del(int fromline, int fromcol, int toline, int tocol) {
	if (_exists()) _this()->del(fromline, fromcol, toline, tocol);
	else _error("del");
	}

char* text::get(const char* from, const char* to) const {
	if (_exists()) return _this()->get(from, to);
	else return (char*) _error("get");
	}

char* text::get(int fromline, int fromcol, int toline, int tocol) const {
	if (_exists()) return _this()->get(fromline, fromcol, toline, tocol);
	else return (char*) _error("get");
	}

void text::install(binding* ac, const char* args ) {
	if (_exists()) _this()->install(ac,args);
	else _error("install");
	}

void text::enable() {
	if (_exists()) _this()->enable();
	else _error("enable");
	}

void text::disable() {
	if (_exists()) _this()->disable();
	else _error("disable");
	}
