#include <hush/java.h>
#include <hush/item.h>

#include <hush/session.h>
#include <hush/string.h>

#undef string

#include <hush/io.h>

#include <native/hush_dv_api_item.h>


#define method(X) Java_hush_dv_api_item_##X


JNIEXPORT void JNICALL method(bind)(JNIEnv *env, jobject obj,
	       jobject o)
{
  java_vm<item> vm(env,obj);
  java_vm<handler>* vmp = new java_vm<handler>(env,o,"Handler");
  handler* h = vmp->self();
  if (h) {
	if (!h->_vmp) h->_vmp = vmp;
  } else {
	h = new handler();
	session::_default->_register(h);
	h->_vmp = vmp;
  }
  h->_register(vmp);
  vm->bind(h); // AE
}

JNIEXPORT void JNICALL method(configure)(JNIEnv *env, jobject obj,
		jstring str)
{
	java_vm<item> vm(env,obj);
	char* _str = vm.get(str);
	vm->configure(_str);
	vm.release(str);
}

JNIEXPORT jint JNICALL method(isvalid)(JNIEnv *env, jobject obj)
{
	java_vm<item> vm(env,obj);
	return vm->no();
}

JNIEXPORT void JNICALL method(tag)(JNIEnv *env, jobject obj,
		jstring str)
{
	java_vm<item> vm(env,obj);
	char* _str = vm.get(str);
	vm->tag(_str);
	vm.release(str);
}

JNIEXPORT jstring JNICALL method(tags)(JNIEnv *env, jobject obj)
{
	java_vm<item> vm(env,obj);
	char* s = vm->tags();
	return vm.string(s);
}

JNIEXPORT jstring JNICALL method(coords)(JNIEnv *env, jobject obj)
{
	java_vm<item> vm(env,obj);
	char* s = vm->coords();
	return vm.string(s);
}

JNIEXPORT jstring JNICALL method(bbox)(JNIEnv *env, jobject obj)
{
	java_vm<item> vm(env,obj);
	char* s = vm->bbox();
	return vm.string(s);
}

JNIEXPORT void JNICALL method(move)(JNIEnv *env, jobject obj,
		jint x, jint y)
{
	java_vm<item> vm(env,obj);
	vm->move((int)x,(int)y);
}

JNIEXPORT void JNICALL method(del)(JNIEnv *env, jobject obj)
{
	java_vm<item> vm(env,obj);
	vm->del();
}


JNIEXPORT jint JNICALL method(getwidget)(JNIEnv *env, jobject obj)
{
	java_vm<item> vm(env,obj);
	widget* w = vm->widget();
	return (jint) w;
}
