#include <hush/java.h>
#include <hush/widget.h>
#include <hush/session.h>

//#include <iostream.h>
#undef string

#include <native/hush_dv_api_widget.h>

#define method(X) Java_hush_dv_api_widget_##X

JNIEXPORT void JNICALL method(pack)(JNIEnv *env, jobject obj,
	       jstring str)
{
  java_vm<widget> vm(env,obj);
  char* s = vm.get(str);
  //cerr << "Options pack " << s << endl;
  if (s[0]=='*')
  	vm->pack();
  else
	vm->pack(s);
  vm.release(str);
}

JNIEXPORT void JNICALL method(title)(JNIEnv *env, jobject obj,
	       jstring opts)
{
  java_vm<widget> vm(env,obj);
  char* _opts = vm.get(opts);
  vm->title(_opts);
  vm.release(opts);
}

JNIEXPORT void JNICALL method(eval)(JNIEnv *env, jobject obj,
	       jstring opts)
{
  java_vm<widget> vm(env,obj);
  char* _opts = vm.get(opts);
  vm->eval(_opts);
  vm.release(opts);
}

JNIEXPORT void JNICALL method(configure)(JNIEnv *env, jobject obj,
	       jstring opts)
{
  java_vm<widget> vm(env,obj);
  char* _opts = vm.get(opts);
  vm->configure(_opts);
  vm.release(opts);
}

JNIEXPORT void JNICALL method(dobind)(JNIEnv *env, jobject obj,
	       jobject o, jstring info)
{
  java_vm<widget> vm(env,obj);
  char* s = vm.get(info);
  java_vm<handler>* vmp = new java_vm<handler>(env,o,"Handler");
  handler* h = vmp->self(); // the (java) peer
  if (h) {
	//cerr << "Setting (widget) VM" << endl;
	//if (!h->_vmp) h->_vmp = vmp;
	delete vmp;
  } else {
	//cerr << "Creating (widget) VM" << endl;
	h = new handler();
	session::_default->_register(h);
	h->_vmp = vmp;
	h->_register(vmp);
  }
  //vm->bind(h,s); // AE
  vm->self()->bind(h,s); // AE
  vm.release(info);
}

JNIEXPORT void JNICALL method(dopbind)(JNIEnv *env, jobject obj,
	       jstring pat, jobject o, jstring info)
{
  java_vm<widget> vm(env,obj);
  char* p = vm.get(pat);
  char* s = vm.get(info);
  java_vm<handler>* vmp = new java_vm<handler>(env,o,"Handler");
  handler* h = vmp->self(); // the (java) peer
  if (h) {
	//cerr << "Setting (widget) VM" << endl;
	//if (!h->_vmp) h->_vmp = vmp;
	delete vmp;
  } else {
	//cerr << "Creating (widget) VM" << endl;
	h = new handler();
	session::_default->_register(h);
	h->_vmp = vmp;
  }
  //vm->bind(p,h,s); // AE
  vm->self()->bind(p,h,s); // AE
  vm.release(info);
  vm.release(pat);
}

JNIEXPORT void JNICALL method(geometry)(JNIEnv *env, jobject obj,
	       jint x, jint y)
{
  java_vm<widget> vm(env,obj);
  vm->geometry((int)x,(int)y);
}

JNIEXPORT jstring JNICALL method(path)(JNIEnv *env, jobject obj)
{
  java_vm<widget> vm(env,obj);
  char* s = vm->path();
  //cerr << "path " << s << endl;
  return vm.string(s);
}

JNIEXPORT void JNICALL method(xscroll)(JNIEnv *env, jobject obj,
		  jobject w)
{
  java_vm<widget> vm(env,obj);
  java_vm<widget> wp(env,w);
  vm->xscroll(wp.self());
}

JNIEXPORT void JNICALL method(yscroll)(JNIEnv *env, jobject obj,
		  jobject w)
{
  java_vm<widget> vm(env,obj);
  java_vm<widget> wp(env,w);
  vm->yscroll(wp.self());
}

JNIEXPORT void JNICALL method(redirect)(JNIEnv *env, jobject obj,
		  jobject w)
{
  java_vm<widget> vm(env,obj);
  java_vm<widget> wp(env,w);
  //cerr << "redirect" <<  wp->self() << endl;
  vm->redirect(wp->self()); // AE
}

JNIEXPORT void JNICALL method(alias)(JNIEnv *env, jobject obj,
		  jobject w)
{
  java_vm<widget> vm(env,obj);
  java_vm<handler> wp(env,w);
  vm->alias(wp.self());
}

JNIEXPORT jint JNICALL method(selfid)(JNIEnv *env, jobject obj)
{
  java_vm<widget> vm(env,obj);
  return (int) vm->self();
}
