#include <hush/sim/event.h>
#include <hush/sim/histogram.h>
#include <hush/string.h>

#include <hush/java.h>

#undef string

#include <native/hush_dv_sim_event.h>

#define method(X) Java_hush_dv_sim_event_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj,
   jint kf)
{
  java_vm<simevent>* vmp = new java_vm<simevent>(env,obj,"Event");
  event* result = 0;
  result =  new simevent(0,0,(int)kf);
  result->_vmp = vmp;
  session::_default->_register(result);
  result->_register(vmp);
  return (jint) result;
}


JNIEXPORT jint JNICALL method(report)(JNIEnv *env, jobject obj,
   jobject hist, jdouble interv)
{
  java_vm<event> vm(env,obj);
  java_vm<histogram> vmh(env,hist);
  histogram* h = vmh.self();
  return (jint) vm->report(h,(double)interv);
}

JNIEXPORT void JNICALL method(stamp)(JNIEnv *env, jobject obj) 
{
  java_vm<event> vm(env,obj);
  vm->stamp();
}

JNIEXPORT jdouble JNICALL method(timespent)(JNIEnv *env, jobject obj) 
{
  java_vm<event> vm(env,obj);
  return (jdouble) vm->timespent();
}

JNIEXPORT jint JNICALL method(getQueuingpriority)(JNIEnv *env, jobject obj) 
{
  java_vm<event> vm(env,obj);
  return (jint) vm->queuingpriority();
}

JNIEXPORT void JNICALL method(setQueuingpriority)(JNIEnv *env, jobject obj,
	jint pr) 
{
  java_vm<event> vm(env,obj);
  vm->queuingpriority((int)pr);
}

JNIEXPORT jint JNICALL method(getSchedulingpriority)(JNIEnv *env, jobject obj) 
{
  java_vm<event> vm(env,obj);
  return (jint) vm->schedulingpriority();
}

JNIEXPORT void JNICALL method(setSchedulingpriority)(JNIEnv *env, jobject obj,
	jint pr) 
{
  java_vm<event> vm(env,obj);
  vm->schedulingpriority((int)pr);
}

JNIEXPORT jboolean JNICALL method(active)(JNIEnv *env, jobject obj) 
{
  java_vm<event> vm(env,obj);
  return (jboolean) vm->_active();
}

JNIEXPORT jboolean JNICALL method(pending)(JNIEnv *env, jobject obj) 
{
  java_vm<event> vm(env,obj);
  return (jboolean) vm->pending();
}

JNIEXPORT jboolean JNICALL method(conditional)(JNIEnv *env, jobject obj) 
{
  java_vm<event> vm(env,obj);
  return (jboolean) vm->conditional();
}

JNIEXPORT jboolean JNICALL method(closed)(JNIEnv *env, jobject obj) 
{
  java_vm<event> vm(env,obj);
  return (jboolean) vm->closed();
}

JNIEXPORT jboolean JNICALL method(passive)(JNIEnv *env, jobject obj) 
{
  java_vm<event> vm(env,obj);
  return (jboolean) vm->passive();
}

JNIEXPORT jboolean JNICALL method(queued)(JNIEnv *env, jobject obj) 
{
  java_vm<event> vm(env,obj);
  return (jboolean) vm->queued();
}
