#include <hush/kit.h>
#include <hush/session.h>
#include <hush/sim/simulation.h>

#include <hush/java.h>
#include <hush/io.h>

#include <native/hush_dv_sim_simulation.h>

#define method(X) Java_hush_dv_sim_simulation_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, jint i)
{
  if (env && obj); // Wall
  //simulation::hush_enabled = 0;
  jint result = (jint) new simulation((int)i); // (jint) new kit();
  session::_default->_register((kit*)result);
  return result;
}

JNIEXPORT void JNICALL method(run)(JNIEnv *env, jobject obj)
{
  java_vm<simulation> vm(env,obj);
  vm->run();
}

JNIEXPORT void JNICALL method(runi)(JNIEnv *env, jobject obj, jint i)
{
  java_vm<simulation> vm(env,obj);
  vm->run((int)i);
}

JNIEXPORT void JNICALL method(runf)(JNIEnv *env, jobject obj, jdouble f)
{
  java_vm<simulation> vm(env,obj);
  vm->run((double)f);
}

JNIEXPORT void JNICALL method(quit)(JNIEnv *env, jobject obj)
{
  java_vm<simulation> vm(env,obj);
  vm->quit();
}

JNIEXPORT jint JNICALL method(terminate)(JNIEnv *env, jobject obj,
	jobject eo)
{
  java_vm<simulation> vm(env,obj);
  java_vm<event> evm(env,eo);
  event* e = evm.self();
  return (jint) vm->terminate(e);
}

JNIEXPORT jint JNICALL method(schedule)(JNIEnv *env, jobject obj,
	jobject eo, jdouble t)
{
  java_vm<simulation> vm(env,obj);
  java_vm<event> evm(env,eo);
  event* e = evm.self();
  return (jint) vm->schedule(e,(double)t);
}

JNIEXPORT void JNICALL method(realtime)(JNIEnv *env, jobject obj,
	jdouble t)
{
  java_vm<simulation> vm(env,obj);
  vm->realtime((double)t);
}

JNIEXPORT jint JNICALL method(wait)(JNIEnv *env, jobject obj,
	jdouble t)
{
  java_vm<simulation> vm(env,obj);
  return (jint) vm->wait((double)t);
}

JNIEXPORT jint JNICALL method(passivate)(JNIEnv *env, jobject obj,
	jobject eo)
{
  java_vm<simulation> vm(env,obj);
  java_vm<event> evm(env,eo);
  event* e = evm.self();
  return (jint) vm->passivate(e);
}

JNIEXPORT jint JNICALL method(activate)(JNIEnv *env, jobject obj,
	jobject eo)
{
  java_vm<simulation> vm(env,obj);
  java_vm<event> evm(env,eo);
  event* e = evm.self();
  return (jint) vm->activate(e);
}

JNIEXPORT jint JNICALL method(hold)(JNIEnv *env, jobject obj,
	jobject eo)
{
  java_vm<simulation> vm(env,obj);
  java_vm<event> evm(env,eo);
  event* e = evm.self();
  return (jint) vm->hold(e);
}

JNIEXPORT jint JNICALL method(withdraw)(JNIEnv *env, jobject obj,
	jobject eo)
{
  java_vm<simulation> vm(env,obj);
  java_vm<event> evm(env,eo);
  event* e = evm.self();
  return (jint) vm->withdraw(e);
}

JNIEXPORT jint JNICALL method(reinstate)(JNIEnv *env, jobject obj,
	jobject eo)
{
  java_vm<simulation> vm(env,obj);
  java_vm<event> evm(env,eo);
  event* e = evm.self();
  return (jint) vm->withdraw(e);
}

JNIEXPORT jint JNICALL method(cancel)(JNIEnv *env, jobject obj)
{
  java_vm<simulation> vm(env,obj);
  return (jint) vm->cancel();
}

JNIEXPORT void JNICALL method(reset)(JNIEnv *env, jobject obj)
{
  java_vm<simulation> vm(env,obj);
  vm->reset();
}

JNIEXPORT void JNICALL method(cout)(JNIEnv *env, jobject obj)
{
  java_vm<simulation> vm(env,obj);
  cout << *(vm.self()) << endl;
}
