#include <hush/java.h>
#include <hush/io.h>

#include <widgets/button.h>
#include <hush/session.h>

#undef string

#include <native/hush_dv_widgets_button.h>

#define method(X) Java_hush_dv_widgets_button_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, 
	   jint root, jstring name, jstring options)
{
  java_vm<button>* vmp = new java_vm<button>(env,obj,"Button");
  char* path = vmp->get(name);
  char* opts = vmp->get(options);
  int r = (int) root;
  button* result = 0;
  if (r)
  	result =  new button((widget*)r,path,opts);
  else {
	result = new button(path,opts);
        session::_default->_register(result);
  }
  result->_register(vmp);
  result->_vmp = vmp;
  vmp->release(name,path);
  vmp->release(options,opts);
  return (jint) result;
}

JNIEXPORT void JNICALL method(text)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<button> vm(env,obj);
  char* s = vm.get(txt);
  vm->text(s);
  vm.release(txt);;
}

JNIEXPORT void JNICALL method(bitmap)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<button> vm(env,obj);
  char* s = vm.get(txt);
  vm->bitmap(s);
  vm.release(txt);;
}

JNIEXPORT void JNICALL method(image)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<button> vm(env,obj);
  char* s = vm.get(txt);
  vm->image(s);
  vm.release(txt);;
}

JNIEXPORT void JNICALL method(state)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<button> vm(env,obj);
  char* s = vm.get(txt);
  vm->state(s);
  vm.release(txt);;
}

JNIEXPORT void JNICALL method(flash)(JNIEnv *env, jobject obj)
{
  java_vm<button> vm(env,obj);
  vm->flash();
}

JNIEXPORT jstring JNICALL method(invoke)(JNIEnv *env, jobject obj)
{
  java_vm<button> vm(env,obj);
  char* s = vm->invoke();
  return vm.string(s);
}
