#include <hush/java.h>
#include <hush/io.h>

#include <widgets/entry.h>
#include <hush/session.h>

#undef string

#include <native/hush_dv_widgets_entry.h>

#define method(X) Java_hush_dv_widgets_entry_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, 
	   jint root, jstring name, jstring options)
{
  java_vm<entry>* vmp = new java_vm<entry>(env,obj,"Entry");
  char* path = vmp->get(name);
  char* opts = vmp->get(options);
  int r = (int) root;
  entry* result = 0;
  cerr << "creating entry " <<  endl;
  if (r)
  	result =  new entry((widget*)r,path,opts);
  else {
	result = new entry(path,opts);
        session::_default->_register(result);
  }
  result->_register(vmp);
  result->_vmp = vmp;
  vmp->release(name,path);
  vmp->release(options,opts);
  return (jint) result;
}


JNIEXPORT void JNICALL method(insert)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<entry> vm(env,obj);
  char* s = vm.get(txt);
  vm->insert(s);
  vm.release(txt);;
}

JNIEXPORT jstring JNICALL method(get)(JNIEnv *env, jobject obj)
{
  java_vm<entry> vm(env,obj);
  char* s = vm->get();
  return vm.string(s);
}

JNIEXPORT void JNICALL method(del)(JNIEnv *env, jobject obj)
{
  java_vm<entry> vm(env,obj);
  vm->del();
}
