#include <hush/java.h>
#include <hush/io.h>

#include <widgets/filechooser.h>
#include <hush/session.h>

#undef string

#include <native/hush_dv_widgets_filechooser.h>

#define method(X) Java_hush_dv_widgets_filechooser_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, 
	   jint root, jstring name, jstring options)
{
  java_vm<filechooser>* vmp = new java_vm<filechooser>(env,obj,"FileChooser");
  char* path = vmp->get(name);
  char* opts = vmp->get(options);
  int r = (int) root;
  filechooser* result = 0;
  cerr << "creating filechooser " <<  endl;
  if (r)
  	result =  new filechooser((widget*)r,path,opts);
  else {
	result = new filechooser(path,opts);
        session::_default->_register(result);
  }
  //AE result->_vmp = vmp;
  result->_register(vmp);
  vmp->release(name,path);
  vmp->release(options,opts);
  return (jint) result;
}


JNIEXPORT void JNICALL method(setmask)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<filechooser> vm(env,obj);
  char* s = vm.get(txt);
  vm->mask(s);
  vm.release(txt);;
}

JNIEXPORT jstring JNICALL method(getmask)(JNIEnv *env, jobject obj)
{
  java_vm<filechooser> vm(env,obj);
  char* s = (char*) vm->mask();
  return vm.string(s);
}

JNIEXPORT void JNICALL method(setdirpath)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<filechooser> vm(env,obj);
  char* s = vm.get(txt);
  vm->dirpath(s);
  vm.release(txt);;
}

JNIEXPORT jstring JNICALL method(getdirpath)(JNIEnv *env, jobject obj)
{
  java_vm<filechooser> vm(env,obj);
  char* s = (char*) vm->dirpath();
  return vm.string(s);
}

JNIEXPORT void JNICALL method(rescan)(JNIEnv *env, jobject obj)
{
  java_vm<filechooser> vm(env,obj);
  vm->rescan();
}

JNIEXPORT jstring JNICALL method(get)(JNIEnv *env, jobject obj)
{
  java_vm<filechooser> vm(env,obj);
  char* s = (char*) vm->get();
  return s?vm.string(s):vm.string("");
}
