#include <hush/java.h>
#include <hush/io.h>

#include <widgets/label.h>
#include <hush/session.h>

#undef string

#include <native/hush_dv_widgets_label.h>

#define method(X) Java_widgets_label_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, 
	   jint root, jstring name, jstring options)
{
  java_vm<label>* vmp = new java_vm<label>(env,obj,"Label");
  char* path = vmp->get(name);
  char* opts = vmp->get(options);
  int r = (int) root;
  label* result = 0;
  cerr << "creating label " <<  endl;
  if (r)
  	result =  new label((widget*)r,path,opts);
  else {
	result = new label(path,opts);
        session::_default->_register(result);
  }
  result->_register(vmp);
  result->_vmp = vmp;
  vmp->release(name,path);
  vmp->release(options,opts);
  return (jint) result;
}


JNIEXPORT void JNICALL method(text)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<label> vm(env,obj);
  char* s = vm.get(txt);
  vm->text(s);
  vm.release(txt);;
}

JNIEXPORT void JNICALL method(text)(JNIEnv *env, jobject obj, 
	   jint i)
{
  java_vm<label> vm(env,obj);
  vm->text((int)i);
}

JNIEXPORT void JNICALL method(text)(JNIEnv *env, jobject obj, 
	   jdouble i)
{
  java_vm<label> vm(env,obj);
  vm->text((double)i);
}

JNIEXPORT void JNICALL method(bitmap)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<label> vm(env,obj);
  char* s = vm.get(txt);
  vm->bitmap(s);
  vm.release(txt);;
}

JNIEXPORT void JNICALL method(image)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<label> vm(env,obj);
  char* s = vm.get(txt);
  vm->image(s);
  vm.release(txt);;
}
