#include <hush/java.h>
#include <hush/io.h>

#include <widgets/radiobutton.h>
#include <hush/session.h>

#undef string

#include <native/hush_dv_widgets_radiobutton.h>

#define method(X) Java_widgets_radiobutton_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, 
	   jint root, jstring name, jstring options)
{
  java_vm<radiobutton>* vmp = new java_vm<radiobutton>(env,obj,"RadioButton");
  char* path = vmp->get(name);
  char* opts = vmp->get(options);
  int r = (int) root;
  radiobutton* result = 0;
  cerr << "creating radiobutton " <<  endl;
  if (r)
  	result =  new radiobutton((widget*)r,path,opts);
  else {
	result = new radiobutton(path,opts);
        session::_default->_register(result);
  }
  result->_register(vmp);
  result->_vmp = vmp;
  vmp->release(name,path);
  vmp->release(options,opts);
  return (jint) result;
}


JNIEXPORT void JNICALL method(variable)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<radiobutton> vm(env,obj);
  char* s = vm.get(txt);
  vm->text(s);
  vm.release(txt);;
}

JNIEXPORT jstring JNICALL method(value)(JNIEnv *env, jobject obj)
{
  java_vm<radiobutton> vm(env,obj);
  char* s = vm->value();
  return vm.string(s);
}

JNIEXPORT void JNICALL method(toggle)(JNIEnv *env, jobject obj)
{
  java_vm<radiobutton> vm(env,obj);
  vm->toggle();
}

JNIEXPORT void JNICALL method(select)(JNIEnv *env, jobject obj)
{
  java_vm<radiobutton> vm(env,obj);
  vm->select();
}

JNIEXPORT void JNICALL method(deselect)(JNIEnv *env, jobject obj)
{
  java_vm<radiobutton> vm(env,obj);
  vm->deselect();
}
