#include <hush/java.h>
#include <hush/io.h>

#include <widgets/scrollbar.h>
#include <hush/session.h>

#undef string

#include <native/hush_dv_widgets_scrollbar.h>

#define method(X) Java_hush_dv_widgets_scrollbar_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, 
	   jint root, jstring name, jstring options)
{
  java_vm<scrollbar>* vmp = new java_vm<scrollbar>(env,obj,"Scrollbar");
  char* path = vmp->get(name);
  char* opts = vmp->get(options);
  int r = (int) root;
  scrollbar* result = 0;
  cerr << "creating scrollbar " <<  endl;
  if (r)
  	result =  new scrollbar((widget*)r,path,opts);
  else {
	result = new scrollbar(path,opts);
        session::_default->_register(result);
  }
  result->_register(vmp);
  result->_vmp = vmp;
  vmp->release(name,path);
  vmp->release(options,opts);
  return (jint) result;
}


JNIEXPORT void JNICALL method(orient)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<scrollbar> vm(env,obj);
  char* s = vm.get(txt);
  vm->orient(s);
  vm.release(txt);;
}

JNIEXPORT void JNICALL method(xview)(JNIEnv *env, jobject obj, 
	   jobject x)
{
  java_vm<scrollbar> vm(env,obj);
  java_vm<widget> vx(env,x);
  vm->xview(vx.self());
}

JNIEXPORT void JNICALL method(yview)(JNIEnv *env, jobject obj, 
	   jobject x)
{
  java_vm<scrollbar> vm(env,obj);
  java_vm<widget> vx(env,x);
  vm->yview(vx.self());
}
