#ifndef IMPLEMENT
#define IMPLEMENT

#include <hush/source.h>


#include <hush/widgets/tk/button.h>
#define BUTTON_C

#define TYPE button
#define CLASS tk_button
#include "hush/widgets/tk/create.i"
#define endl "\n"

#include <hush/sys/bind.h>

#include <string.h>
#include <stdio.h>


#ifdef TKFILLUP
#include "widgets/tk/widget.c"
#endif

#endif



void CLASS::text(const char* s) { 
	sprintf(buf,"%s configure -text \"%s\"",path(),s);
	tk->eval(buf);
	}

void CLASS::bitmap(const char* s) { 
	if (s[0] != '@')
		sprintf(buf,"%s configure -bitmap @%s",path(),s);
	else
		sprintf(buf,"%s configure -bitmap %s",path(),s);
	tk->eval(buf);
	}

void CLASS::image(const char* s) { 
	if (s[0] != '@')
		sprintf(buf,"%s configure -image %s",path(),s);
	else {
		sprintf(buf,"image create photo -file %s",s+1);
		char* r = tk->evaluate(buf);
		sprintf(buf,"%s configure -image %s",path(),r);
		}
	tk->eval(buf);
	}


void CLASS::state(const char *s) {
	if (!strcmp(s,"normal") && !strcmp(s,"active") && !strcmp(s,"disabled") )
		err() << "error: should be normal active or disabled" << endl;
	else {
		sprintf(buf,"%s configure -state %s",path(),s);
		tk->eval(buf);
		}
	}

void CLASS::flash() {
	sprintf(buf,"%s flash",path());
	tk->eval(buf);
	}

char* CLASS::invoke() {
	sprintf(buf,"%s invoke",path());
	return tk->evaluate( buf );
	}


void CLASS::install(binding* ac, const char* args) {
	sprintf(buf,"%s configure -command {%s %s}",path(),ac->name(),args);
	tk->eval( buf );
	}
