#include <hush/source.h>
#include <hush/widgets/tk/canvas.h>
#include <hush/widgets/tk/citem.h>

#include <hush/hush.h>


#include <hush/source.h>


#include <string.h>
#include <hush/assert.h>
#include <stdlib.h>
#include <stdio.h>

static item* new_c_item(int n, canvas* x) {
	item* i = new item( new c_item(n,x) );
	x->_register(i);
	return i;
	}

#define TYPE canvas
#define CLASS tk_canvas
#define CONSTRUCTOR _cs = 0;
#include "hush/widgets/tk/create.i"


void CLASS::region(int x1, int y1, int x2, int y2 ) {
	sprintf(buf,"%s configure -scrollregion { %d %d %d %d }",
		thepath(),x1,y1,x2,y2);
	tk->eval( buf );
	}


int CLASS::canvasx(int screenx) const { // returns x relative to canvas
                sprintf(buf, "%s canvasx %d", thepath(), screenx);
                if (0==tk->eval(buf)) return atoi(tk->result());
                else return -1;
            }

int CLASS::canvasy(int screeny) const { // returns y relative to canvas
                sprintf(buf, "%s canvasy %d", thepath(), screeny);
                if (0==tk->eval(buf)) return atoi(tk->result());
                else return -1;
            }

void CLASS::install(binding* ac, const char* args) {
	bind("<Any-ButtonPress>",ac, args);
	bind("<Any-ButtonRelease>",ac, args);
	bind("<Any-Motion>",ac, args );
	bind("<Enter>",ac, args );
	bind("<Leave>",ac, args );
	}

void CLASS::raise(const char* tag, const char* abovethis) {
	sprintf(buf,"%s raise %s %s", thepath(), tag, abovethis);
	tk->eval(buf);
	}

void CLASS::lower(const char* tag, const char* belowthis) {
	sprintf(buf,"%s lower %s %s", thepath(), tag, belowthis);
	tk->eval(buf);
	}

void CLASS::tag(int id, const char* tag) {
	sprintf(buf,"%s addtag %s withtag %d",thepath(),tag,id);
	tk->eval(buf);
	}

char* CLASS::tags(int id) const {
	sprintf(buf,"%s gettags %d",thepath(),id);
	return tk->evaluate(buf);
	}

char* CLASS::coords(int id) const{
        sprintf(buf,"%s coords %d",self()->name(),id);
        return tk->evaluate(buf);
        }

char* CLASS::coords(const char* id) const{
        sprintf(buf,"%s coords %s",self()->name(),id);
        return tk->evaluate(buf);
        }

char* CLASS::bbox(int id) const {
        sprintf(buf,"%s bbox %d",self()->name(),id);
        return tk->evaluate(buf);
        }

char* CLASS::bbox(const char* id) const {
        sprintf(buf,"%s bbox %s",self()->name(),id);
        return tk->evaluate(buf);
        }


void CLASS::del(int id) {
	sprintf(buf,"%s delete %d",thepath(),id);
	tk->eval(buf);
	}

void CLASS::del(const char* id) {
	sprintf(buf,"%s delete %s",thepath(),id);
	tk->eval(buf);
	}

void CLASS::move(int id, int x, int y) {
	sprintf(buf,"%s move %d %d %d",thepath(),id,x,y);
	tk->eval(buf);
	}

void CLASS::move(const char* id, int x, int y) {
	sprintf(buf,"%s move %s %d %d",thepath(),id,x,y);
	require(tk);
	tk->eval(buf);
	}

item* CLASS::bitmap(int x1, int y1, const char* bitmap, const char* options ) {
	x1 = convertx( x1 ); y1 = converty( y1 );
	if (bitmap[0] == '@' )
	sprintf(buf,"%s create bitmap %d %d -bitmap \"%s\" %s",thepath(),x1,y1,bitmap,options);
	else
	sprintf(buf,"%s create bitmap %d %d -bitmap \"%s\" %s",thepath(),x1,y1,bitmap,options);

	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}

item* CLASS::image(int x1, int y1, const char* bitmap, const char* options ) {
	x1 = convertx( x1 ); y1 = converty( y1 );
	if (bitmap[0] == '@' ) {
	sprintf(buf,"image create photo -file %s",bitmap+1);
	char* r = tk->evaluate( buf );
	sprintf(buf,"%s create image %d %d -image \"%s\" %s",thepath(),x1,y1,r,options);
	} else
	sprintf(buf,"%s create image %d %d -image \"%s\" %s",thepath(),x1,y1,bitmap,options);

	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}

item* CLASS::photo(int x1, int y1, int x2, int y2, const char* options) {
	x1 = convertx( x1 ); y1 = converty( y1 );
	x2 = convertx( x2 ); y2 = converty( y2 );
	sprintf(buf,"%s create photo %d %d %d %d %s",thepath(),x1,y1,x2,y2,options);
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}

void CLASS::readppm(int id, const char* file) {
	sprintf(buf,"readppm %s-%d %s",thepath(),id,file);
	tk->eval( buf );
	}

item* CLASS::line(int x1, int y1, int x2, int y2, const char* options) {
	x1 = convertx( x1 ); y1 = converty( y1 );
	x2 = convertx( x2 ); y2 = converty( y2 );
	sprintf(buf,"%s create line %d %d %d %d %s",thepath(),x1,y1,x2,y2,options);
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}

item* CLASS::line(const char* linespec, const char* options) {
	sprintf(buf,"%s create line %s %s",thepath(),linespec,options);
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}

item* CLASS::arc(int x1, int y1, int x2, int y2, const char* options) {
	x1 = convertx( x1 ); y1 = converty( y1 );
	x2 = convertx( x2 ); y2 = converty( y2 );
	sprintf(buf,"%s create arc %d %d %d %d %s",thepath(),x1,y1,x2,y2,options);
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}

item* CLASS::oval(int x1, int y1, int x2, int y2, const char* options) {
	x1 = convertx( x1 ); y1 = converty( y1 );
	x2 = convertx( x2 ); y2 = converty( y2 );
	sprintf(buf,"%s create oval %d %d %d %d %s",thepath(),x1,y1,x2,y2,options);
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}

item* CLASS::circle(int x1, int y1, int r, const char* options) {
	x1 = convertx( x1 ); y1 = converty( y1 );
	sprintf(buf,"%s create oval %d %d %d %d %s",thepath(),x1-r,y1-r,x1+r,y1+r,options);
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}

item* CLASS::polygon(const char* linespec, const char* options) {
	sprintf(buf,"%s create polygon %s %s",thepath(),linespec,options);
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}

item* CLASS::rectangle(int x1, int y1, int x2, int y2, const char* options) {
	x1 = convertx( x1 ); y1 = converty( y1 );
	x2 = convertx( x2 ); y2 = converty( y2 );
	sprintf(buf,"%s create rectangle %d %d %d %d %s",thepath(),x1,y1,x2,y2,options);
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}

item* CLASS::text(int x1, int y1, const char* txt, const char* options) {
	x1 = convertx( x1 ); y1 = converty( y1 );
	sprintf(buf,"%s create text %d %d -text \"%s\" %s",thepath(),x1,y1,txt,options);
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}

item* CLASS::window(int x1, int y1, const char* win, const char* options) {
	x1 = convertx( x1 ); y1 = converty( y1 );
	sprintf(buf,"%s create window %d %d -window \"%s\" %s",thepath(),x1,y1,win,options);
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}

item* CLASS::window(int x1, int y1, widget* win, const char* options) {
	x1 = convertx( x1 ); y1 = converty( y1 );
	sprintf(buf,"%s create window %d %d -window \"%s\" %s",thepath(),x1,y1,win->path(),options);
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}

item* CLASS::sphere(int x1, int y1, int x2, int y2, const char* color, const char* tag, const char* options) {
	x1 = convertx( x1 ); y1 = converty( y1 );
	x2 = convertx( x2 ); y2 = converty( y2 );
	sprintf(buf,"vsphere %s %s %d %d %d %d %s %s",thepath(),tag,x1,y1,x2,y2,color,options);
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}

item* CLASS::sphere(int x1, int y1, int r, const char* color, const char* tag, const char* options) {
	x1 = convertx( x1 ); y1 = converty( y1 );
	sprintf(buf,"vsphere %s %s %d %d %d %d %s %s",thepath(),tag,x1-r,y1-r,x1+r,y1+r,color,options);
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}

item* CLASS::current() {
	sprintf(buf,"%s find withtag current",thepath());
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}
	
item* CLASS::overlapping(int x, int y, const char* options) {
	char ids[BUFSIZ];  
	x = convertx( x ); y = converty( y );
	strcpy(ids, items(x,y));
	int n;
	if (!strcmp(options,"first")) {
		sscanf(ids,"%d",&n);
		}
	else {
		//AE p = ids.lindex( ids.llength() ); sscanf(p,"%d",&n);
		n = 0;
		}
	return new_c_item(n,this);
	}

item* CLASS::overlapping(int x, int y) {
	x = convertx( x ); y = converty( y );
	sprintf(buf,"%s find overlapping %d %d %d %d",thepath(),x-5,y-5,x+5,y+5);
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return new_c_item(n,this);
	}


char* CLASS::items(int x, int y) {
	x = convertx( x ); y = converty( y );
	sprintf(buf,"%s find overlapping %d %d %d %d",thepath(),x,y,x,y);
	return tk->evaluate( buf );
	}

char* CLASS::items(int x1, int y1, int x2, int y2) {
	x1 = convertx( x1 ); y1 = converty( y1 );
	x2 = convertx( x2 ); y2 = converty( y2 );
	sprintf(buf,"%s find overlapping %d %d %d %d",thepath(),x1,y1,x2,y2);
	return tk->evaluate( buf );
	}


void CLASS::itemconfigure(int it, const char* options) {
	sprintf(buf,"%s itemconfigure %d %s",thepath(),it,options);
	tk->eval(buf);
	}

void CLASS::itemconfigure(const char* tag, const char* options) {
	sprintf(buf,"%s itemconfigure %s %s",thepath(),tag,options);
	tk->eval(buf);
	}

int CLASS::itembind(int i, const char* s, binding* a, const char* args) {
        return itemdirect(i,s,a,args);
	}

int CLASS::itembind(const char *i, const char* s, binding* a, const char* args) {
        return itemdirect(i,s,a,args);
	}

void CLASS::postscript(const char* file, const char* options) {
	sprintf(buf,"%s postscript -fontmap hush::fontmap -file %s %s",thepath(), file, options);
	tk->eval( buf );
	}
void CLASS::fontmap(const char *xfontname, const char *printerfont,int ptsize) {
        sprintf(buf,"set hush::fontmap(%s) {%s %d}",xfontname,printerfont,ptsize);
        tk->evaluate(buf);
}


int CLASS::itemdirect(int i, const char *s, binding* ac, const char* args) {
	sprintf(buf,"%s bind %d %s { %s %s }", thepath(),i,s,ac->name(),args);
	return tk->eval( buf );
	}

int CLASS::itemdirect(const char* i, const char *s, binding* ac, const char* args) {
	sprintf(buf,"%s bind %s %s { %s %s }", thepath(),i,s,ac->name(),args);
	return tk->eval( buf );
	}


int CLASS::coordsystem() const { 
  return _cs; 
}

void CLASS::coordsystem(int cs) { 
  _cs = cs; 
}

int CLASS::convertx(int x) const { 
  return (_cs==window_coords)?canvasx(x):x;
}

int CLASS::converty(int y) const { 
  return (_cs==window_coords)?canvasy(y):y;
}

