#include <hush/source.h>

#include <hush/widgets/tk/citem.h>

#include <hush/hush.h>
#include <hush/kit.h>
#include <hush/sys/bind.h>

#include <hush/widgets/tk/canvas.h>

#include <stdio.h>
#include <math.h>

c_item::c_item() : item() {
	n = 0; c = 0; tk = thekit(); 
	}

c_item::c_item(int i, class canvas* x) : item() {
	n = i; c = x; tk = thekit();
	}

// sneaky:

c_item::c_item(int i, const char* x) : item() {
	n = i; c = new class canvas(x,0);
	tk = thekit();
	}


c_item::~c_item() {
	}

int c_item::no() const { return n; }
char* c_item::id() const { return ""; }

char* c_item::name() const { 
	char* _name = handler::name();
	if (!_name) {
		const int width = 5 + (n ? (int) log10((double)n) : 0);
		_name = new char[ width+1 ];
		sprintf(_name, "item%d", n);
		((item*)this)->rename(_name);
		delete[] _name;
		return handler::name();
	}
	return _name;
}

void c_item::move(int x, int y) { c->move(n,x,y); }
void c_item::del() { c->del(n); }
void c_item::tag(const char* s) { c->tag(n,s); }
char* c_item::tags() const { return c->tags(n); }
char* c_item::coords() const { return c->coords(n); }
char* c_item::bbox() const { return c->bbox(n); }
void c_item::configure(const char* s) { c->itemconfigure(n,s); }

int c_item::bind(const char* s, dvbinding* a, const char* args) {
	return direct(s,a,args);
	}

int c_item::bind(const char *s, handler* h, const char* args) {
	binding* ac = tk->bind(h);
	return direct(s,ac,args);
	}

int c_item::bind(handler* h, const char* args  ) {
	binding* ac = tk->bind(h);
	install(ac,args);
	return 0;
	}

void c_item::install(binding* ac, const char* args ) {
	bind("<Any-ButtonPress>",ac, args);
	bind("<Any-ButtonRelease>",ac, args);
	bind("<Any-Motion>",ac, args );
	bind("<Enter>",ac, args );
	bind("<Leave>",ac, args );
	}

int c_item::direct(const char*s, binding* ac, const char* args) {
	return c->itembind(n,s,ac,args);
	}
