#include <hush/source.h>

#include <hush/hush.h>
#include <hush/widgets/frame.h>
#include <hush/widgets/tk/glxwin.h>
#include <string.h>
#include <stdio.h>
#include <iostream.h>


#define TYPE glxwin
#define CLASS tk_glxwin
#include "hush/widgets/tk/create.i"

void CLASS::geometry(int x, int y) {
	sprintf(buf,"%s configure -width %d -height %d",thepath(),x,y);
	tk->eval( buf );
	}

void CLASS::configure(const char* s) { 
	sprintf(buf,"%s configure %s",thepath(),s);
	tk->eval( buf );
	}

void CLASS::draw() { }
void CLASS::redraw() { }

void CLASS::link() { 
	sprintf(buf,"%s link",thepath());
	//cerr << buf << endl;
	tk->eval( buf );
	}

void CLASS::swap() { 
	sprintf(buf,"%s swap",thepath());
	//cerr << buf << endl;
	tk->eval( buf );
	}

void CLASS::init(const char* options) {

widget* top = new frame( path() );
_register(top);
widget* glx = new widget(top,"glx");

sprintf(buf,"tkglxwin %s %s", glx->path(), options);
tk->eval( buf );

glx->pack("-fill both -expand true"); // don t forget to pack

redirect( glx ); // not superfluous !

alias( this );
}


int CLASS::operator()(){ /// (II)
	int argc = _event->argc(); char** argv = _event->argv();
        if (!strcmp("self",argv[1]) ) tk->result(self()->path());
        else if ( !strcmp( "CLASS" ,*argv) )
					  create(--argc,++argv); 
        else self()->eval( flatten(--argc,++argv) );
        return 0;
	}

void CLASS::create(int argc, char* argv[]) { /// (III)
        char* name = *argv;
        widget* w = new CLASS(name, flatten(--argc,++argv));
	_register(w);
        }

void CLASS::install(binding* ac, const char* args) {
        self()->bind("<Any-ButtonPress>",ac, args);
        self()->bind("<Any-ButtonRelease>",ac, args);
        self()->bind("<Any-Motion>",ac, args );
        self()->bind("<Enter>",ac, args );
        self()->bind("<Leave>",ac, args );
        }

