// Used on Windows 95/NT to redirect stdin/out to console
//
// jrvosse: why hdrstop?
// #pragma hdrstop
//
// jrvosse: why extern C?
// extern "C" void ShowMessage(const char* buffer);

#ifdef WIN32

#include <hush/source.h>
#include <tcl.h>
#include <string.h>
#include <widgets/win-redirect.h>

// typedef void* messageproc( const char* buffer);

infostreambuf::infostreambuf(void* x) :
_interp(x?x:(void*)Tcl_CreateInterp)
{
    buffer = new char[bufsize=30];
    textlen=0;
}

infostreambuf::~infostreambuf()
{
    flush();
    delete[] buffer;
}


infostreambuf& infostreambuf::flush( )
{
    if (textlen==0)
        return *this;
    buffer[textlen]=0;
    
	Tcl_Interp* interp = (Tcl_Interp*) _interp;
    Tcl_Channel outChannel = Tcl_GetStdChannel(TCL_STDOUT);
	Tcl_Write(outChannel, (char*) buffer, strlen(buffer));
	textlen=0;
	return *this;
}

int infostreambuf::overflow( int c )
{
    switch (c)
    {
        case '\r' : break;  // do nothing
        case '\t' : do
                        overflow(' ');
                    while (textlen%4 >0);
                    break;
        default:
        {
            if (textlen>=bufsize-2)
            {
                bufsize+=50;
                char* newbuf = new char[bufsize];
                memcpy(newbuf,buffer,textlen);
                delete[] buffer;
                buffer = newbuf;
            }
            buffer[textlen++]=c;
			flush();
        }
    }
    return 1;
}

#endif
