
float4 color = { 0.5f, 0.5f, 3.0f, 0.5f };	
float factor;
float time;

texture tex;

float4x4 wvp;	// World * View * Projection matrix



sampler tex_sampler = sampler_state
{
    texture = <tex>;    
};


struct vsinput {
    float4 pos : POSITION; 
    float3 normal : NORMAL; 
    float2 uv : TEXCOORD0;
};

struct vsoutput {
    float4 pos   : POSITION;   // vertex pos 
    float4 color    : COLOR0;     // vertex diffuse color
    float2 uv  : TEXCOORD0;  // vertex texture coords 
};

vsoutput vs_id( vsinput vx ) {
    vsoutput vs;
    float xfactor = factor * 2.0 * 4.0;
    //vs.pos = mul(vx.pos, wvp);
    //float4 screen = float4(vx.pos.x,vx.pos.y,2.0,2.0);
    float4 screen = float4(xfactor * vx.pos.y, xfactor * vx.pos.x,4.0,4.0);
    vs.color = color;
    vs.color.r = sin(time);
    //vs.uv.uv = vx.uv.vu; 
    vs.uv = vx.uv;
    //vs.pos = float4(
	//0.5 * (1.0 + screen.x/screen.w) + (0.5 * 1024),
	//0.5 * (1.0 + screen.y/screen.w) + (0.5 * 756),
	//0.0,
	//1.0
	//);
    vs.pos = screen;      
    
    return vs;    
}


struct psoutput
{
    float4 color : COLOR0;  
};


psoutput ps_id( vsoutput vs ) 
{ 
    psoutput ps;
    float4 white = (1,1,1,1);
    float4 black = (0,0,0,1);
    float4 x = tex2D(tex_sampler, vs.uv);
    
    
    float c = (x.r + x.g + x.b) / 3.0;
    if (c > 0.5) x = white;
    else x = black;
    if (c > 0.5) c = 1.0;
    if (c < 0.2) c = 0;
    x.r = c;
    x.g = c;
    x.b = c;

    ps.color = x;
      //*  vs.color;

    return ps;
}



technique render_id
{
    pass P0
    {          
        VertexShader = compile vs_1_1 vs_id();
        PixelShader  = compile ps_2_0 ps_id(); 
    }
}
