
float4 color = { 0.5f, 0.5f, 3.0f, 0.5f };	
float factor;
float time;

texture tex;

float4x4 wvp;	// World * View * Projection matrix



sampler tex_sampler = sampler_state
{
    texture = <tex>;    
};


struct vsinput {
    float4 pos : POSITION; 
    float3 normal : NORMAL; 
    float2 uv : TEXCOORD0;
};

struct vsoutput {
    float4 pos   : POSITION;   // vertex pos 
    float4 color    : COLOR0;     // vertex diffuse color
    float2 uv  : TEXCOORD0;  // vertex texture coords 
};

vsoutput vs_id( vsinput vx ) {
    vsoutput vs;
    float xf = 1.0;
    float xfactor = factor * 2.0 * xf;
    vs.pos = mul(vx.pos, wvp);
    //float4 screen = float4(xfactor * vx.pos.y, xfactor * vx.pos.x,xf,xf);
    vs.color = color;
    //vs.color.r = sin(time);
    vs.uv = vx.uv;
    //vs.pos = screen;      
    
    return vs;    
}


struct psoutput
{
    float4 color : COLOR0;  
};


psoutput ps_id( vsoutput vs ) 
{ 
    psoutput ps;
    
    float4 x = tex2D(tex_sampler, vs.uv);
    //if (x.r > xd) x.r = 1.0;
    //if (x.g > xd) x.g = 1.0;
    //if (x.b > xd) x.b = 1.0;
    //if (x.r < xl) x.r = 0.0;
    //if (x.g < xl) x.g = 0.0;
    //if (x.b < xl) x.b = 0.0;
    

    ps.color = x;

    return ps;
}



technique render_id
{
    pass P0
    {          
        //VertexShader = compile vs_1_1 vs_id();
        PixelShader  = compile ps_2_0 ps_id(); 
    }
}
