
float4 color = { 1.0f, 1.0f, 1.0f, 1.0f };	

texture tex;
float	 time;
float factor = 0.4;

float4x4 wvp;	// World * View * Projection matrix
float4x4 view;
float4x4 vp;


sampler tex_sampler = sampler_state
{
    texture = <tex>;    
};

float lerpMin = -1.00;
float lerpMax = 1.00;
float speed = 0.11;


struct vsinput {
    float4 position : POSITION; 
    float3 normal : NORMAL; 
    float2 uv : TEXCOORD0;
};

//struct VS_OUTPUT {
  // float4 Pos:     POSITION;
  // float3 normal:  TEXCOORD0;
  // float3 viewVec: TEXCOORD1;
  // float4 base:    TEXCOORD2;
//};

struct vsoutput {
    float4 position   : POSITION;   // vertex position 
    float4 color    : COLOR0;     // vertex diffuse color
    float2 uv  : TEXCOORD0;  // vertex texture coords 
    float3 normal:  TEXCOORD1;
    float3 viewVec: TEXCOORD2;
    float4 base:    TEXCOORD3;
};

vsoutput vs_morph( vsinput vx ) {
    vsoutput vs;
  
    //vs.position = mul(vx.position, world);
    vs.color = color;
    vs.uv = vx.uv; 
    vs.normal = vx.normal;
    vs.viewVec = vx.normal;
    vs.base = color;
    vs.color.r = sin(3.0 * time/5.0);
    vs.color.b = cos(time/3.0 * 2.0 );
    vs.color.g = 0.5f;
    vs.color.a = 1.0f;
    vx.position.y = -vx.position.y;
    
    //return vs;
     // Define the two key frames
   float3 spherePos = normalize(vx.position.xyz);
   float3 cubePos = 0.9 * vx.position.xyz;

   float3 sphereNormal = spherePos;
   float3 cubeNormal = vx.normal;

   // Make a smooth 0->1->0 curve
  float t = frac(speed * time);
  t = smoothstep(0, 0.5, t) - smoothstep(0.5, 1, t);

   // Find the interpolation factor
  float lrp = lerpMin + (lerpMax - lerpMin) * t;

   // Linearly interpolate the position and normal
 vx.position.xyz = lerp(spherePos, cubePos, lrp);
 vx.normal = lerp(sphereNormal, cubeNormal, lrp);

   // Use position as base color
  vs.base = 0.5 + 0.5 * vx.position;
   // Give the thing some size
  vx.position.xyz *= 0.5 * factor; //0.4;// 30;

  vs.position = mul(wvp, vx.position);
   // Eye-space lighting
  vs.normal = mul(view, vx.normal);
  vs.viewVec = -mul(view, vx.position);
    
  return vs;    
}


struct psoutput
{
    float4 color : COLOR0;  
};


psoutput ps_morph( vsoutput vs ) 
{ 
    psoutput ps;

    //ps.color = tex2D(tex_sampler, vs.uv);// * vs.color;
    
    
    
    
    //return ps;
    
    
   float4 lightDir = ( 0.41, 0.41, -0.82, 1.00 );


    vs.normal = normalize(vs.normal);

   // Soft diffuse
   float diffuse = 0.5 + 0.5 * dot(lightDir, vs.normal);
   // Standard specular
   float specular = pow(saturate(dot(reflect(-normalize(vs.viewVec), vs.normal), lightDir)), 24);

   //ps.color = ps.color * diffuse * vs.base; // + specular;

   ps.color = tex2D(tex_sampler, vs.uv); // * vs.color;// + diffuse * vs.base; // + specular; //;// * vs.color;

  return ps;
}



technique render_morph
{
    pass P0
    {          
        VertexShader = compile vs_1_1 vs_morph();
        PixelShader  = compile ps_2_0 ps_morph(); 
    }
}
