float4x4 wvp;
texture tex;

//float4 clr = { 1.0, 0, 1.0, 1 };

sampler tex_sampler = sampler_state {
	texture = <tex>;
};



struct vsinput {
  float4 position : POSITION;
  float3 normal : NORMAL;
  float2 uv : TEXCOORD0; 
};

struct vsoutput {
  float4 position : POSITION;
  float4 color    : COLOR0;
  float2 uv : TEXCOORD0; 
};

struct psoutput {
  float4 color : COLOR0;
};

vsoutput vs_id( //vsinput in)
	float4 position : POSITION,
	float3 normal : NORMAL,
        float2 uv : TEXCOORD0)
{
  vsoutput vs;

  vs.position = mul(position, wvp);
  vs.color = float4(1,0,1,1);
  vs.uv = uv;

  return vs;	
}

psoutput ps_id(vsoutput vs)
{
  psoutput ps;
  ps.color = tex2D(tex_sampler,vs.uv);// * in.color;
  return ps;
}

technique render_id
{
pass P0
{
   VertexShader = compile vs_1_0 vs_id();
   PixelShader = compile ps_1_0 ps_id(); 
   }
}

