
float4 color = { 0.5f, 0.5f, 3.0f, 0.5f };	

texture tex;
float	 time;

float4x4 wvp;	// World * View * Projection matrix



sampler tex_sampler = sampler_state
{
    texture = <tex>;    
};


struct vsinput {
    float4 position : POSITION; 
    float3 normal : NORMAL; 
    float2 uv : TEXCOORD0;
};

struct vsoutput {
    float4 position   : POSITION;   // vertex position 
    float4 color    : COLOR0;     // vertex diffuse color
    float2 uv  : TEXCOORD0;  // vertex texture coords 
};

vsoutput vs_id( vsinput vx ) {
    vsoutput vs;
  
    vs.position = mul(vx.position, wvp);
    vs.color = color;
    vs.uv = vx.uv; 
    vs.color.r = sin(3.0 * time/5.0);
    vs.color.b = cos(time/3.0 * 2.0 );
    vs.color.g = 0.5f;
    vs.color.a = 1.0f;
    
    return vs;    
}


struct psoutput
{
    float4 color : COLOR0;  
};


psoutput ps_id( vsoutput vs ) 
{ 
    psoutput ps;

    ps.color = tex2D(tex_sampler, vs.uv) * vs.color;

    return ps;
}



technique render_id
{
    pass P0
    {          
        VertexShader = compile vs_1_1 vs_id();
        PixelShader  = compile ps_2_0 ps_id(); 
    }
}
