
float4 color = { 0.5f, 0.5f, 3.0f, 0.5f };	
float factor;
float time;
float xfac;
float yfac;
float zfac;

texture tex;
texture slides;
texture overlay;

float4x4 wvp;	// World * View * Projection matrix



sampler tex_sampler = sampler_state
{
    texture = <tex>;    
};
sampler slides_sampler = sampler_state
{
    texture = <slides>;    
};
sampler overlay_sampler = sampler_state
{
    texture = <overlay>;    
};


struct vsinput {
    float4 pos : POSITION; 
    float3 normal : NORMAL; 
    float2 uv : TEXCOORD0;
};

struct vsoutput {
    float4 pos   : POSITION;   // vertex pos 
    float4 color    : COLOR0;     // vertex diffuse color
    float2 uv  : TEXCOORD0;  // vertex texture coords 
};

vsoutput vs_id( vsinput vx ) {
    vsoutput vs;
    float xf = 1.0;
    float xfactor = factor * 2.0 * xf;
    vs.pos = mul(vx.pos, wvp);
    //float4 screen = float4(xfactor * vx.pos.y, xfactor * vx.pos.x,xf,xf);
    vs.color = color;
    //vs.color.r = sin(time);
    vs.uv = vx.uv;
    //vs.pos = screen;      
    
    return vs;    
}


struct psoutput
{
    float4 color : COLOR0;  
};


psoutput ps_id( vsoutput vs ) 
{ 
    psoutput ps;
    
    float xi = 1.1;
    float xd = 0.7;
    float xl = 0.2;
    float4 x = tex2D(tex_sampler, vs.uv);
    float4 y = tex2D(slides_sampler, vs.uv);
    float4 z = tex2D(overlay_sampler, vs.uv);
    if (0) {
    if (x.r > x.g && x.r > x.b) { x.r *= xi; x.g *= xd; x.b *= xd; }
    else  if (x.g > x.r && x.g > x.b) { x.g *= xi; x.r *= xd; x.b *= xd; }
    else  if (x.b > x.r && x.b > x.g) { x.b *= xi; x.r *= xd; x.g *= xd; }
    }
    float b = x.r + x.g + x.b;
    //if (x.r > xd) x.r = 1.0;
    //if (x.g > xd) x.g = 1.0;
    //if (x.b > xd) x.b = 1.0;
    //if (x.r < xl) x.r = 0.0;
    //if (x.g < xl) x.g = 0.0;
    //if (x.b < xl) x.b = 0.0;
    
    
    
    

  // ps.color = x*0.5 + 0.5*y;
   ps.color = x*xfac + y*yfac;
   //if (b < 1) ps.color = 0.5*y + 0.5*z;
   if (b < 1) ps.color = y*yfac + z*zfac;
    //ps.color.a = 0;
      //*  vs.color;

    return ps;
}



technique render_id
{
    pass P0
    {          
        //VertexShader = compile vs_1_1 vs_id();
        PixelShader  = compile ps_2_0 ps_id(); 
    }
}
