/*******************************************************
 *
 * Author: Hirokazu Kato, Atsishi Nakazawa
 *
 *         kato@sys.im.hiroshima-cu.ac.jp
 *         nakazawa@inolab.sys.es.osaka-u.ac.jp
 *
 * Revision: 4.2
 * Date: 2000/04/23
 *
*******************************************************/
#ifndef AR_VIDEO_H
#define AR_VIDEO_H
#ifdef  __cplusplus
extern "C" {
#endif

#ifdef __linux
#include <stdlib.h>
#include <linux/types.h>
#include <linux/videodev.h>
#endif
#ifdef __sgi
#include <AR/SGI/video2.h>
#endif
#include <AR/config.h>
#include <AR/ar.h>

int        arVideoOpen( char *config );
int        arVideoClose( void );
int        arVideoDispOption( void );

int        arVideoInqSize( int *x, int *y );
ARUint8   *arVideoGetImage( void );

int        arVideoCapStart( void );
int        arVideoCapStop( void );
int        arVideoCapNext( void );



#ifndef _WIN32
typedef struct {
#ifdef __linux
    char     dev[256];
    int      width;
    int      height;
    int      channel;
    int      mode;
    int      debug;
    double   contrast;
    double   brightness;
    double   color;

    int                 fd;
    int                 video_cont_num;
    ARUint8             *map;
    struct video_mbuf   vm;
    struct video_mmap   vmm;
#endif
#ifdef __sgi
    int             did;
    int             width;
    int             height;
    ARVideoFormat   format;
    ARVideoPacking  packing;
    ARVideoZoom     zoom;
    int             buf_size;
#endif
} AR2VideoParamT;

int             ar2VideoDispOption ( void );
AR2VideoParamT *ar2VideoOpen       ( char *config );
int             ar2VideoClose      ( AR2VideoParamT *vid );
int             ar2VideoCapStart   ( AR2VideoParamT *vid );
int             ar2VideoCapNext    ( AR2VideoParamT *vid );
int             ar2VideoCapStop    ( AR2VideoParamT *vid );
ARUint8        *ar2VideoGetImage   ( AR2VideoParamT *vid );
int             ar2VideoInqSize    ( AR2VideoParamT *vid, int *x,int *y );
#endif

#ifdef  __cplusplus
}
#endif
#endif
