/* Copyright (c) 2001 by SoftIntegration, Inc. All Rights Reserved */
/* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF SoftIntegration  */
/* The copyright notice above does not evidence any    */
/* actual or intended publication of such source code. */


#ifndef _CHEMBEDDED_H
#define _CHEMBEDDED_H

#include <ch/extern/ch.h> 

#ifdef  __cplusplus
extern "C" {
#endif

/* Options invoked when Ch is embedded in an application */
typedef struct ChOptions{
   int shelltype;        /* shell type */
   int chrc;             /* CH_DEFAULTCHRC or CH_USERCHRC to execut startup file */
   char *chrcname;       /* Not NULL to execute user's startup script file */
   char *chhome;         /* Embedded Ch home directory. if NULL, use Ch home directory for 
                            standard/professional edition as Embedded Ch home directory */
} ChOptions_t;

/* shell type */
#define CH_REGULARCH       0
#define CH_SAFECH          1
/* mode for invoke chrc at startup */
#define CH_NOCHRC        0
#define CH_DEFAULTCHRC   1 
#define CH_USERCHRC      2 

/* Standard file descriptors used in 2nd arg in Ch_Reopen()  */
#define STDIN_FILENO    0       /* Standard input.  */
#define STDOUT_FILENO   1       /* Standard output.  */
#define STDERR_FILENO   2       /* Standard error output.  */

typedef int ChFile_t;     /* file descriptor for portable file stream redirection */

/* In addition to functions in ch.h, 
   these APIs are specifically for embedding Ch in applications */
extern int      Ch_Initialize(ChInterp_t * interp, ChOptions_t *option);
extern int      Ch_ParseScript(ChInterp_t interp, char **argv);
extern int      Ch_ExecScript(ChInterp_t interp, const char *progname);
extern int      Ch_RunScript(ChInterp_t interp, char **argv);
extern int      Ch_AppendParseScript(ChInterp_t interp, const char *code);
extern int      Ch_AppendParseScriptFile(ChInterp_t interp, const char *filename);
extern int      Ch_AppendRunScript(ChInterp_t interp, const char *code);
extern int      Ch_AppendRunScriptFile(ChInterp_t interp, const char *filename);
extern int      Ch_ExprCalc(ChInterp_t interp, const char *expr, int datatype, void *result);
extern int      Ch_ExprEval(ChInterp_t interp, const char *expr); /* obsolete, use Ch_ExprCalc(NULL, expr, CH_VOIDTYPE,  NULL); */
extern int      Ch_ExprParse(ChInterp_t interp, const char *expr);
extern int      Ch_Close(ChInterp_t interp, ChFile_t fildes);
extern ChFile_t Ch_Reopen(ChInterp_t interp, const char *filename, const char *mode, int fildes);
extern int      Ch_Flush(ChInterp_t interp, ChFile_t fildes);
extern int      Ch_End(ChInterp_t interp);

/* APIs to find infor about global variables in Ch */
extern int   Ch_DataType(ChInterp_t interp, const char *expr);
extern int   Ch_IsArray(ChInterp_t interp, const char *expr);
extern int   Ch_ArrayDim(ChInterp_t interp, const char *name);
extern int   Ch_ArrayExtent(ChInterp_t interp, const char *name, int index);
extern int   Ch_IsFunc(ChInterp_t interp, const char *name);
extern int   Ch_IsFuncVarArg(ChInterp_t interp, const char *name);
extern int   Ch_FuncArgNum(ChInterp_t interp, const char *name);
extern void *Ch_UserDefinedAddr(ChInterp_t interp, const char *name); 
extern char *Ch_UserDefinedName(ChInterp_t interp, const char *name); 
extern int   Ch_UserDefinedSize(ChInterp_t interp, const char *name); 
extern int   Ch_SymbolTotalNum(ChInterp_t interp);
extern int   Ch_SymbolNum(ChInterp_t interp, const char *name);
/* extern void *Ch_SymbolAddrByName(ChInterp_t interp, const char *name); in ch.h */
extern void *Ch_SymbolAddrByIndex(ChInterp_t interp, int index);
extern char *Ch_SymbolNameByIndex(ChInterp_t interp, int index);


/* APIs to find infor about function arguments of a function  
   for calling Ch functions from C/C++ binary space */
extern int   Ch_FuncArgDataType(ChInterp_t interp, const char *funcname, int argnum);
extern int   Ch_FuncArgIsArray(ChInterp_t interp, const char *funcname, int argnum); /* int [n], int [:], int &, int [&] */
extern int   Ch_FuncArgArrayDim(ChInterp_t interp, const char *funcname, int argnum);
extern int   Ch_FuncArgArrayExtent(ChInterp_t interp, const char *funcname, int argnum, int index);
extern int   Ch_FuncArgIsFunc(ChInterp_t interp, const char *funcname, int argnum);
extern int   Ch_FuncArgIsFuncVarArg(ChInterp_t interp, const char *funcname, int argnum);
extern int   Ch_FuncArgFuncArgNum(ChInterp_t interp, const char *funcname, int argnum);
extern char *Ch_FuncArgUserDefinedName(ChInterp_t interp, const char *funcname, int argnum);
extern int   Ch_FuncArgUserDefinedSize(ChInterp_t interp, const char *funcname, int argnum);

#ifdef  __cplusplus
}
#endif

#endif  /* _CHEMBEDDED_H */

