#ifndef _DVSETH
#define _DVSETH

#include <hush/list.h>
#include <hush/export.h>

template<class T>
class HUSH_API dvset : public dvslist<T> {
public:
  dvset() { insertion( unique ); }
  dvset(const dvset<T>& l): dvslist<T>(l) { }
  
  static T* unique( const T* e, const dvlist<T>& l) {
	  //cerr << "set:u:0" << endl;
	T* x = (l.contains(e))?(T*)0:(T*)e;
	//cerr << "set:u:1" << endl;
	return x;

  }
};

template<class T>
class HUSH_API dvoset : public dvset<T> {
public:
  dvoset() { mode( _ordered ); order( dvolist<T>::less ); }
  dvoset(const dvoset<T>& l): dvset<T>(l) { }
};

#ifndef set
#define set dvset
#endif

#ifndef oset
#define oset dvoset
#endif

#endif
